/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.18 from the
 * contents of Virt.xs. Do not edit this file, edit Virt.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Virt.xs"
/* -*- c -*-
 *
 * Copyright (C) 2006 Red Hat
 * Copyright (C) 2006-2007 Daniel P. Berrange
 *
 * This program is free software; You can redistribute it and/or modify
 * it under either:
 *
 * a) the GNU General Public License as published by the Free
 *   Software Foundation; either version 2, or (at your option) any
 *   later version,
 *
 * or
 *
 * b) the "Artistic License"
 *
 * The file "LICENSE" distributed along with this file provides full
 * details of the terms and conditions of the two licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <libvirt/virterror.h>
#include <libvirt/libvirt.h>

/*
 * On 32-bit OS (and some 64-bit) Perl does not have an
 * integer type capable of storing 64 bit numbers. So
 * we serialize to/from strings on these platforms
 */

static long long
virt_SvIVll(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoll(SvPV_nolen(sv), NULL, 10);
#endif
}


static unsigned long long
virt_SvIVull(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoull(SvPV_nolen(sv), NULL, 10);
#endif
}


#ifndef PRId64
#define PRId64 "lld"
#endif


static SV *
virt_newSVll(long long val) {
#ifdef USE_64_BIT_ALL
    return newSViv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRId64, val);
    return newSVpv(buf, len);
#endif
}


#ifndef PRIu64
#define PRIu64 "llu"
#endif

static SV *
virt_newSVull(unsigned long long val) {
#ifdef USE_64_BIT_ALL
    return newSVuv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRIu64, val);
    return newSVpv(buf, len);
#endif
}



static void
ignoreVirErrorFunc(void * userData, virErrorPtr error) {
  /* Do nothing */
}


static SV *
_sv_from_error(virErrorPtr error)
{
    HV *hv;

    hv = newHV ();

    /* Map virErrorPtr attributes to hash keys */
    (void)hv_store (hv, "level", 5, newSViv (error ? error->level : 0), 0);
    (void)hv_store (hv, "code", 4, newSViv (error ? error->code : 0), 0);
    (void)hv_store (hv, "domain", 6, newSViv (error ? error->domain : VIR_FROM_NONE), 0);
    (void)hv_store (hv, "message", 7, newSVpv (error && error->message ? error->message : "Unknown problem", 0), 0);

    return sv_bless (newRV_noinc ((SV*) hv), gv_stashpv ("Sys::Virt::Error", TRUE));
}


static void
_croak_error(void)
{
    virErrorPtr error = virGetLastError();
    sv_setsv(ERRSV, _sv_from_error (error));

    /* croak does not return, so we free this now to avoid leaking */
    virResetError(error);

    croak (Nullch);
}


static void
_populate_constant(HV *stash, const char *name, int val)
{
    SV *valsv;

    valsv = newSViv(0);
    sv_setuv(valsv,val);
    newCONSTSUB(stash, name, valsv);
}


static void
_populate_constant_str(HV *stash, const char *name, const char *value)
{
    SV *valsv;

    valsv = newSVpv(value, strlen(value));
    newCONSTSUB(stash, name, valsv);
}


static void
_populate_constant_ull(HV *stash, const char *name, unsigned long long val)
{
    SV *valsv;

    valsv = virt_newSVull(val);
    newCONSTSUB(stash, name, valsv);
}


#define REGISTER_CONSTANT(name, key) _populate_constant(stash, #key, name)
#define REGISTER_CONSTANT_STR(name, key) _populate_constant_str(stash, #key, name)
#define REGISTER_CONSTANT_ULL(name, key) _populate_constant_ull(stash, #key, name)

static int
_domain_event_lifecycle_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 int event,
                                 int detail,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_generic_callback(virConnectPtr con,
                               virDomainPtr dom,
                               void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_rtcchange_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 long long utcoffset,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(virt_newSVll(utcoffset)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_watchdog_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int action,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(action)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_io_error_callback(virConnectPtr con,
                                virDomainPtr dom,
                                const char *srcPath,
                                const char *devAlias,
                                int action,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(srcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(action)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_disk_change_callback(virConnectPtr con,
                                   virDomainPtr dom,
                                   const char *oldSrcPath,
                                   const char *newSrcPath,
                                   const char *devAlias,
                                   int reason,
                                   void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(oldSrcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(newSrcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_tray_change_callback(virConnectPtr con,
                                   virDomainPtr dom,
                                   const char *devAlias,
                                   int reason,
                                   void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_pmwakeup_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int reason,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_pmsuspend_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 int reason,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_pmsuspend_disk_callback(virConnectPtr con,
                                      virDomainPtr dom,
                                      int reason,
                                      void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_io_error_reason_callback(virConnectPtr con,
                                       virDomainPtr dom,
                                       const char *srcPath,
                                       const char *devAlias,
                                       int action,
                                       const char *reason,
                                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(srcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(action)));
    XPUSHs(sv_2mortal(newSVpv(reason, 0)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_graphics_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int phase,
                                virDomainEventGraphicsAddressPtr local,
                                virDomainEventGraphicsAddressPtr remote,
                                const char *authScheme,
                                virDomainEventGraphicsSubjectPtr subject,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    HV *local_hv;
    HV *remote_hv;
    AV *subject_av;
    int i;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    local_hv = newHV();
    (void)hv_store(local_hv, "family", 6, newSViv(local->family), 0);
    (void)hv_store(local_hv, "node", 4, newSVpv(local->node, 0), 0);
    (void)hv_store(local_hv, "service", 7, newSVpv(local->service, 0), 0);

    remote_hv = newHV();
    (void)hv_store(remote_hv, "family", 6, newSViv(remote->family), 0);
    (void)hv_store(remote_hv, "node", 4, newSVpv(remote->node, 0), 0);
    (void)hv_store(remote_hv, "service", 7, newSVpv(remote->service, 0), 0);

    subject_av = newAV();
    for (i = 0 ; i < subject->nidentity ; i++) {
        HV *identity = newHV();
        (void)hv_store(identity, "type", 4, newSVpv(subject->identities[i].type, 0), 0);
        (void)hv_store(identity, "name", 4, newSVpv(subject->identities[i].name, 0), 0);

        av_push(subject_av, newRV_noinc((SV *)identity));
    }

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(phase)));
    XPUSHs(newRV_noinc((SV*)local_hv));
    XPUSHs(newRV_noinc((SV*)remote_hv));
    XPUSHs(sv_2mortal(newSVpv(authScheme, 0)));
    XPUSHs(newRV_noinc((SV*)subject_av));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_block_job_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 const char *path,
                                 int type,
                                 int status,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(path, 0)));
    XPUSHs(sv_2mortal(newSViv(type)));
    XPUSHs(sv_2mortal(newSViv(status)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_balloonchange_callback(virConnectPtr con,
                                     virDomainPtr dom,
                                     unsigned long long actual,
                                     void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(virt_newSVull(actual)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_domain_event_device_removed_callback(virConnectPtr con,
                                      virDomainPtr dom,
                                      const char *devAlias,
                                      void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static void
_domain_event_free(void *opaque)
{
  SV *sv = opaque;
  SvREFCNT_dec(sv);
}


static void
_close_callback(virConnectPtr con,
                int reason,
                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;
}


static void
_close_callback_free(void *opaque)
{
  SV *sv = opaque;
  SvREFCNT_dec(sv);
}


static int
_event_add_handle(int fd,
		  int events,
		  virEventHandleCallback cb,
		  void *opaque,
		  virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int watch = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref= sv_newmortal();
    opaqueref= sv_newmortal();
    ffref= sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(fd)));
    XPUSHs(sv_2mortal(newSViv(events)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_handle", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
      watch = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
      return -1;

    return watch;
}


static void
_event_update_handle(int watch,
		     int events)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_handle", G_DISCARD);

    FREETMPS;
    LEAVE;
}


static int
_event_remove_handle(int watch)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_handle", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
    return 0;
}


static int
_event_add_timeout(int interval,
		   virEventTimeoutCallback cb,
		   void *opaque,
		   virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int timer = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref = sv_newmortal();
    opaqueref = sv_newmortal();
    ffref = sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(interval)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_timeout", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
      timer = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
      return -1;

    return timer;
}


static void
_event_update_timeout(int timer,
		      int interval)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    XPUSHs(sv_2mortal(newSViv(interval)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;
}


static int
_event_remove_timeout(int timer)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_open_auth_callback(virConnectCredentialPtr cred,
		    unsigned int ncred,
		    void *cbdata)
{
  dSP;
  int i, ret, success = -1;
  AV *credlist;

  credlist = newAV();

  ENTER;
  SAVETMPS;
  PUSHMARK(SP);

  for (i = 0 ; i < ncred ; i++) {
      HV *credrec = newHV();

      (void)hv_store(credrec, "type", 4, newSViv(cred[i].type), 0);
      (void)hv_store(credrec, "prompt", 6, newSVpv(cred[i].prompt, 0), 0);
      (void)hv_store(credrec, "challenge", 9, newSVpv(cred[i].challenge, 0), 0);
      if (cred[i].defresult != NULL)
          (void)hv_store(credrec, "result", 6, newSVpv(cred[i].defresult, 0), 0);
      else
          (void)hv_fetch(credrec, "result", 6, 1);

      av_push(credlist, newRV_noinc((SV *)credrec));
  }
  SvREFCNT_inc((SV*)credlist);

  XPUSHs(newRV_noinc((SV*)credlist));
  PUTBACK;

  ret = call_sv((SV*)cbdata, G_SCALAR);

  SPAGAIN;

  if (ret == 1)
     success = POPi;

  for (i = 0 ; i < ncred ; i++) {
      SV **credsv = av_fetch(credlist, i, 0);
      HV *credrec = (HV*)SvRV(*credsv);
      SV **val = hv_fetch(credrec, "result", 6, 0);

      if (val && SvOK(*val)) {
	  STRLEN len;
	  char *result = SvPV(*val, len);
	  if (!(cred[i].result = malloc(len+1)))
	      abort();
	  memcpy(cred[i].result, result, len+1);
	  cred[i].resultlen = (unsigned int)len;
      } else {
	  cred[i].resultlen = 0;
	  cred[i].result = NULL;
      }
  }

  FREETMPS;
  LEAVE;

  return success;
}


static void
_event_handle_helper(int watch,
                     int fd,
                     int events,
                     void *opaque)
{
    SV *cb = opaque;
    dSP;

    SvREFCNT_inc(cb);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    XPUSHs(sv_2mortal(newSViv(fd)));
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_sv(cb, G_DISCARD);

    FREETMPS;
    LEAVE;
}


static void
_event_timeout_helper(int timer,
                      void *opaque)
{
    SV *cb = opaque;
    dSP;

    SvREFCNT_inc(cb);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    PUTBACK;

    call_sv(cb, G_DISCARD);

    FREETMPS;
    LEAVE;
}


static void
_event_cb_free(void *opaque)
{
    SV *data = opaque;
    SvREFCNT_dec(data);
}


static void
_stream_event_callback(virStreamPtr st,
                       int events,
                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;
}


static void
_stream_event_free(void *opaque)
{
    AV *data = opaque;
    SvREFCNT_dec(data);
}


static int
_stream_send_all_source(virStreamPtr st,
                        char *data,
                        size_t nbytes,
                        void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **handler;
    SV *datasv;
    int rv;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    handler = av_fetch(av, 1, 0);
    datasv = newSVpv("", 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(datasv);
    XPUSHs(sv_2mortal(newSViv(nbytes)));
    PUTBACK;

    rv = call_sv((SV*)*handler, G_SCALAR);

    SPAGAIN;

    if (rv == 1) {
        ret = POPi;
    } else {
        ret = -1;
    }

    if (ret > 0) {
        const char *newdata = SvPV_nolen(datasv);
        if (ret > nbytes)
            ret = nbytes;
        strncpy(data, newdata, nbytes);
    }

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(datasv);

    return ret;
}


static int
_stream_recv_all_sink(virStreamPtr st,
                      const char *data,
                      size_t nbytes,
                      void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **handler;
    SV *datasv;
    int rv;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    handler = av_fetch(av, 1, 0);
    datasv = newSVpv(data, nbytes);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(datasv);
    XPUSHs(sv_2mortal(newSViv(nbytes)));
    PUTBACK;

    rv = call_sv((SV*)*handler, G_SCALAR);

    SPAGAIN;

    if (rv == 1) {
        ret = POPi;
    } else {
        ret = -1;
    }

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(datasv);

    return ret;
}


static HV *
vir_typed_param_to_hv(virTypedParameter *params, int nparams)
{
    HV *ret = (HV *)sv_2mortal((SV*)newHV());
    unsigned int i;
    const char *field;
    STRLEN val_length;

    for (i = 0 ; i < nparams ; i++) {
        SV *val = NULL;

        switch (params[i].type) {
        case VIR_TYPED_PARAM_INT:
            val = newSViv(params[i].value.i);
            break;

        case VIR_TYPED_PARAM_UINT:
            val = newSViv((int)params[i].value.ui);
            break;

        case VIR_TYPED_PARAM_LLONG:
            val = virt_newSVll(params[i].value.l);
            break;

        case VIR_TYPED_PARAM_ULLONG:
            val = virt_newSVull(params[i].value.ul);
            break;

        case VIR_TYPED_PARAM_DOUBLE:
            val = newSVnv(params[i].value.d);
            break;

        case VIR_TYPED_PARAM_BOOLEAN:
            val = newSViv(params[i].value.b);
            break;

        case VIR_TYPED_PARAM_STRING:
            val_length = strlen(params[i].value.s);
            val = newSVpv(params[i].value.s, val_length);
            break;

        }

        field = params[i].field;
        (void)hv_store(ret, field, strlen(params[i].field), val, 0);
    }

    return ret;
}


static int
vir_typed_param_from_hv(HV *newparams, virTypedParameter *params, int nparams)
{
    unsigned int i;
    char * ptr;
    STRLEN len;

    /* We only want to set parameters which we're actually changing
     * so here we figure out which elements of 'params' we need to
     * update, and overwrite the others
     */
    for (i = 0 ; i < nparams ;) {
        if (!hv_exists(newparams, params[i].field, strlen(params[i].field))) {
            if ((nparams-i) > 1)
                memmove(params+i, params+i+1, sizeof(*params)*(nparams-(i+1)));
            nparams--;
            continue;
        }

        i++;
    }

    for (i = 0 ; i < nparams ; i++) {
        SV **val;

        val = hv_fetch (newparams, params[i].field, strlen(params[i].field), 0);

        switch (params[i].type) {
        case VIR_TYPED_PARAM_INT:
            params[i].value.i = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_UINT:
            params[i].value.ui = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_LLONG:
            params[i].value.l = virt_SvIVll(*val);
            break;

        case VIR_TYPED_PARAM_ULLONG:
            params[i].value.ul = virt_SvIVull(*val);
            break;

        case VIR_TYPED_PARAM_DOUBLE:
            params[i].value.d = SvNV(*val);
            break;

        case VIR_TYPED_PARAM_BOOLEAN:
            params[i].value.b = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_STRING:
            ptr = SvPV(*val, len);
            params[i].value.s = (char *)ptr;
            break;
        }
    }

    return nparams;
}


#line 1401 "Virt.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 1543 "Virt.c"

XS_EUPXS(XS_Sys__Virt__open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__open)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, flags");
    {
	SV *	name = ST(0)
;
	unsigned int	flags = (unsigned int)SvUV(ST(1))
;
#line 1400 "Virt.xs"
      const char *uri = NULL;
#line 1558 "Virt.c"
	virConnectPtr	RETVAL;
#line 1402 "Virt.xs"
      if (SvOK(name))
	  uri = SvPV_nolen(name);

      if (!(RETVAL = virConnectOpenAuth(uri, NULL, flags)))
          _croak_error();
#line 1566 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__open_auth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__open_auth)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "name, creds, cb, flags");
    {
	SV *	name = ST(0)
;
	SV *	creds = ST(1)
;
	SV *	cb = ST(2)
;
	unsigned int	flags = (unsigned int)SvUV(ST(3))
;
#line 1418 "Virt.xs"
      AV *credlist;
      virConnectAuth auth;
      int i;
      const char *uri = NULL;
#line 1594 "Virt.c"
	virConnectPtr	RETVAL;
#line 1423 "Virt.xs"
      if (SvOK(name))
	  uri = SvPV_nolen(name);

      if (SvOK(cb) && SvOK(creds)) {
	  memset(&auth, 0, sizeof auth);
	  credlist = (AV*)SvRV(creds);
	  auth.ncredtype = av_len(credlist) + 1;
	  Newx(auth.credtype, auth.ncredtype, int);
	  for (i = 0 ; i < auth.ncredtype ; i++) {
	    SV **type = av_fetch(credlist, i, 0);
	    auth.credtype[i] = SvIV(*type);
	  }

	  auth.cb = _open_auth_callback;
	  auth.cbdata = cb;
	  RETVAL = virConnectOpenAuth(uri,
				      &auth,
                                      flags);
	  Safefree(auth.credtype);
      } else {
	  RETVAL = virConnectOpenAuth(uri,
				      virConnectAuthPtrDefault,
                                      flags);
      }
      if (!RETVAL)
	_croak_error();
#line 1623 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_restore_domain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_restore_domain)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "con, from, dxmlsv=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	from = (const char *)SvPV_nolen(ST(1))
;
	SV *	dxmlsv;
	unsigned int	flags;
#line 1460 "Virt.xs"
      const char *dxml = NULL;
#line 1647 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::restore_domain() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    dxmlsv = &PL_sv_undef;
	else {
	    dxmlsv = ST(2)
;
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 1462 "Virt.xs"
      if (SvOK(dxmlsv))
	  dxml = SvPV_nolen(dxmlsv);

      if (dxml || flags) {
          if (virDomainRestoreFlags(con, from, dxml, flags) < 0)
              _croak_error();
      } else {
          if (virDomainRestore(con, from) < 0)
              _croak_error();
      }
#line 1681 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_save_image_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_save_image_xml_description)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, file, flags=0");
    {
	virConnectPtr	con;
	const char *	file = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 1480 "Virt.xs"
      char *xml;
#line 1701 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_save_image_xml_description() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 1482 "Virt.xs"
      if (!(xml = virDomainSaveImageGetXMLDesc(con, file, flags)))
	 _croak_error();
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 1723 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_define_save_image_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_define_save_image_xml)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, file, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	file = (const char *)SvPV_nolen(ST(1))
;
	const char *	xml = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::define_save_image_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 1497 "Virt.xs"
      if (virDomainSaveImageDefineXML(con, file, xml, flags) < 0)
          _croak_error();
#line 1764 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__get_library_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__get_library_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
#line 1505 "Virt.xs"
      unsigned long version;
#line 1780 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;
#line 1507 "Virt.xs"
      if (virGetVersion(&version, NULL, NULL) < 0)
          _croak_error();
      RETVAL = version;
#line 1787 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__get_conn_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__get_conn_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1518 "Virt.xs"
      unsigned long version;
#line 1804 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::_get_conn_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1520 "Virt.xs"
      if (virConnectGetVersion(con, &version) < 0)
          _croak_error();
      RETVAL = version;
#line 1819 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__get_conn_library_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__get_conn_library_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1531 "Virt.xs"
      unsigned long version;
#line 1836 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::_get_conn_library_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1533 "Virt.xs"
      if (virConnectGetLibVersion(con, &version) < 0)
          _croak_error();
      RETVAL = version;
#line 1851 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_is_encrypted); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_is_encrypted)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::is_encrypted() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1544 "Virt.xs"
      if ((RETVAL = virConnectIsEncrypted(conn)) < 0)
          _croak_error();
#line 1879 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_is_secure); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_is_secure)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::is_secure() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1554 "Virt.xs"
      if ((RETVAL = virConnectIsSecure(conn)) < 0)
          _croak_error();
#line 1907 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_is_alive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_is_alive)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::is_alive() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1564 "Virt.xs"
      if ((RETVAL = virConnectIsAlive(conn)) < 0)
          _croak_error();
#line 1935 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_set_keep_alive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_set_keep_alive)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "conn, interval, count");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	int	interval = (int)SvIV(ST(1))
;
	unsigned int	count = (unsigned int)SvUV(ST(2))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::set_keep_alive() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1576 "Virt.xs"
      if (virConnectSetKeepAlive(conn, interval, count) < 0)
          _croak_error();
#line 1967 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_type() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1584 "Virt.xs"
      RETVAL = virConnectGetType(con);
#line 1994 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_uri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_uri)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_uri() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1593 "Virt.xs"
      RETVAL = virConnectGetURI(con);
#line 2021 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_sysinfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_sysinfo)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    {
	virConnectPtr	con;
	unsigned int	flags;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_sysinfo() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 1603 "Virt.xs"
      RETVAL = virConnectGetSysinfo(con, flags);
#line 2056 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1612 "Virt.xs"
      virNodeInfo info;
#line 2073 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_info() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1614 "Virt.xs"
      if (virNodeGetInfo(con, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "model", 5, newSVpv(info.model, 0), 0);
      (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      (void)hv_store (RETVAL, "cpus", 4, newSViv(info.cpus), 0);
      (void)hv_store (RETVAL, "mhz", 3, newSViv(info.mhz), 0);
      (void)hv_store (RETVAL, "nodes", 5, newSViv(info.nodes), 0);
      (void)hv_store (RETVAL, "sockets", 7, newSViv(info.sockets), 0);
      (void)hv_store (RETVAL, "cores", 5, newSViv(info.cores), 0);
      (void)hv_store (RETVAL, "threads", 7, newSViv(info.threads), 0);
#line 2096 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_security_model); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_security_model)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1634 "Virt.xs"
      virSecurityModel secmodel;
#line 2114 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_security_model() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1636 "Virt.xs"
      if (virNodeGetSecurityModel(con, &secmodel) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "model", 5, newSVpv(secmodel.model, 0), 0);
      (void)hv_store (RETVAL, "doi", 3, newSVpv(secmodel.doi, 0), 0);
#line 2131 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_cpu_map); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_cpu_map)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 1650 "Virt.xs"
      unsigned char *cpumaps;
      unsigned int online;
      int ncpus;
#line 2154 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_cpu_map() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 1654 "Virt.xs"
      if ((ncpus = virNodeGetCPUMap(con, &cpumaps, &online, flags)) < 0)
          _croak_error();

      EXTEND(SP, 3);
      PUSHs(sv_2mortal(newSViv(ncpus)));
      PUSHs(sv_2mortal(newSVpvn((char*)cpumaps, VIR_CPU_MAPLEN(ncpus))));
      PUSHs(sv_2mortal(newSViv(online)));
      free(cpumaps);
#line 2179 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_node_free_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_free_memory)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1667 "Virt.xs"
      unsigned long long mem;
#line 2196 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1669 "Virt.xs"
      if ((mem = virNodeGetFreeMemory(con)) == 0)
          _croak_error();

      RETVAL = virt_newSVull(mem);
#line 2211 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_cells_free_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_cells_free_memory)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "con, start, end");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	start = (int)SvIV(ST(1))
;
	int	end = (int)SvIV(ST(2))
;
#line 1683 "Virt.xs"
      unsigned long long *mem;
      int i, num;
#line 2236 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_cells_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1686 "Virt.xs"
      Newx(mem, end-start, unsigned long long);
      if ((num = virNodeGetCellsFreeMemory(con, mem, start, end)) < 0) {
          Safefree(mem);
          _croak_error();
      }
      EXTEND(SP, num);
      for (i = 0 ; i < num ; i++) {
	SV *val = newSViv(mem[i]);
	PUSHs(sv_2mortal(val));
      }
      Safefree(mem);
#line 2257 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_node_cpu_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_cpu_stats)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "con, cpuNum=VIR_NODE_CPU_STATS_ALL_CPUS, flags=0");
    {
	virConnectPtr	con;
	int	cpuNum;
	unsigned int	flags;
#line 1705 "Virt.xs"
      virNodeCPUStatsPtr params;
      int nparams = 0;
      int i;
#line 2278 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_cpu_stats() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    cpuNum = VIR_NODE_CPU_STATS_ALL_CPUS;
	else {
	    cpuNum = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 1709 "Virt.xs"
      if (virNodeGetCPUStats(con, cpuNum, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virNodeCPUStats);
      if (virNodeGetCPUStats(con, cpuNum, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      for (i = 0 ; i < nparams ; i++) {
          if (strcmp(params[i].field, VIR_NODE_CPU_STATS_KERNEL) == 0) {
              (void)hv_store (RETVAL, "kernel", 6, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_USER) == 0) {
              (void)hv_store (RETVAL, "user", 4, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_IDLE) == 0) {
              (void)hv_store (RETVAL, "idle", 4, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_IOWAIT) == 0) {
              (void)hv_store (RETVAL, "iowait", 6, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_UTILIZATION) == 0) {
              (void)hv_store (RETVAL, "utilization", 11, virt_newSVull(params[i].value), 0);
          }
      }
      Safefree(params);
#line 2326 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_memory_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_memory_stats)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "con, cellNum=VIR_NODE_MEMORY_STATS_ALL_CELLS, flags=0");
    {
	virConnectPtr	con;
	int	cellNum;
	unsigned int	flags;
#line 1742 "Virt.xs"
      virNodeMemoryStatsPtr params;
      int nparams = 0;
      int i;
#line 2348 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_memory_stats() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    cellNum = VIR_NODE_MEMORY_STATS_ALL_CELLS;
	else {
	    cellNum = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 1746 "Virt.xs"
      if (virNodeGetMemoryStats(con, cellNum, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virNodeMemoryStats);
      if (virNodeGetMemoryStats(con, cellNum, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      for (i = 0 ; i < nparams ; i++) {
          if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_TOTAL) == 0) {
              (void)hv_store (RETVAL, "total", 5, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_FREE) == 0) {
              (void)hv_store (RETVAL, "free", 4, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_BUFFERS) == 0) {
              (void)hv_store (RETVAL, "buffers", 7, virt_newSVull(params[i].value), 0);
          } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_CACHED) == 0) {
              (void)hv_store (RETVAL, "cached", 6, virt_newSVull(params[i].value), 0);
          }
      }
      Safefree(params);
#line 2394 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_memory_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    {
	virConnectPtr	conn;
	unsigned int	flags;
#line 1776 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 2414 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_memory_parameters() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 1779 "Virt.xs"
      nparams = 0;
      if (virNodeGetMemoryParameters(conn, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);

      if (virNodeGetMemoryParameters(conn, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 2445 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_set_node_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_set_node_memory_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "conn, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	HV *	newparams;
	unsigned int	flags;
#line 1802 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 2468 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::set_node_memory_parameters() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::set_node_memory_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 1805 "Virt.xs"
      nparams = 0;
      if (virNodeGetMemoryParameters(conn, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);

      if (virNodeGetMemoryParameters(conn, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      nparams = vir_typed_param_from_hv(newparams, params, nparams);

      if (virNodeSetMemoryParameters(conn, params, nparams, flags) < 0)
          _croak_error();
      Safefree(params);
#line 2515 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_node_suspend_for_duration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_node_suspend_for_duration)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "conn, target, duration, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	target = (unsigned int)SvUV(ST(1))
;
	SV *	duration = ST(2)
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::node_suspend_for_duration() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 1831 "Virt.xs"
      if (virNodeSuspendForDuration(conn, target, virt_SvIVull(duration), flags) < 0)
          _croak_error();
#line 2555 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_find_storage_pool_sources); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_find_storage_pool_sources)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, type, srcspec, flags=0");
    {
	virConnectPtr	con;
	const char *	type = (const char *)SvPV_nolen(ST(1))
;
	const char *	srcspec = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::find_storage_pool_sources() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 1842 "Virt.xs"
      if ((RETVAL = virConnectFindStoragePoolSources(con, type, srcspec, flags)) == NULL)
          _croak_error();
#line 2595 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_capabilities); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_capabilities)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1852 "Virt.xs"
      char *xml;
#line 2612 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_capabilities() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1854 "Virt.xs"
      if (!(xml = virConnectGetCapabilities(con)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 2628 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_compare_cpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_compare_cpu)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	char *	xml = (char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 1869 "Virt.xs"
      int rc;
#line 2649 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::compare_cpu() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 1871 "Virt.xs"
      if ((rc = virConnectCompareCPU(con, xml, flags)) < 0)
          _croak_error();

      RETVAL = newSViv(rc);
#line 2671 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_baseline_cpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_baseline_cpu)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	SV *	xml = ST(1)
;
	unsigned int	flags;
#line 1885 "Virt.xs"
      AV *xmllist;
      const char **xmlstr;
      int xmllen;
      int i;
      char *retxml;
#line 2696 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::baseline_cpu() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 1891 "Virt.xs"
      xmllist = (AV*)SvRV(xml);
      xmllen = av_len(xmllist) + 1;
      Newx(xmlstr, xmllen, const char *);
      for (i = 0 ; i < xmllen ; i++) {
          SV **doc = av_fetch(xmllist, i, 0);
          xmlstr[i] = SvPV_nolen(*doc);
      }

      if (!(retxml = virConnectBaselineCPU(con, xmlstr, xmllen, flags))) {
          Safefree(xmlstr);
          _croak_error();
      }

      Safefree(xmlstr);
      RETVAL = newSVpv(retxml, 0);
      free(retxml);
#line 2730 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_max_vcpus)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, type");
    {
	virConnectPtr	con;
	char *	type = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_max_vcpus() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1916 "Virt.xs"
      if ((RETVAL = virConnectGetMaxVcpus(con, type)) < 0)
          _croak_error();
#line 2761 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_hostname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 1926 "Virt.xs"
      char *host;
#line 2778 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_hostname() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1928 "Virt.xs"
      if (!(host = virConnectGetHostname(con)))
          _croak_error();

      RETVAL = newSVpv(host, 0);
      free(host);
#line 2794 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_num_of_domains); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_domains)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1941 "Virt.xs"
      if ((RETVAL = virConnectNumOfDomains(con)) < 0)
	_croak_error();
#line 2823 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_domain_ids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_domain_ids)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxids");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxids = (int)SvIV(ST(1))
;
#line 1952 "Virt.xs"
      int *ids;
      int i, nid;
#line 2845 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_domain_ids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1955 "Virt.xs"
      Newx(ids, maxids, int);
      if ((nid = virConnectListDomains(con, ids, maxids)) < 0) {
          Safefree(ids);
          _croak_error();
      }
      EXTEND(SP, nid);
      for (i = 0 ; i < nid ; i++) {
          PUSHs(sv_2mortal(newSViv(ids[i])));
      }
      Safefree(ids);
#line 2865 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_defined_domains); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_defined_domains)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_defined_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1971 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedDomains(con)) < 0)
          _croak_error();
#line 2893 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_defined_domain_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_defined_domain_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 1982 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 2916 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_defined_domain_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 1986 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedDomains(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 2937 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_domains); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_domains)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 2004 "Virt.xs"
      virDomainPtr *doms;
      int i, ndom;
      SV *domrv;
#line 2959 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2008 "Virt.xs"
      if ((ndom = virConnectListAllDomains(con, &doms, flags)) < 0)
          _croak_error();

      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
          domrv = sv_newmortal();
          sv_setref_pv(domrv, "Sys::Virt::Domain", doms[i]);
          PUSHs(domrv);
      }
      free(doms);
#line 2986 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_interfaces); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_interfaces)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 2025 "Virt.xs"
      virInterfacePtr *ifaces;
      int i, niface;
      SV *ifacerv;
#line 3008 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2029 "Virt.xs"
      if ((niface = virConnectListAllInterfaces(con, &ifaces, flags)) < 0)
          _croak_error();

      EXTEND(SP, niface);
      for (i = 0 ; i < niface ; i++) {
          ifacerv = sv_newmortal();
          sv_setref_pv(ifacerv, "Sys::Virt::Interface", ifaces[i]);
          PUSHs(ifacerv);
      }
      free(ifaces);
#line 3035 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_nwfilters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_nwfilters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 2046 "Virt.xs"
      virNWFilterPtr *nwfilters;
      int i, nnwfilter;
      SV *nwfilterrv;
#line 3057 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_nwfilters() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2050 "Virt.xs"
      if ((nnwfilter = virConnectListAllNWFilters(con, &nwfilters, flags)) < 0)
          _croak_error();

      EXTEND(SP, nnwfilter);
      for (i = 0 ; i < nnwfilter ; i++) {
          nwfilterrv = sv_newmortal();
          sv_setref_pv(nwfilterrv, "Sys::Virt::NWFilter", nwfilters[i]);
          PUSHs(nwfilterrv);
      }
      free(nwfilters);
#line 3084 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_networks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_networks)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 2067 "Virt.xs"
      virNetworkPtr *nets;
      int i, nnet;
      SV *netrv;
#line 3106 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2071 "Virt.xs"
      if ((nnet = virConnectListAllNetworks(con, &nets, flags)) < 0)
          _croak_error();

      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          netrv = sv_newmortal();
          sv_setref_pv(netrv, "Sys::Virt::Network", nets[i]);
          PUSHs(netrv);
      }
      free(nets);
#line 3133 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_node_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_node_devices)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 2088 "Virt.xs"
      virNodeDevicePtr *devs;
      int i, ndev;
      SV *devrv;
#line 3155 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_node_devices() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2092 "Virt.xs"
      if ((ndev = virConnectListAllNodeDevices(con, &devs, flags)) < 0)
          _croak_error();

      EXTEND(SP, ndev);
      for (i = 0 ; i < ndev ; i++) {
          devrv = sv_newmortal();
          sv_setref_pv(devrv, "Sys::Virt::NodeDevice", devs[i]);
          PUSHs(devrv);
      }
      free(devs);
#line 3182 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_secrets); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_secrets)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 2109 "Virt.xs"
      virSecretPtr *secrets;
      int i, nsecret;
      SV *secretrv;
#line 3204 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_secrets() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2113 "Virt.xs"
      if ((nsecret = virConnectListAllSecrets(con, &secrets, flags)) < 0)
          _croak_error();

      EXTEND(SP, nsecret);
      for (i = 0 ; i < nsecret ; i++) {
          secretrv = sv_newmortal();
          sv_setref_pv(secretrv, "Sys::Virt::Secret", secrets[i]);
          PUSHs(secretrv);
      }
      free(secrets);
#line 3231 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_storage_pools)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 2130 "Virt.xs"
      virStoragePoolPtr *pools;
      int i, npool;
      SV *poolrv;
#line 3253 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2134 "Virt.xs"
      if ((npool = virConnectListAllStoragePools(con, &pools, flags)) < 0)
          _croak_error();

      EXTEND(SP, npool);
      for (i = 0 ; i < npool ; i++) {
          poolrv = sv_newmortal();
          sv_setref_pv(poolrv, "Sys::Virt::StoragePool", pools[i]);
          PUSHs(poolrv);
      }
      free(pools);
#line 3280 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_networks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_networks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2150 "Virt.xs"
      if ((RETVAL = virConnectNumOfNetworks(con)) < 0)
          _croak_error();
#line 3308 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_network_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_network_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 2161 "Virt.xs"
      char **names;
      int i, nnet;
#line 3330 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2164 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListNetworks(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3351 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_defined_networks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_defined_networks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_defined_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2181 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedNetworks(con)) < 0)
          _croak_error();
#line 3379 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_defined_network_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_defined_network_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 2192 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 3402 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_defined_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2196 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedNetworks(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3423 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_storage_pools)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2213 "Virt.xs"
      if ((RETVAL = virConnectNumOfStoragePools(con)) < 0)
          _croak_error();
#line 3451 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_storage_pool_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 2224 "Virt.xs"
      char **names;
      int i, nnet;
#line 3473 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2227 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListStoragePools(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3494 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_defined_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_defined_storage_pools)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_defined_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2244 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedStoragePools(con)) < 0)
          _croak_error();
#line 3522 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_defined_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_defined_storage_pool_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 2254 "Virt.xs"
      char **names;
      int ndom;
      int i;
#line 3545 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_defined_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2258 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((ndom = virConnectListDefinedStoragePools(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, ndom);
      for (i = 0 ; i < ndom ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3566 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_node_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_node_devices)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, cap, flags=0");
    {
	virConnectPtr	con;
	SV *	cap = ST(1)
;
	int	flags;
#line 2277 "Virt.xs"
      const char *capname = NULL;
#line 3586 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_node_devices() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 2279 "Virt.xs"
      if (SvOK(cap))
	  capname = SvPV_nolen(cap);
      if ((RETVAL = virNodeNumOfDevices(con, capname, flags)) < 0)
          _croak_error();
#line 3609 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_node_device_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_node_device_names)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, cap, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	SV *	cap = ST(1)
;
	int	maxnames = (int)SvIV(ST(2))
;
	int	flags;
#line 2294 "Virt.xs"
      char **names;
      int i, nnet;
      const char *capname = NULL;
#line 3635 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_node_device_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}
#line 2298 "Virt.xs"
      if (SvOK(cap))
	  capname = SvPV_nolen(cap);
      Newx(names, maxnames, char *);
      if ((nnet = virNodeListDevices(con, capname, names, maxnames, flags)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3665 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_interfaces); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_interfaces)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2317 "Virt.xs"
      if ((RETVAL = virConnectNumOfInterfaces(con)) < 0)
          _croak_error();
#line 3693 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_interface_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_interface_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 2328 "Virt.xs"
      char **names;
      int i, nnet;
#line 3715 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_interface_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2331 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListInterfaces(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3736 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_defined_interfaces); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_defined_interfaces)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_defined_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2348 "Virt.xs"
      if ((RETVAL = virConnectNumOfDefinedInterfaces(con)) < 0)
          _croak_error();
#line 3764 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_defined_interface_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_defined_interface_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 2359 "Virt.xs"
      char **names;
      int i, nnet;
#line 3786 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_defined_interface_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2362 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListDefinedInterfaces(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3807 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_secrets); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_secrets)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_secrets() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2379 "Virt.xs"
      if ((RETVAL = virConnectNumOfSecrets(con)) < 0)
          _croak_error();
#line 3835 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_secret_uuids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_secret_uuids)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxuuids");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxuuids = (int)SvIV(ST(1))
;
#line 2390 "Virt.xs"
      char **uuids;
      int i, nsecret;
#line 3857 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_secret_uuids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2393 "Virt.xs"
      Newx(uuids, maxuuids, char *);
      if ((nsecret = virConnectListSecrets(con, uuids, maxuuids)) < 0) {
          Safefree(uuids);
          _croak_error();
      }
      EXTEND(SP, nsecret);
      for (i = 0 ; i < nsecret ; i++) {
          PUSHs(sv_2mortal(newSVpv(uuids[i], 0)));
          free(uuids[i]);
      }
      Safefree(uuids);
#line 3878 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_nwfilters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_nwfilters)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_nwfilters() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2410 "Virt.xs"
      if ((RETVAL = virConnectNumOfNWFilters(con)) < 0)
          _croak_error();
#line 3906 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_nwfilter_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_nwfilter_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 2421 "Virt.xs"
      char **names;
      int i, nnet;
#line 3928 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_nwfilter_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2424 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virConnectListNWFilters(con, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 3949 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_domain_xml_from_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_xml_from_native)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, configtype, configdata, flags=0");
    {
	virConnectPtr	con;
	const char *	configtype = (const char *)SvPV_nolen(ST(1))
;
	const char *	configdata = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;
#line 2444 "Virt.xs"
      char *xmldata;
#line 3971 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::domain_xml_from_native() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 2446 "Virt.xs"
      if (!(xmldata = virConnectDomainXMLFromNative(con, configtype, configdata, flags)))
          _croak_error();

      RETVAL = newSVpv(xmldata, 0);
      free(xmldata);
#line 3994 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_domain_xml_to_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_xml_to_native)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, configtype, xmldata, flags=0");
    {
	virConnectPtr	con;
	const char *	configtype = (const char *)SvPV_nolen(ST(1))
;
	const char *	xmldata = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;
#line 2462 "Virt.xs"
      char *configdata;
#line 4017 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::domain_xml_to_native() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 2464 "Virt.xs"
      if (!(configdata = virConnectDomainXMLToNative(con, configtype, xmldata, flags)))
          _croak_error();

      RETVAL = newSVpv(configdata, 0);
      free(configdata);
#line 4040 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_domain_event_register); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_event_register)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "conref, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	conref = ST(0)
;
	SV*	cb = ST(1)
;
#line 2478 "Virt.xs"
      AV *opaque;
      virConnectPtr con;
#line 4064 "Virt.c"
#line 2481 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(conref));
      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(conref);
      av_push(opaque, conref);
      av_push(opaque, cb);
      if (virConnectDomainEventRegister(con, _domain_event_lifecycle_callback,
                                        opaque, _domain_event_free) < 0)
          _croak_error();
#line 4075 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_domain_event_deregister); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_event_deregister)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::domain_event_deregister() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2496 "Virt.xs"
      virConnectDomainEventDeregister(con, _domain_event_lifecycle_callback);
#line 4102 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_domain_event_register_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_event_register_any)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "conref, domref, eventID, cb");
    {
	SV*	conref = ST(0)
;
	SV*	domref = ST(1)
;
	int	eventID = (int)SvIV(ST(2))
;
	SV*	cb = ST(3)
;
#line 2506 "Virt.xs"
      AV *opaque;
      virConnectPtr con;
      virDomainPtr dom;
      virConnectDomainEventGenericCallback callback;
#line 4129 "Virt.c"
	int	RETVAL;
	dXSTARG;
#line 2511 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(conref));
      if (SvROK(domref)) {
          dom = (virDomainPtr)SvIV((SV*)SvRV(domref));
      } else {
          dom = NULL;
      }

      switch (eventID) {
      case VIR_DOMAIN_EVENT_ID_LIFECYCLE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_lifecycle_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_REBOOT:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_RTC_CHANGE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_rtcchange_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_WATCHDOG:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_watchdog_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_IO_ERROR:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_io_error_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_IO_ERROR_REASON:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_io_error_reason_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_GRAPHICS:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_graphics_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_CONTROL_ERROR:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_BLOCK_JOB:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_block_job_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_DISK_CHANGE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_disk_change_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_TRAY_CHANGE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_tray_change_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_PMSUSPEND:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_pmsuspend_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_PMSUSPEND_DISK:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_pmsuspend_disk_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_PMWAKEUP:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_pmwakeup_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_BALLOON_CHANGE:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_balloonchange_callback);
          break;
      case VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_device_removed_callback);
          break;
      default:
          callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
          break;
      }

      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(conref);
      av_push(opaque, conref);
      av_push(opaque, cb);
      if ((RETVAL = virConnectDomainEventRegisterAny(con, dom, eventID, callback, opaque, _domain_event_free)) < 0)
          _croak_error();
#line 4201 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_domain_event_deregister_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_event_deregister_any)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, callbackID");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	callbackID = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::domain_event_deregister_any() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2588 "Virt.xs"
      virConnectDomainEventDeregisterAny(con, callbackID);
#line 4230 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_register_close_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_register_close_callback)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "conref, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	conref = ST(0)
;
	SV*	cb = ST(1)
;
#line 2596 "Virt.xs"
      AV *opaque;
      virConnectPtr con;
#line 4253 "Virt.c"
#line 2599 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(conref));
      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(conref);
      av_push(opaque, conref);
      av_push(opaque, cb);
      if (virConnectRegisterCloseCallback(con, _close_callback,
                                          opaque, _close_callback_free) < 0)
          _croak_error();
#line 4264 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_unregister_close_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_unregister_close_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::unregister_close_callback() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2614 "Virt.xs"
      virConnectUnregisterCloseCallback(con, _close_callback);
#line 4291 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_interface_change_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_interface_change_begin)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::interface_change_begin() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2622 "Virt.xs"
      if (virInterfaceChangeBegin(conn, flags) < 0)
          _croak_error();
#line 4327 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_interface_change_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_interface_change_commit)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::interface_change_commit() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2631 "Virt.xs"
      if (virInterfaceChangeCommit(conn, flags) < 0)
          _croak_error();
#line 4363 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_interface_change_rollback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_interface_change_rollback)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::interface_change_rollback() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2640 "Virt.xs"
      if (virInterfaceChangeRollback(conn, flags) < 0)
          _croak_error();
#line 4399 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	con_rv = ST(0)
;
#line 2648 "Virt.xs"
      virConnectPtr con;
#line 4419 "Virt.c"
#line 2650 "Virt.xs"
      con = (virConnectPtr)SvIV((SV*)SvRV(con_rv));
      if (con) {
	virConnectClose(con);
	sv_setiv((SV*)SvRV(con_rv), 0);
      }
#line 4426 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain__create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__create)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_create() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 2666 "Virt.xs"
      if (flags) {
          if (!(RETVAL = virDomainCreateXML(con, xml, flags)))
              _croak_error();
      } else {
          if (!(RETVAL = virDomainCreateLinux(con, xml, 0)))
              _croak_error();
      }
#line 4468 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__create_with_files); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__create_with_files)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, xml, fdssv, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	SV *	fdssv = ST(2)
;
	unsigned int	flags;
#line 2684 "Virt.xs"
      AV *fdsav;
      unsigned int nfds;
      int *fds;
      int i;
#line 4494 "Virt.c"
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_create_with_files() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 2689 "Virt.xs"
      if (!SvROK(fdssv))
          return;
      fdsav = (AV*)SvRV(fdssv);
      nfds = av_len(fdsav) + 1;
      Newx(fds, nfds, int);

      for (i = 0 ; i < nfds ; i++) {
          SV **fd = av_fetch(fdsav, i, 0);
          fds[i] = SvIV(*fd);
      }

      if (!(RETVAL = virDomainCreateXMLWithFiles(con, xml, nfds, fds, flags))) {
          Safefree(fds);
          _croak_error();
      }

      Safefree(fds);
#line 4529 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__define_xml)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2715 "Virt.xs"
      if (!(RETVAL = virDomainDefineXML(con, xml)))
          _croak_error();
#line 4559 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_id)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, id");
    {
	virConnectPtr	con;
	int	id = (int)SvIV(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_id() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2726 "Virt.xs"
      if (!(RETVAL = virDomainLookupByID(con, id)))
          _croak_error();
#line 4589 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2737 "Virt.xs"
      if (!(RETVAL = virDomainLookupByName(con, name)))
          _croak_error();
#line 4619 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2748 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUID(con, uuid)))
          _croak_error();
#line 4649 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2759 "Virt.xs"
      if (!(RETVAL = virDomainLookupByUUIDString(con, uuid)))
          _croak_error();
#line 4679 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_id() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2769 "Virt.xs"
      RETVAL = virDomainGetID(dom);
#line 4707 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2778 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 4724 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_uuid() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2780 "Virt.xs"
      if ((virDomainGetUUID(dom, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 4739 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2792 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 4757 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_uuid_string() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2794 "Virt.xs"
      if ((virDomainGetUUIDString(dom, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 4772 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2806 "Virt.xs"
      if (!(RETVAL = virDomainGetName(dom)))
          _croak_error();
#line 4801 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_hostname)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_hostname() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2817 "Virt.xs"
      if (!(RETVAL = virDomainGetHostname(dom, flags)))
          _croak_error();
#line 4837 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_metadata)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "dom, type, uri=&PL_sv_undef, flags=0");
    {
	virDomainPtr	dom;
	int	type = (int)SvIV(ST(1))
;
	SV *	uri;
	unsigned int	flags;
#line 2830 "Virt.xs"
      const char *uristr = NULL;
#line 4858 "Virt.c"
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_metadata() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(2)
;
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 2832 "Virt.xs"
      if (SvOK(uri))
	  uristr = SvPV_nolen(uri);

      if (!(RETVAL = virDomainGetMetadata(dom, type, uristr, flags)))
          _croak_error();
#line 4889 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_metadata)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 6)
       croak_xs_usage(cv,  "dom, type, metadata=&PL_sv_undef, key=&PL_sv_undef, uri=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	type = (int)SvIV(ST(1))
;
	SV *	metadata;
	SV *	key;
	SV *	uri;
	unsigned int	flags;
#line 2850 "Virt.xs"
      const char *metadatastr = NULL;
      const char *keystr = NULL;
      const char *uristr = NULL;
#line 4916 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_metadata() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    metadata = &PL_sv_undef;
	else {
	    metadata = ST(2)
;
	}

	if (items < 4)
	    key = &PL_sv_undef;
	else {
	    key = ST(3)
;
	}

	if (items < 5)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(4)
;
	}

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(5))
;
	}
#line 2854 "Virt.xs"
      if (SvOK(metadata))
	  metadatastr = SvPV_nolen(metadata);
      if (SvOK(key))
	  keystr = SvPV_nolen(key);
      if (SvOK(uri))
	  uristr = SvPV_nolen(uri);

      if (virDomainSetMetadata(dom, type, metadatastr, keystr, uristr, flags) < 0)
          _croak_error();
#line 4963 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::is_active() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2870 "Virt.xs"
      if ((RETVAL = virDomainIsActive(dom)) < 0)
          _croak_error();
#line 4991 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_is_persistent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::is_persistent() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2880 "Virt.xs"
      if ((RETVAL = virDomainIsPersistent(dom)) < 0)
          _croak_error();
#line 5019 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_is_updated); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_is_updated)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::is_updated() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2890 "Virt.xs"
      if ((RETVAL = virDomainIsUpdated(dom)) < 0)
          _croak_error();
#line 5047 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_suspend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_suspend)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::suspend() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2900 "Virt.xs"
      if ((virDomainSuspend(dom)) < 0)
          _croak_error();
#line 5075 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_resume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::resume() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2908 "Virt.xs"
      if ((virDomainResume(dom)) < 0)
          _croak_error();
#line 5103 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pm_wakeup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pm_wakeup)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pm_wakeup() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2917 "Virt.xs"
      if ((virDomainPMWakeup(dom, flags)) < 0)
          _croak_error();
#line 5139 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_save)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "dom, to, dxmlsv=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1))
;
	SV *	dxmlsv;
	unsigned int	flags;
#line 2928 "Virt.xs"
      const char *dxml = NULL;
#line 5162 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    dxmlsv = &PL_sv_undef;
	else {
	    dxmlsv = ST(2)
;
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 2930 "Virt.xs"
      if (SvOK(dxmlsv))
	  dxml = SvPV_nolen(dxmlsv);

      if (dxml || flags) {
          if ((virDomainSaveFlags(dom, to, dxml, flags)) < 0)
              _croak_error();
      } else {
          if ((virDomainSave(dom, to)) < 0)
              _croak_error();
      }
#line 5196 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_managed_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_managed_save)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::managed_save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2947 "Virt.xs"
      if ((virDomainManagedSave(dom, flags)) < 0)
          _croak_error();
#line 5232 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_has_managed_save_image); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_has_managed_save_image)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::has_managed_save_image() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2956 "Virt.xs"
      if ((RETVAL = virDomainHasManagedSaveImage(dom, flags)) < 0)
          _croak_error();
#line 5268 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_managed_save_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_managed_save_remove)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::managed_save_remove() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2967 "Virt.xs"
      if ((virDomainManagedSaveRemove(dom, flags)) < 0)
          _croak_error();
#line 5304 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_core_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_core_dump)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, to, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::core_dump() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 2977 "Virt.xs"
      if (virDomainCoreDump(dom, to, flags) < 0)
          _croak_error();
#line 5342 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 2985 "Virt.xs"
      virDomainInfo info;
#line 5359 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2987 "Virt.xs"
      if (virDomainGetInfo(dom, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "maxMem", 6, newSViv(info.maxMem), 0);
      (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
      (void)hv_store (RETVAL, "nrVirtCpu", 9, newSViv(info.nrVirtCpu), 0);
      (void)hv_store (RETVAL, "cpuTime", 7, virt_newSVull(info.cpuTime), 0);
#line 5379 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_control_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_control_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3005 "Virt.xs"
      virDomainControlInfo info;
#line 5398 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_control_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3007 "Virt.xs"
      if (virDomainGetControlInfo(dom, &info, flags) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "details", 7, newSViv(info.details), 0);
      (void)hv_store (RETVAL, "stateTime", 9, virt_newSVull(info.stateTime), 0);
#line 5423 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_state); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_state)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3023 "Virt.xs"
      int state;
      int reason;
#line 5445 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_state() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3026 "Virt.xs"
      if (virDomainGetState(dom, &state, &reason, flags) < 0)
          _croak_error();

      XPUSHs(sv_2mortal(newSViv(state)));
      XPUSHs(sv_2mortal(newSViv(reason)));
#line 5467 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_open_console); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_open_console)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, st, devname, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	virStreamPtr	st;
	SV *	devname = ST(2)
;
	unsigned int	flags;
#line 3040 "Virt.xs"
      const char *devnamestr = NULL;
#line 5490 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::open_console() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::Domain::open_console() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3042 "Virt.xs"
      if (SvOK(devname))
          devnamestr = SvPV_nolen(devname);

      if (virDomainOpenConsole(dom, devnamestr, st, flags) < 0)
          _croak_error();
#line 5520 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_open_channel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_open_channel)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, st, devname, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	virStreamPtr	st;
	SV *	devname = ST(2)
;
	unsigned int	flags;
#line 3056 "Virt.xs"
      const char *devnamestr = NULL;
#line 5543 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::open_channel() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::Domain::open_channel() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3058 "Virt.xs"
      if (SvOK(devname))
          devnamestr = SvPV_nolen(devname);

      if (virDomainOpenChannel(dom, devnamestr, st, flags) < 0)
          _croak_error();
#line 5573 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_open_graphics); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_open_graphics)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, idx, fd, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	idx = (unsigned int)SvUV(ST(1))
;
	int	fd = (int)SvIV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::open_graphics() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3072 "Virt.xs"
      if (virDomainOpenGraphics(dom, idx, fd, flags) < 0)
          _croak_error();
#line 5613 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_screenshot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_screenshot)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, st, screen, flags=0");
    {
	virDomainPtr	dom;
	virStreamPtr	st;
	unsigned int	screen = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;
#line 3083 "Virt.xs"
      char *mimetype;
#line 5634 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::screenshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::Domain::screenshot() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3085 "Virt.xs"
      if (!(mimetype = virDomainScreenshot(dom, st, screen, flags)))
          _croak_error();
      RETVAL = newSVpv(mimetype, 0);
      free(mimetype);
#line 5664 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_block_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_block_info)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, dev, flags=0");
    {
	virDomainPtr	dom;
	const char *	dev = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 3099 "Virt.xs"
      virDomainBlockInfo info;
#line 5685 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_block_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3101 "Virt.xs"
      if (virDomainGetBlockInfo(dom, dev, &info, flags) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
      (void)hv_store (RETVAL, "physical", 8, virt_newSVull(info.physical), 0);
#line 5710 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_job_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_job_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 3116 "Virt.xs"
      virDomainJobInfo info;
#line 5728 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_job_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3118 "Virt.xs"
      if (virDomainGetJobInfo(dom, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
      (void)hv_store (RETVAL, "timeElapsed", 11, virt_newSVull(info.timeElapsed), 0);
      (void)hv_store (RETVAL, "timeRemaining", 13, virt_newSVull(info.timeRemaining), 0);
      (void)hv_store (RETVAL, "dataTotal", 9, virt_newSVull(info.dataTotal), 0);
      (void)hv_store (RETVAL, "dataProcessed", 13, virt_newSVull(info.dataProcessed), 0);
      (void)hv_store (RETVAL, "dataRemaining", 13, virt_newSVull(info.dataRemaining), 0);
      (void)hv_store (RETVAL, "memTotal", 8, virt_newSVull(info.memTotal), 0);
      (void)hv_store (RETVAL, "memProcessed", 12, virt_newSVull(info.memProcessed), 0);
      (void)hv_store (RETVAL, "memRemaining", 12, virt_newSVull(info.memRemaining), 0);
      (void)hv_store (RETVAL, "fileTotal", 9, virt_newSVull(info.fileTotal), 0);
      (void)hv_store (RETVAL, "fileProcessed", 13, virt_newSVull(info.fileProcessed), 0);
      (void)hv_store (RETVAL, "fileRemaining", 13, virt_newSVull(info.fileRemaining), 0);
#line 5755 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_job_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_job_stats)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3143 "Virt.xs"
      int type;
      virTypedParameter *params;
      int nparams;
      HV *paramsHv;
      SV *typeSv;
#line 5780 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_job_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3149 "Virt.xs"
      if (virDomainGetJobStats(dom, &type, &params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      typeSv = newSViv(type);
      paramsHv = vir_typed_param_to_hv(params, nparams);
      Safefree(params);

      EXTEND(SP, 2);
      PUSHs(newRV_noinc((SV*)typeSv));
      PUSHs(newRV_noinc((SV*)paramsHv));
#line 5809 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_abort_job); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_abort_job)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::abort_job() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3167 "Virt.xs"
      if (virDomainAbortJob(dom) < 0)
          _croak_error();
#line 5837 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_abort_block_job); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_abort_block_job)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::abort_block_job() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3177 "Virt.xs"
      if (virDomainBlockJobAbort(dom, path, flags) < 0)
          _croak_error();
#line 5875 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_block_job_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_block_job_info)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 3187 "Virt.xs"
      virDomainBlockJobInfo info;
#line 5895 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_block_job_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3189 "Virt.xs"
      if (virDomainGetBlockJobInfo(dom, path, &info, flags) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
      (void)hv_store (RETVAL, "bandwidth", 9, virt_newSVull(info.bandwidth), 0);
      (void)hv_store (RETVAL, "cur", 3, virt_newSVull(info.cur), 0);
      (void)hv_store (RETVAL, "end", 3, virt_newSVull(info.end), 0);
#line 5921 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_block_job_speed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_block_job_speed)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, path, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_block_job_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3208 "Virt.xs"
      if (virDomainBlockJobSetSpeed(dom, path, bandwidth, flags) < 0)
          _croak_error();
#line 5962 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_pull); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_pull)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, path, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_pull() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3219 "Virt.xs"
      if (virDomainBlockPull(dom, path, bandwidth, flags) < 0)
          _croak_error();
#line 6002 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_rebase); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_rebase)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, path, base, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	const char *	base = (const char *)SvPV_nolen(ST(2))
;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(3))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_rebase() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 3231 "Virt.xs"
      if (virDomainBlockRebase(dom, path, base, bandwidth, flags) < 0)
          _croak_error();
#line 6044 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_commit)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "dom, path, base, top, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	const char *	base = (const char *)SvPV_nolen(ST(2))
;
	const char *	top = (const char *)SvPV_nolen(ST(3))
;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(4))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_commit() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(5))
;
	}
#line 3244 "Virt.xs"
      if (virDomainBlockCommit(dom, path, base, top, bandwidth, flags) < 0)
          _croak_error();
#line 6088 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_disk_errors); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_disk_errors)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3253 "Virt.xs"
      virDomainDiskErrorPtr errors;
      unsigned int maxerrors;
      int ret;
      int i;
#line 6111 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_disk_errors() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3258 "Virt.xs"
      if ((ret = virDomainGetDiskErrors(dom, NULL, 0, 0)) < 0)
          _croak_error();
      maxerrors = ret;
      Newx(errors, maxerrors, virDomainDiskError);
      if ((ret = virDomainGetDiskErrors(dom, errors, maxerrors, flags)) < 0) {
          Safefree(errors);
          _croak_error();
      }
      EXTEND(SP, ret);
      for (i = 0 ; i < ret ; i++) {
          HV *rec = newHV();
          (void)hv_store(rec, "path", 4, newSVpv(errors[i].disk, 0), 0);
          (void)hv_store(rec, "error", 5, newSViv(errors[i].error), 0);
          PUSHs(newRV_noinc((SV *)rec));
      }

      Safefree(errors);
#line 6145 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_scheduler_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3282 "Virt.xs"
      virTypedParameter *params;
      int nparams;
      char *type;
#line 6165 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3286 "Virt.xs"
      if (!(type = virDomainGetSchedulerType(dom, &nparams)))
          _croak_error();

      free(type);
      Newx(params, nparams, virTypedParameter);
      if (flags) {
          if (virDomainGetSchedulerParametersFlags(dom, params, &nparams, flags) < 0) {
              Safefree(params);
              _croak_error();
          }
      } else {
          if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
              Safefree(params);
              _croak_error();
          }
      }
      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 6201 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_scheduler_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 3314 "Virt.xs"
      virTypedParameter *params;
      int nparams;
      char *type;
#line 6225 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_scheduler_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3318 "Virt.xs"
      if (!(type = virDomainGetSchedulerType(dom, &nparams)))
          _croak_error();

      free(type);
      Newx(params, nparams, virTypedParameter);
      if (flags) {
          if (virDomainGetSchedulerParametersFlags(dom, params, &nparams, flags) < 0) {
              Safefree(params);
              _croak_error();
          }
      } else {
          if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
              Safefree(params);
              _croak_error();
          }
      }
      nparams = vir_typed_param_from_hv(newparams, params, nparams);
      if (flags) {
          if (virDomainSetSchedulerParametersFlags(dom, params, nparams, flags) < 0)
              _croak_error();
      } else {
          if (virDomainSetSchedulerParameters(dom, params, nparams) < 0)
              _croak_error();
      }
      Safefree(params);
#line 6281 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_memory_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3350 "Virt.xs"
      virMemoryParameter *params;
      int nparams;
#line 6300 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_memory_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3353 "Virt.xs"
      nparams = 0;
      if (virDomainGetMemoryParameters(dom, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virMemoryParameter);

      if (virDomainGetMemoryParameters(dom, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 6331 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_memory_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 3376 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 6354 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_memory_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_memory_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3379 "Virt.xs"
      nparams = 0;
      if (virDomainGetMemoryParameters(dom, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virMemoryParameter);

      if (virDomainGetMemoryParameters(dom, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      nparams = vir_typed_param_from_hv(newparams, params, nparams);

      if (virDomainSetMemoryParameters(dom, params, nparams, flags) < 0)
          _croak_error();
      Safefree(params);
#line 6401 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_numa_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_numa_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3402 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 6420 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_numa_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3405 "Virt.xs"
      nparams = 0;
      if (virDomainGetNumaParameters(dom, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);

      if (virDomainGetNumaParameters(dom, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 6451 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_numa_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_numa_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 3428 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 6474 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_numa_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_numa_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3431 "Virt.xs"
      nparams = 0;
      if (virDomainGetNumaParameters(dom, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);

      if (virDomainGetNumaParameters(dom, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      nparams = vir_typed_param_from_hv(newparams, params, nparams);

      if (virDomainSetNumaParameters(dom, params, nparams, flags) < 0)
          _croak_error();
      Safefree(params);
#line 6521 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_blkio_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_blkio_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3454 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 6540 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_blkio_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3457 "Virt.xs"
      nparams = 0;
      if (virDomainGetBlkioParameters(dom, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virBlkioParameter);

      if (virDomainGetBlkioParameters(dom, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 6571 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_blkio_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_blkio_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 3480 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 6594 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_blkio_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_blkio_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3483 "Virt.xs"
      nparams = 0;
      if (virDomainGetBlkioParameters(dom, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virBlkioParameter);

      if (virDomainGetBlkioParameters(dom, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      nparams = vir_typed_param_from_hv(newparams, params, nparams);

      if (virDomainSetBlkioParameters(dom, params, nparams,
                                      flags) < 0)
          _croak_error();
      Safefree(params);
#line 6642 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_max_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_max_memory)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3506 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxMemory(dom)))
          _croak_error();
#line 6670 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_max_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_max_memory)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dom, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3517 "Virt.xs"
      if (virDomainSetMaxMemory(dom, val) < 0)
	_croak_error();
#line 6700 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_memory)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, val, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3527 "Virt.xs"
      if (flags) {
          if (virDomainSetMemoryFlags(dom, val, flags) < 0)
              _croak_error();
      } else {
          if (virDomainSetMemory(dom, val) < 0)
              _croak_error();
      }
#line 6743 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_memory_stats_period); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_memory_stats_period)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, val, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	val = (int)SvIV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_memory_stats_period() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3542 "Virt.xs"
      if (virDomainSetMemoryStatsPeriod(dom, val, flags) < 0)
          _croak_error();
#line 6781 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_max_vcpus)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_max_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3550 "Virt.xs"
      if (!(RETVAL = virDomainGetMaxVcpus(dom)))
          _croak_error();
#line 6809 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_vcpus)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, num, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	num = (int)SvIV(ST(1))
;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 3562 "Virt.xs"
      if (flags) {
          if (virDomainSetVcpusFlags(dom, num, flags) < 0)
              _croak_error();
      } else {
          if (virDomainSetVcpus(dom, num) < 0)
              _croak_error();
      }
#line 6852 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_vcpus)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 3576 "Virt.xs"
    if ((RETVAL = virDomainGetVcpusFlags(dom, flags)) < 0)
        _croak_error();
#line 6888 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_autostart)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dom, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	autostart = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3587 "Virt.xs"
      if (virDomainSetAutostart(dom, autostart) < 0)
          _croak_error();
#line 6918 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_autostart)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 3595 "Virt.xs"
      int autostart;
#line 6935 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3597 "Virt.xs"
      if (virDomainGetAutostart(dom, &autostart) < 0)
          _croak_error();
      RETVAL = autostart;
#line 6950 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_scheduler_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_scheduler_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 3608 "Virt.xs"
      int nparams;
#line 6967 "Virt.c"
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3610 "Virt.xs"
      if ((RETVAL = virDomainGetSchedulerType(dom, &nparams)) == NULL)
          _croak_error();
#line 6981 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_os_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_os_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 3620 "Virt.xs"
      char *type;
#line 6998 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_os_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3622 "Virt.xs"
      if (!(type = virDomainGetOSType(dom)))
          _croak_error();

      RETVAL = newSVpv(type, 0);
      free(type);
#line 7014 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3636 "Virt.xs"
      char *xml;
#line 7033 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_xml_description() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3638 "Virt.xs"
      if (!(xml = virDomainGetXMLDesc(dom, flags)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 7056 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_shutdown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_shutdown)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::shutdown() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3652 "Virt.xs"
      if (flags) {
          if (virDomainShutdownFlags(dom, flags) < 0)
              _croak_error();
      } else {
          if (virDomainShutdown(dom) < 0)
              _croak_error();
      }
#line 7098 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_reboot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_reboot)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::reboot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3666 "Virt.xs"
      if (virDomainReboot(dom, flags) < 0)
          _croak_error();
#line 7134 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pm_suspend_for_duration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pm_suspend_for_duration)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, target, duration, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	target = (unsigned int)SvUV(ST(1))
;
	SV *	duration = ST(2)
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pm_suspend_for_duration() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3677 "Virt.xs"
      if (virDomainPMSuspendForDuration(dom, target, virt_SvIVull(duration), flags) < 0)
          _croak_error();
#line 7174 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_reset)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::reset() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3686 "Virt.xs"
      if (virDomainReset(dom, flags) < 0)
          _croak_error();
#line 7210 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_inject_nmi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_inject_nmi)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::inject_nmi() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3695 "Virt.xs"
      if (virDomainInjectNMI(dom, flags) < 0)
          _croak_error();
#line 7246 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_undefine)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::undefine() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3704 "Virt.xs"
      if (flags) {
          if (virDomainUndefineFlags(dom, flags) < 0)
              _croak_error();
      } else {
          if (virDomainUndefine(dom) < 0)
              _croak_error();
      }
#line 7287 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_create)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::create() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3718 "Virt.xs"
      if (flags) {
          if (virDomainCreateWithFlags(dom, flags) < 0)
              _croak_error();
      } else {
          if (virDomainCreate(dom) < 0)
              _croak_error();
      }
#line 7328 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_create_with_files); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_create_with_files)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, fdssv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	fdssv = ST(1)
;
	unsigned int	flags;
#line 3734 "Virt.xs"
      AV *fdsav;
      unsigned int nfds;
      int *fds;
      int i;
#line 7353 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::create_with_files() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3739 "Virt.xs"
      if (!SvROK(fdssv))
          return;
      fdsav = (AV*)SvRV(fdssv);
      nfds = av_len(fdsav) + 1;
      Newx(fds, nfds, int);

      for (i = 0 ; i < nfds ; i++) {
          SV **fd = av_fetch(fdsav, i, 0);
          fds[i] = SvIV(*fd);
      }

      if (virDomainCreateWithFiles(dom, nfds, fds, flags) < 0) {
          Safefree(fds);
          _croak_error();
      }

      Safefree(fds);
#line 7387 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain__migrate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__migrate)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, destcon, newparams, flags=0");
    {
	virDomainPtr	dom;
	virConnectPtr	destcon;
	HV *	newparams;
	unsigned long	flags;
#line 3765 "Virt.xs"
     virTypedParameter *params;
     int nparams;
#line 7408 "Virt.c"
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_migrate() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        destcon = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::Domain::_migrate() -- destcon is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::Domain::_migrate",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}
#line 3768 "Virt.xs"
     nparams = 5;
     Newx(params, nparams, virTypedParameter);

     strncpy(params[0].field, VIR_MIGRATE_PARAM_URI,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[0].type = VIR_TYPED_PARAM_STRING;

     strncpy(params[1].field, VIR_MIGRATE_PARAM_DEST_NAME,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[1].type = VIR_TYPED_PARAM_STRING;

     strncpy(params[2].field, VIR_MIGRATE_PARAM_DEST_XML,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[2].type = VIR_TYPED_PARAM_STRING;

     strncpy(params[3].field, VIR_MIGRATE_PARAM_GRAPHICS_URI,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[3].type = VIR_TYPED_PARAM_STRING;

     strncpy(params[4].field, VIR_MIGRATE_PARAM_BANDWIDTH,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[4].type = VIR_TYPED_PARAM_ULLONG;


     nparams = vir_typed_param_from_hv(newparams, params, nparams);

     /* No need to support virDomainMigrate/virDomainMigrate2, since
      * virDomainMigrate3 takes care to call the older APIs internally
      * if it is possible todo so
      */
     if ((RETVAL = virDomainMigrate3(dom, destcon, params, nparams, flags)) == NULL) {
         Safefree(params);
         _croak_error();
     }
     Safefree(params);
#line 7483 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Domain", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__migrate_to_uri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__migrate_to_uri)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, desturi, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	desturi = (const char *)SvPV_nolen(ST(1))
;
	HV *	newparams;
	unsigned long	flags;
#line 3814 "Virt.xs"
     virTypedParameter *params;
     int nparams;
#line 7508 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_migrate_to_uri() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::Domain::_migrate_to_uri",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}
#line 3817 "Virt.xs"
     nparams = 5;
     Newx(params, nparams, virTypedParameter);

     strncpy(params[0].field, VIR_MIGRATE_PARAM_URI,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[0].type = VIR_TYPED_PARAM_STRING;

     strncpy(params[1].field, VIR_MIGRATE_PARAM_DEST_NAME,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[1].type = VIR_TYPED_PARAM_STRING;

     strncpy(params[2].field, VIR_MIGRATE_PARAM_DEST_XML,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[2].type = VIR_TYPED_PARAM_STRING;

     strncpy(params[3].field, VIR_MIGRATE_PARAM_GRAPHICS_URI,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[3].type = VIR_TYPED_PARAM_STRING;

     strncpy(params[4].field, VIR_MIGRATE_PARAM_BANDWIDTH,
             VIR_TYPED_PARAM_FIELD_LENGTH);
     params[4].type = VIR_TYPED_PARAM_ULLONG;

     nparams = vir_typed_param_from_hv(newparams, params, nparams);

     /* No need to support virDomainMigrateToURI/virDomainMigrateToURI2, since
      * virDomainMigrate3 takes care to call the older APIs internally
      * if it is possible todo so
      */
     if (virDomainMigrateToURI3(dom, desturi, params, nparams, flags) < 0) {
         Safefree(params);
         _croak_error();
     }
     Safefree(params);
#line 7573 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_max_downtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_max_downtime)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, downtime, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	downtime = ST(1)
;
	unsigned int	flags;
#line 3859 "Virt.xs"
     unsigned long long downtimeVal;
#line 7595 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_set_max_downtime() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3861 "Virt.xs"
     downtimeVal = virt_SvIVull(downtime);
     if (virDomainMigrateSetMaxDowntime(dom, downtimeVal, flags) < 0)
         _croak_error();
#line 7615 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_max_speed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_max_speed)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_set_max_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3872 "Virt.xs"
     if (virDomainMigrateSetMaxSpeed(dom, bandwidth, flags) < 0)
         _croak_error();
#line 7653 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_max_speed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_max_speed)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3881 "Virt.xs"
      unsigned long speed;
#line 7671 "Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_get_max_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3883 "Virt.xs"
      if (virDomainMigrateGetMaxSpeed(dom, &speed, flags) < 0)
          _croak_error();

      RETVAL = speed;
#line 7694 "Virt.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_compression_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_compression_cache)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, cacheSizeSv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	cacheSizeSv = ST(1)
;
	unsigned int	flags;
#line 3897 "Virt.xs"
      unsigned long long cacheSize;
#line 7716 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_set_compression_cache() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3899 "Virt.xs"
      cacheSize = virt_SvIVull(cacheSizeSv);
      if (virDomainMigrateSetCompressionCache(dom, cacheSize, flags) < 0)
          _croak_error();
#line 7736 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_compression_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_compression_cache)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 3909 "Virt.xs"
      unsigned long long cacheSize;
#line 7754 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_get_compression_cache() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3911 "Virt.xs"
      if (virDomainMigrateGetCompressionCache(dom, &cacheSize, flags) < 0)
          _croak_error();

      RETVAL = virt_newSVull(cacheSize);
#line 7776 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_attach_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_attach_device)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::attach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3925 "Virt.xs"
      if (flags) {
          if (virDomainAttachDeviceFlags(dom, xml, flags) < 0)
              _croak_error();
      } else {
          if (virDomainAttachDevice(dom, xml) < 0)
              _croak_error();
      }
#line 7820 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_detach_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_detach_device)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::detach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3940 "Virt.xs"
      if (flags) {
          if (virDomainDetachDeviceFlags(dom, xml, flags) < 0)
              _croak_error();
      } else {
          if (virDomainDetachDevice(dom, xml) < 0)
              _croak_error();
      }
#line 7863 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_update_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_update_device)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::update_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3955 "Virt.xs"
      if (virDomainUpdateDeviceFlags(dom, xml, flags) < 0)
          _croak_error();
#line 7901 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_block_iotune); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_block_iotune)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, disk, flags=0");
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 3965 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 7922 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_block_iotune() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3968 "Virt.xs"
      nparams = 0;
      RETVAL = NULL;
      if (virDomainGetBlockIoTune(dom, disk, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);
      if (virDomainGetBlockIoTune(dom, disk, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 7953 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_block_iotune); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_block_iotune)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, disk, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1))
;
	HV *	newparams;
	unsigned int	flags;
#line 3992 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 7978 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_block_iotune() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_block_iotune",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3995 "Virt.xs"
      nparams = 0;
      if (virDomainGetBlockIoTune(dom, disk, NULL, &nparams, flags) < 0)
          _croak_error();
      Newx(params, nparams, virTypedParameter);

      if (virDomainGetBlockIoTune(dom, disk, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      nparams = vir_typed_param_from_hv(newparams, params, nparams);
      if (virDomainSetBlockIoTune(dom, disk, params, nparams, flags) < 0)
          _croak_error();
#line 8022 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_interface_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_interface_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, intf, flags=0");
    {
	virDomainPtr	dom;
	const char *	intf = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 4016 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 8043 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_interface_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4019 "Virt.xs"
      nparams = 0;
      RETVAL = NULL;
      if (virDomainGetInterfaceParameters(dom, intf, NULL, &nparams, flags) < 0)
          _croak_error();

      Newx(params, nparams, virTypedParameter);
      if (virDomainGetInterfaceParameters(dom, intf, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      RETVAL = vir_typed_param_to_hv(params, nparams);
      Safefree(params);
#line 8074 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_interface_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_interface_parameters)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, intf, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	intf = (const char *)SvPV_nolen(ST(1))
;
	HV *	newparams;
	unsigned int	flags;
#line 4043 "Virt.xs"
      virTypedParameter *params;
      int nparams;
#line 8099 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_interface_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_interface_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4046 "Virt.xs"
      nparams = 0;
      if (virDomainGetInterfaceParameters(dom, intf, NULL, &nparams, flags) < 0)
          _croak_error();
      Newx(params, nparams, virTypedParameter);

      if (virDomainGetInterfaceParameters(dom, intf, params, &nparams, flags) < 0) {
          Safefree(params);
          _croak_error();
      }

      nparams = vir_typed_param_from_hv(newparams, params, nparams);
      if (virDomainSetInterfaceParameters(dom, intf, params, nparams, flags) < 0)
          _croak_error();
#line 8143 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_stats)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 4067 "Virt.xs"
      virDomainBlockStatsStruct stats;
      virTypedParameter *params;
      int nparams;
      unsigned int i;
      const char *field;
#line 8167 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4073 "Virt.xs"
      nparams = 0;
      RETVAL = NULL;
      if (virDomainBlockStatsFlags(dom, path, NULL, &nparams, flags) < 0) {
          virErrorPtr err = virGetLastError();
          if (err && err->code == VIR_ERR_NO_SUPPORT && !flags) {
              if (virDomainBlockStats(dom, path, &stats, sizeof(stats)) < 0)
                  _croak_error();

              RETVAL = (HV *)sv_2mortal((SV*)newHV());
              (void)hv_store (RETVAL, "rd_req", 6, virt_newSVll(stats.rd_req), 0);
              (void)hv_store (RETVAL, "rd_bytes", 8, virt_newSVll(stats.rd_bytes), 0);
              (void)hv_store (RETVAL, "wr_req", 6, virt_newSVll(stats.wr_req), 0);
              (void)hv_store (RETVAL, "wr_bytes", 8, virt_newSVll(stats.wr_bytes), 0);
              (void)hv_store (RETVAL, "errs", 4, virt_newSVll(stats.errs), 0);
          } else {
              _croak_error();
          }
      } else {
          Newx(params, nparams, virTypedParameter);

          if (virDomainBlockStatsFlags(dom, path, params, &nparams, flags) < 0) {
              Safefree(params);
              _croak_error();
          }

          RETVAL = vir_typed_param_to_hv(params, nparams);
          for (i = 0 ; i < nparams ; i++) {
              field = NULL;
              /* For back compat with previous hash above */
              if (strcmp(params[i].field, "rd_operations") == 0)
                  field = "rd_reqs";
              else if (strcmp(params[i].field, "wr_operations") == 0)
                  field = "wr_reqs";
              else if (strcmp(params[i].field, "flush_operations") == 0)
                  field = "flush_reqs";
              if (field) {
                  SV *val = hv_delete(RETVAL, params[i].field, strlen(params[i].field), 0);
                  SvREFCNT_inc(val);
                  (void)hv_store(RETVAL, field, strlen(field), val, 0);
              }
          }
          Safefree(params);
      }
#line 8228 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_interface_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_interface_stats)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dom, path");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
#line 4125 "Virt.xs"
      virDomainInterfaceStatsStruct stats;
#line 8248 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::interface_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4127 "Virt.xs"
      if (virDomainInterfaceStats(dom, path, &stats, sizeof(stats)) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "rx_bytes", 8, virt_newSVll(stats.rx_bytes), 0);
      (void)hv_store (RETVAL, "rx_packets", 10, virt_newSVll(stats.rx_packets), 0);
      (void)hv_store (RETVAL, "rx_errs", 7, virt_newSVll(stats.rx_errs), 0);
      (void)hv_store (RETVAL, "rx_drop", 7, virt_newSVll(stats.rx_drop), 0);
      (void)hv_store (RETVAL, "tx_bytes", 8, virt_newSVll(stats.tx_bytes), 0);
      (void)hv_store (RETVAL, "tx_packets", 10, virt_newSVll(stats.tx_packets), 0);
      (void)hv_store (RETVAL, "tx_errs", 7, virt_newSVll(stats.tx_errs), 0);
      (void)hv_store (RETVAL, "tx_drop", 7, virt_newSVll(stats.tx_drop), 0);
#line 8271 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_memory_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_memory_stats)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 4148 "Virt.xs"
      virDomainMemoryStatPtr stats;
      int i, got;
#line 8291 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::memory_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4151 "Virt.xs"
      Newx(stats, VIR_DOMAIN_MEMORY_STAT_NR, virDomainMemoryStatStruct);
      if ((got = virDomainMemoryStats(dom, stats, VIR_DOMAIN_MEMORY_STAT_NR, flags)) < 0) {
          Safefree(stats);
          _croak_error();
      }
      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      for (i = 0 ; i < got ; i++) {
          switch (stats[i].tag) {
          case VIR_DOMAIN_MEMORY_STAT_SWAP_IN:
              (void)hv_store (RETVAL, "swap_in", 7, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_SWAP_OUT:
              (void)hv_store (RETVAL, "swap_out", 8, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_MAJOR_FAULT:
              (void)hv_store (RETVAL, "major_fault", 11, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_MINOR_FAULT:
              (void)hv_store (RETVAL, "minor_fault", 11, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_UNUSED:
              (void)hv_store (RETVAL, "unused", 6, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_AVAILABLE:
              (void)hv_store (RETVAL, "available", 9, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_ACTUAL_BALLOON:
              (void)hv_store (RETVAL, "actual_balloon", 14, virt_newSVll(stats[i].val), 0);
              break;

          case VIR_DOMAIN_MEMORY_STAT_RSS:
              (void)hv_store (RETVAL, "rss", 14, virt_newSVll(stats[i].val), 0);
              break;
          }
      }
      Safefree(stats);
#line 8351 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_send_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_send_key)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, codeset, holdtime, keycodesSV, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	codeset = (unsigned int)SvUV(ST(1))
;
	unsigned int	holdtime = (unsigned int)SvUV(ST(2))
;
	SV *	keycodesSV = ST(3)
;
	unsigned int	flags;
#line 4205 "Virt.xs"
      AV *keycodesAV;
      unsigned int *keycodes;
      int nkeycodes;
      int i;
#line 8381 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::send_key() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 4210 "Virt.xs"
      if (!SvROK(keycodesSV))
          return;
      keycodesAV = (AV*)SvRV(keycodesSV);
      nkeycodes = av_len(keycodesAV) + 1;
      Newx(keycodes, nkeycodes, unsigned int);

      for (i = 0 ; i < nkeycodes ; i++) {
          SV **code = av_fetch(keycodesAV, i, 0);
          keycodes[i] = SvIV(*code);
      }

      if (virDomainSendKey(dom, codeset, holdtime, keycodes, nkeycodes, flags) < 0) {
          Safefree(keycodes);
          _croak_error();
      }

      Safefree(keycodes);
#line 8415 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_resize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_resize)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, disk, size, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1))
;
	SV *	size = ST(2)
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_resize() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4236 "Virt.xs"
      if (virDomainBlockResize(dom, disk, virt_SvIVull(size), flags) < 0)
          _croak_error();
#line 8455 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_peek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_peek)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, path, offset, size, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	offset = (unsigned int)SvUV(ST(2))
;
	size_t	size = (size_t)SvUV(ST(3))
;
	unsigned int	flags;
#line 4248 "Virt.xs"
      char *buf;
#line 8479 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 4250 "Virt.xs"
      Newx(buf, size, char);
      if (virDomainBlockPeek(dom, path, offset, size, buf, flags) < 0) {
          Safefree(buf);
          _croak_error();
      }
      RETVAL = newSVpvn(buf, size);
#line 8503 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_memory_peek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_memory_peek)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, offset, size, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	offset = (unsigned int)SvUV(ST(1))
;
	size_t	size = (size_t)SvUV(ST(2))
;
	unsigned int	flags;
#line 4267 "Virt.xs"
      char *buf;
#line 8526 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::memory_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4269 "Virt.xs"
      Newx(buf, size, char);
      if (virDomainMemoryPeek(dom, offset, size, buf, flags) < 0) {
          Safefree(buf);
          _croak_error();
      }
      RETVAL = newSVpvn(buf, size);
#line 8550 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_security_label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_security_label)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 4283 "Virt.xs"
      virSecurityLabel seclabel;
#line 8568 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_security_label() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4285 "Virt.xs"
      if (virDomainGetSecurityLabel(dom, &seclabel) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "label", 5, newSVpv(seclabel.label, 0), 0);
      (void)hv_store (RETVAL, "enforcing", 9, newSViv(seclabel.enforcing), 0);
#line 8585 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_security_label_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_security_label_list)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
#line 4299 "Virt.xs"
      virSecurityLabelPtr seclabels;
      int nlabels;
      int i;
#line 8607 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_security_label_list() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4303 "Virt.xs"
      if ((nlabels = virDomainGetSecurityLabelList(dom, &seclabels)) < 0)
          _croak_error();

      EXTEND(SP, nlabels);
      for (i = 0 ; i < nlabels ; i++) {
          HV *rec = (HV *)sv_2mortal((SV*)newHV());
          (void)hv_store (rec, "label", 5, newSVpv(seclabels[i].label, 0), 0);
          (void)hv_store (rec, "enforcing", 9, newSViv(seclabels[i].enforcing), 0);
          PUSHs(newRV_noinc((SV*)rec));
      }
      free(seclabels);
#line 8628 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_cpu_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_cpu_stats)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, start_cpu, ncpus, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	start_cpu = (int)SvIV(ST(1))
;
	unsigned int	ncpus = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;
#line 4323 "Virt.xs"
      virTypedParameterPtr params;
      unsigned int nparams;
      int ret;
      int i;
#line 8655 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_cpu_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4328 "Virt.xs"
      if ((ret = virDomainGetCPUStats(dom, NULL, 0, 0, 1, 0)) < 0)
          _croak_error();
      nparams = ret;

      if (ncpus == 0) {
          if ((ret = virDomainGetCPUStats(dom, NULL, 0, 0, 0, 0)) < 0)
              _croak_error();
          ncpus = ret;
      }

      Newx(params, ncpus * nparams, virTypedParameter);
      if ((ret = virDomainGetCPUStats(dom, params, nparams, start_cpu, ncpus, flags)) < 0) {
          Safefree(params);
          _croak_error();
      }

      EXTEND(SP, ret);
      for (i = 0 ; i < ret ; i++) {
          HV *rec = vir_typed_param_to_hv(params + (i * nparams), nparams);
          PUSHs(newRV_noinc((SV *)rec));
      }

      Safefree(params);
#line 8695 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_vcpu_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_vcpu_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 4358 "Virt.xs"
      virVcpuInfoPtr info;
      unsigned char *cpumaps;
      size_t maplen;
      virNodeInfo nodeinfo;
      virDomainInfo dominfo;
      int nvCpus;
      int i;
#line 8721 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_vcpu_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4366 "Virt.xs"
      if (virNodeGetInfo(virDomainGetConnect(dom), &nodeinfo) < 0)
          _croak_error();
      if (virDomainGetInfo(dom, &dominfo) < 0)
          _croak_error();

      maplen = VIR_CPU_MAPLEN(VIR_NODEINFO_MAXCPUS(nodeinfo));
      Newx(cpumaps, dominfo.nrVirtCpu * maplen, unsigned char);
      if (!flags) {
	  Newx(info, dominfo.nrVirtCpu, virVcpuInfo);
          if ((nvCpus = virDomainGetVcpus(dom, info, dominfo.nrVirtCpu, cpumaps, maplen)) < 0) {
              virErrorPtr err = virGetLastError();
              Safefree(info);
              info = NULL;
              if (err && err->code == VIR_ERR_OPERATION_INVALID) {
                  if ((nvCpus = virDomainGetVcpuPinInfo(dom, dominfo.nrVirtCpu, cpumaps, maplen, flags)) < 0) {
                      Safefree(cpumaps);
                      _croak_error();
                  }
              } else {
                  Safefree(cpumaps);
                  _croak_error();
              }
          }
      } else {
          info = NULL;
          if ((nvCpus = virDomainGetVcpuPinInfo(dom, dominfo.nrVirtCpu, cpumaps, maplen, flags)) < 0) {
              Safefree(cpumaps);
              _croak_error();
          }
      }

      EXTEND(SP, nvCpus);
      for (i = 0 ; i < nvCpus ; i++) {
          HV *rec = newHV();
          (void)hv_store(rec, "number", 6, newSViv(i), 0);
          if (info) {
              (void)hv_store(rec, "state", 5, newSViv(info[i].state), 0);
              (void)hv_store(rec, "cpuTime", 7, virt_newSVull(info[i].cpuTime), 0);
              (void)hv_store(rec, "cpu", 3, newSViv(info[i].cpu), 0);
          } else {
              (void)hv_store(rec, "state", 5, newSViv(0), 0);
              (void)hv_store(rec, "cpuTime", 7, virt_newSVull(0), 0);
              (void)hv_store(rec, "cpu", 3, newSViv(0), 0);
          }
          (void)hv_store(rec, "affinity", 8, newSVpvn((char*)cpumaps + (i *maplen), maplen), 0);
          PUSHs(newRV_noinc((SV *)rec));
      }

      if (info)
          Safefree(info);
      Safefree(cpumaps);
#line 8789 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pin_vcpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pin_vcpu)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, vcpu, mask, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	vcpu = (unsigned int)SvUV(ST(1))
;
	SV *	mask = ST(2)
;
	unsigned int	flags;
#line 4426 "Virt.xs"
     STRLEN masklen;
     unsigned char *maps;
#line 8814 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pin_vcpu() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4429 "Virt.xs"
     maps = (unsigned char *)SvPV(mask, masklen);
     if (flags) {
         if (virDomainPinVcpuFlags(dom, vcpu, maps, masklen, flags) < 0)
             _croak_error();
     } else {
         if (virDomainPinVcpu(dom, vcpu, maps, masklen) < 0)
             _croak_error();
     }
#line 8839 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pin_emulator); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pin_emulator)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, mask, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	mask = ST(1)
;
	unsigned int	flags;
#line 4445 "Virt.xs"
     STRLEN masklen;
     unsigned char *maps;
#line 8862 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pin_emulator() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4448 "Virt.xs"
     maps = (unsigned char *)SvPV(mask, masklen);
     if (virDomainPinEmulator(dom, maps, masklen, flags) < 0)
         _croak_error();
#line 8882 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_emulator_pin_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_emulator_pin_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 4458 "Virt.xs"
      unsigned char *cpumaps;
      int maplen;
      virNodeInfo nodeinfo;
      int nCpus;
#line 8903 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_emulator_pin_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4463 "Virt.xs"
      if (virNodeGetInfo(virDomainGetConnect(dom), &nodeinfo) < 0)
          _croak_error();

      nCpus = VIR_NODEINFO_MAXCPUS(nodeinfo);
      maplen = VIR_CPU_MAPLEN(nCpus);
      Newx(cpumaps, maplen, unsigned char);
      if ((virDomainGetEmulatorPinInfo(dom, cpumaps, maplen, flags)) < 0) {
          Safefree(cpumaps);
          _croak_error();
      }
      RETVAL = newSVpvn((char*)cpumaps, maplen);
      Safefree(cpumaps);
#line 8933 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_num_of_snapshots); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_num_of_snapshots)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::num_of_snapshots() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4484 "Virt.xs"
      if ((RETVAL = virDomainSnapshotNum(dom, flags)) < 0)
          _croak_error();
#line 8970 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_list_snapshot_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_list_snapshot_names)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	maxnames = (int)SvIV(ST(1))
;
	unsigned int	flags;
#line 4496 "Virt.xs"
      char **names;
      int nsnap;
      int i;
#line 8994 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::list_snapshot_names() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4500 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nsnap = virDomainSnapshotListNames(dom, names, maxnames, flags)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nsnap);
      for (i = 0 ; i < nsnap ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 9022 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_list_all_snapshots); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_list_all_snapshots)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 4518 "Virt.xs"
      virDomainSnapshotPtr *domsss;
      int i, ndomss;
      SV *domssrv;
#line 9044 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::list_all_snapshots() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4522 "Virt.xs"
      if ((ndomss = virDomainListAllSnapshots(dom, &domsss, flags)) < 0)
          _croak_error();

      EXTEND(SP, ndomss);
      for (i = 0 ; i < ndomss ; i++) {
          domssrv = sv_newmortal();
          sv_setref_pv(domssrv, "Sys::Virt::DomainSnapshot", domsss[i]);
          PUSHs(domssrv);
      }
      free(domsss);
#line 9071 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_has_current_snapshot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_has_current_snapshot)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::has_current_snapshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4539 "Virt.xs"
      if ((RETVAL = virDomainHasCurrentSnapshot(dom, flags)) < 0)
          _croak_error();
#line 9107 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_current_snapshot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_current_snapshot)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::current_snapshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4550 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotCurrent(dom, flags)))
          _croak_error();
#line 9142 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::DomainSnapshot", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_fs_trim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_fs_trim)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, mountPoint, minimumsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	mountPoint = (const char *)SvPV_nolen(ST(1))
;
	SV *	minimumsv = ST(2)
;
	unsigned int	flags;
#line 4563 "Virt.xs"
      unsigned long long minimum;
#line 9167 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::fs_trim() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4565 "Virt.xs"
      minimum = virt_SvIVull(minimumsv);
      if (virDomainFSTrim(dom, mountPoint, minimum, flags) < 0)
          _croak_error();
#line 9187 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_send_process_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_send_process_signal)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, pidsv, signum, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	pidsv = ST(1)
;
	unsigned int	signum = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;
#line 4577 "Virt.xs"
      long long pid;
#line 9211 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::send_process_signal() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4579 "Virt.xs"
      pid = virt_SvIVull(pidsv);
      if (virDomainSendProcessSignal(dom, pid, signum, flags) < 0)
          _croak_error();
#line 9231 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_destroy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom_rv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0)
;
	unsigned int	flags;
#line 4589 "Virt.xs"
      virDomainPtr dom;
#line 9252 "Virt.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4591 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (flags) {
          if (virDomainDestroyFlags(dom, flags) < 0)
              _croak_error();
      } else {
          if (virDomainDestroy(dom) < 0)
              _croak_error();
      }
#line 9269 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0)
;
#line 4605 "Virt.xs"
      virDomainPtr dom;
#line 9289 "Virt.c"
#line 4607 "Virt.xs"
      dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
      if (dom) {
	virDomainFree(dom);
	sv_setiv((SV*)SvRV(dom_rv), 0);
      }
#line 9296 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__create_xml)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4622 "Virt.xs"
      if (!(RETVAL = virNetworkCreateXML(con, xml)))
          _croak_error();
#line 9325 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__define_xml)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4633 "Virt.xs"
      if (!(RETVAL = virNetworkDefineXML(con, xml)))
          _croak_error();
#line 9355 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4644 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByName(con, name)))
          _croak_error();
#line 9385 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4655 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUID(con, uuid)))
          _croak_error();
#line 9415 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4666 "Virt.xs"
      if (!(RETVAL = virNetworkLookupByUUIDString(con, uuid)))
          _croak_error();

#line 9446 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Network", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 4677 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 9464 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_uuid() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4679 "Virt.xs"
      if ((virNetworkGetUUID(net, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 9479 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 4691 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 9497 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_uuid_string() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4693 "Virt.xs"
      if ((virNetworkGetUUIDString(net, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 9512 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4705 "Virt.xs"
      if (!(RETVAL = virNetworkGetName(net)))
          _croak_error();
#line 9541 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::is_active() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4715 "Virt.xs"
      if ((RETVAL = virNetworkIsActive(net)) < 0)
          _croak_error();
#line 9569 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_is_persistent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::is_persistent() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4725 "Virt.xs"
      if ((RETVAL = virNetworkIsPersistent(net)) < 0)
          _croak_error();
#line 9597 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_bridge_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_bridge_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 4735 "Virt.xs"
      char *name;
#line 9614 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_bridge_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4737 "Virt.xs"
      if (!(name = virNetworkGetBridgeName(net)))
          _croak_error();

      RETVAL = newSVpv(name, 0);
      free(name);
#line 9630 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "net, flags=0");
    {
	virNetworkPtr	net;
	unsigned int	flags;
#line 4751 "Virt.xs"
      char *xml;
#line 9649 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_xml_description() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4753 "Virt.xs"
      if (!(xml = virNetworkGetXMLDesc(net, flags)))
	 _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 9672 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::undefine() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4766 "Virt.xs"
      if (virNetworkUndefine(net) < 0)
          _croak_error();
#line 9701 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::create() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4774 "Virt.xs"
      if (virNetworkCreate(net) < 0)
          _croak_error();
#line 9729 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_update)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "net, command, section, parentIndex, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	unsigned int	command = (unsigned int)SvUV(ST(1))
;
	unsigned int	section = (unsigned int)SvUV(ST(2))
;
	int	parentIndex = (int)SvIV(ST(3))
;
	const char *	xml = (const char *)SvPV_nolen(ST(4))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::update() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(5))
;
	}
#line 4787 "Virt.xs"
      if (virNetworkUpdate(net, command, section, parentIndex, xml, flags) < 0)
          _croak_error();
#line 9773 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_set_autostart)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "net, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	int	autostart = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::set_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4795 "Virt.xs"
      if (virNetworkSetAutostart(net, autostart) < 0)
          _croak_error();
#line 9803 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_autostart)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 4803 "Virt.xs"
      int autostart;
#line 9820 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4805 "Virt.xs"
      if (virNetworkGetAutostart(net, &autostart) < 0)
          _croak_error();

      RETVAL = autostart;
#line 9836 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0)
;
#line 4817 "Virt.xs"
      virNetworkPtr net;
#line 9856 "Virt.c"
#line 4819 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (virNetworkDestroy(net) < 0)
          _croak_error();
#line 9861 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0)
;
#line 4828 "Virt.xs"
      virNetworkPtr net;
#line 9881 "Virt.c"
#line 4830 "Virt.xs"
      net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
      if (net) {
	virNetworkFree(net);
	sv_setiv((SV*)SvRV(net_rv), 0);
      }
#line 9888 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__create_xml)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4845 "Virt.xs"
      if (!(RETVAL = virStoragePoolCreateXML(con, xml, 0)))
          _croak_error();

#line 9918 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__define_xml)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4857 "Virt.xs"
      if (!(RETVAL = virStoragePoolDefineXML(con, xml, 0)))
          _croak_error();
#line 9948 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4868 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByName(con, name)))
          _croak_error();
#line 9978 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4879 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByUUID(con, uuid)))
          _croak_error();
#line 10008 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4890 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByUUIDString(con, uuid)))
	_croak_error();
#line 10038 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_volume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_volume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_volume() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4900 "Virt.xs"
      if (!(RETVAL = virStoragePoolLookupByVolume(vol)))
          _croak_error();
#line 10066 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StoragePool", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 4910 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 10084 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4912 "Virt.xs"
      if ((virStoragePoolGetUUID(pool, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 10099 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 4924 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 10117 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid_string() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4926 "Virt.xs"
      if ((virStoragePoolGetUUIDString(pool, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 10132 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4938 "Virt.xs"
      if (!(RETVAL = virStoragePoolGetName(pool)))
          _croak_error();
#line 10161 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::is_active() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4948 "Virt.xs"
      if ((RETVAL = virStoragePoolIsActive(pool)) < 0)
          _croak_error();
#line 10189 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_is_persistent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::is_persistent() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4958 "Virt.xs"
      if ((RETVAL = virStoragePoolIsPersistent(pool)) < 0)
          _croak_error();
#line 10217 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    {
	virStoragePoolPtr	pool;
	unsigned int	flags;
#line 4969 "Virt.xs"
      char *xml;
#line 10235 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_xml_description() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4971 "Virt.xs"
      if (!(xml = virStoragePoolGetXMLDesc(pool, flags)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 10258 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::undefine() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4984 "Virt.xs"
      if (virStoragePoolUndefine(pool) < 0)
          _croak_error();
#line 10287 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::create() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4992 "Virt.xs"
      if (virStoragePoolCreate(pool, 0) < 0)
          _croak_error();
#line 10315 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_refresh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_refresh)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::refresh() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 5001 "Virt.xs"
      if (virStoragePoolRefresh(pool, flags) < 0)
          _croak_error();
#line 10351 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_build); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_build)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::build() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 5010 "Virt.xs"
      if (virStoragePoolBuild(pool, flags) < 0)
          _croak_error();
#line 10387 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_delete)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::delete() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 5019 "Virt.xs"
      if (virStoragePoolDelete(pool, flags) < 0)
          _croak_error();
#line 10423 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_set_autostart)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pool, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	autostart = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::set_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5028 "Virt.xs"
      if (virStoragePoolSetAutostart(pool, autostart) < 0)
          _croak_error();
#line 10453 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_autostart)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 5036 "Virt.xs"
      int autostart;
#line 10470 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5038 "Virt.xs"
      if (virStoragePoolGetAutostart(pool, &autostart) < 0)
          _croak_error();

      RETVAL = autostart;
#line 10486 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 5050 "Virt.xs"
      virStoragePoolInfo info;
#line 10503 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_info() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5052 "Virt.xs"
      if (virStoragePoolGetInfo(pool, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
      (void)hv_store (RETVAL, "available", 9, virt_newSVull(info.available), 0);
#line 10522 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0)
;
#line 5068 "Virt.xs"
      virStoragePoolPtr pool;
#line 10543 "Virt.c"
#line 5070 "Virt.xs"
      pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
      if (virStoragePoolDestroy(pool) < 0)
          _croak_error();
#line 10548 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_num_of_storage_volumes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_num_of_storage_volumes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::num_of_storage_volumes() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5079 "Virt.xs"
      if ((RETVAL = virStoragePoolNumOfVolumes(pool)) < 0)
          _croak_error();
#line 10576 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_list_storage_vol_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_list_storage_vol_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pool, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	maxnames = (int)SvIV(ST(1))
;
#line 5090 "Virt.xs"
      char **names;
      int i, nnet;
#line 10598 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::list_storage_vol_names() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5093 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nnet = virStoragePoolListVolumes(pool, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 10619 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_list_all_volumes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_list_all_volumes)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	unsigned int	flags;
#line 5111 "Virt.xs"
      virStorageVolPtr *vols;
      int i, nvolss;
      SV *volssrv;
#line 10641 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::list_all_volumes() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5115 "Virt.xs"
      if ((nvolss = virStoragePoolListAllVolumes(pool, &vols, flags)) < 0)
          _croak_error();

      EXTEND(SP, nvolss);
      for (i = 0 ; i < nvolss ; i++) {
          volssrv = sv_newmortal();
          sv_setref_pv(volssrv, "Sys::Virt::StorageVol", vols[i]);
          PUSHs(volssrv);
      }
      free(vols);
#line 10668 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0)
;
#line 5133 "Virt.xs"
      virStoragePoolPtr pool;
#line 10688 "Virt.c"
#line 5135 "Virt.xs"
      pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
      if (pool) {
          virStoragePoolFree(pool);
          sv_setiv((SV*)SvRV(pool_rv), 0);
      }
#line 10695 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pool, xml, flags=0");
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	int	flags;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 5151 "Virt.xs"
      if (!(RETVAL = virStorageVolCreateXML(pool, xml, flags)))
          _croak_error();
#line 10732 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol__create_xml_from); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__create_xml_from)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "pool, xml, clone, flags=0");
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virStorageVolPtr	clone;
	int	flags;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml_from() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVMG))
        clone = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(2) )));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml_from() -- clone is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}
#line 5164 "Virt.xs"
      if (!(RETVAL = virStorageVolCreateXMLFrom(pool, xml, clone, flags)))
	_croak_error();
#line 10779 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pool, name");
    {
	virStoragePoolPtr	pool;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5175 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByName(pool, name)))
          _croak_error();
#line 10809 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, key");
    {
	virConnectPtr	con;
	const char *	key = (const char *)SvPV_nolen(ST(1))
;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_key() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5186 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByKey(con, key)))
          _croak_error();
#line 10839 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_path)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, path");
    {
	virConnectPtr	con;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5197 "Virt.xs"
      if (!(RETVAL = virStorageVolLookupByPath(con, path)))
          _croak_error();
#line 10869 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::StorageVol", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_name() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5207 "Virt.xs"
      if (!(RETVAL = virStorageVolGetName(vol)))
          _croak_error();
#line 10898 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_key() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5217 "Virt.xs"
      if (!(RETVAL = virStorageVolGetKey(vol)))
          _croak_error();
#line 10926 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_path() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5227 "Virt.xs"
      if (!(RETVAL = virStorageVolGetPath(vol)))
          _croak_error();
#line 10954 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_resize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_resize)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "vol, capacity, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	SV *	capacity = ST(1)
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::resize() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5239 "Virt.xs"
      if (virStorageVolResize(vol, virt_SvIVull(capacity), flags) < 0)
          _croak_error();
#line 10992 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    {
	virStorageVolPtr	vol;
	unsigned int	flags;
#line 5248 "Virt.xs"
      char *xml;
#line 11010 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_xml_description() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5250 "Virt.xs"
      if (!(xml = virStorageVolGetXMLDesc(vol, flags)))
	 _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 11033 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_delete)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::delete() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5264 "Virt.xs"
      if (virStorageVolDelete(vol, flags) < 0)
          _croak_error();
#line 11070 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_wipe); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_wipe)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::wipe() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5273 "Virt.xs"
      if (virStorageVolWipe(vol, flags) < 0)
          _croak_error();
#line 11106 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_wipe_pattern); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_wipe_pattern)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "vol, algorithm, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	algorithm = (unsigned int)SvUV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::wipe_pattern() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5283 "Virt.xs"
      if (virStorageVolWipePattern(vol, algorithm, flags) < 0)
          _croak_error();
#line 11144 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
#line 5291 "Virt.xs"
      virStorageVolInfo info;
#line 11161 "Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_info() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5293 "Virt.xs"
      if (virStorageVolGetInfo(vol, &info) < 0)
          _croak_error();

      RETVAL = (HV *)sv_2mortal((SV*)newHV());
      (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
      (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
      (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
#line 11179 "Virt.c"
	ST(0) = newRV((SV*)RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_download); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_download)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "vol, st, offsetsv, lengthsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	virStreamPtr	st;
	SV *	offsetsv = ST(2)
;
	SV *	lengthsv = ST(3)
;
	unsigned int	flags;
#line 5312 "Virt.xs"
      unsigned long long offset;
      unsigned long long length;
#line 11206 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::download() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::StorageVol::download() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 5315 "Virt.xs"
      offset = virt_SvIVull(offsetsv);
      length = virt_SvIVull(lengthsv);

      if (virStorageVolDownload(vol, st, offset, length, flags) < 0)
          _croak_error();
#line 11236 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_upload); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_upload)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "vol, st, offsetsv, lengthsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	virStreamPtr	st;
	SV *	offsetsv = ST(2)
;
	SV *	lengthsv = ST(3)
;
	unsigned int	flags;
#line 5330 "Virt.xs"
      unsigned long long offset;
      unsigned long long length;
#line 11262 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::upload() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::StorageVol::upload() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 5333 "Virt.xs"
      offset = virt_SvIVull(offsetsv);
      length = virt_SvIVull(lengthsv);

      if (virStorageVolUpload(vol, st, offset, length, flags) < 0)
          _croak_error();
#line 11292 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	vol_rv = ST(0)
;
#line 5344 "Virt.xs"
      virStorageVolPtr vol;
#line 11312 "Virt.c"
#line 5346 "Virt.xs"
      vol = (virStorageVolPtr)SvIV((SV*)SvRV(vol_rv));
      if (vol) {
          virStorageVolFree(vol);
          sv_setiv((SV*)SvRV(vol_rv), 0);
      }
#line 11319 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5362 "Virt.xs"
      if (!(RETVAL = virNodeDeviceCreateXML(con, xml, flags)))
          _croak_error();
#line 11356 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NodeDevice", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5373 "Virt.xs"
      if (!(RETVAL = virNodeDeviceLookupByName(con, name)))
          _croak_error();
#line 11386 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NodeDevice", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice__lookup_scsihost_by_wwn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice__lookup_scsihost_by_wwn)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, wwnn, wwpn, flags=0");
    {
	virConnectPtr	con;
	const char *	wwnn = (const char *)SvPV_nolen(ST(1))
;
	const char *	wwpn = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::_lookup_scsihost_by_wwn() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 5386 "Virt.xs"
      if (!(RETVAL = virNodeDeviceLookupSCSIHostByWWN(con, wwnn, wwpn, flags)))
          _croak_error();
#line 11426 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NodeDevice", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::get_name() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5396 "Virt.xs"
      if (!(RETVAL = virNodeDeviceGetName(dev)))
          _croak_error();
#line 11455 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_get_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_get_parent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::get_parent() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5406 "Virt.xs"
      if (!(RETVAL = virNodeDeviceGetParent(dev))) {
          if (virGetLastError() != NULL)
              _croak_error();
      }
#line 11485 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dev, flags=0");
    {
	virNodeDevicePtr	dev;
	unsigned int	flags;
#line 5419 "Virt.xs"
      char *xml;
#line 11503 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::get_xml_description() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5421 "Virt.xs"
      if (!(xml = virNodeDeviceGetXMLDesc(dev, flags)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 11526 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_dettach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_dettach)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dev, driversv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
	SV *	driversv = ST(1)
;
	unsigned int	flags;
#line 5436 "Virt.xs"
      const char *driver = NULL;
      STRLEN len;
#line 11550 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::dettach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5439 "Virt.xs"
      if (SvOK(driversv)) {
	  driver = SvPV(driversv, len);
      }

      if (flags || driver) {
          if (virNodeDeviceDetachFlags(dev, driver, flags) < 0)
              _croak_error();
      } else {
          if (virNodeDeviceDettach(dev) < 0)
              _croak_error();
      }
#line 11578 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_reattach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_reattach)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::reattach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5456 "Virt.xs"
      if (virNodeDeviceReAttach(dev) < 0)
	_croak_error();
#line 11606 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::reset() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5464 "Virt.xs"
      if (virNodeDeviceReset(dev) < 0)
          _croak_error();
#line 11634 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_list_capabilities); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_list_capabilities)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
#line 5472 "Virt.xs"
      int maxnames;
      char **names;
      int i, nnet;
#line 11655 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::list_capabilities() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5476 "Virt.xs"
      if ((maxnames = virNodeDeviceNumOfCaps(dev)) < 0)
          _croak_error();

      Newx(names, maxnames, char *);
      if ((nnet = virNodeDeviceListCaps(dev, names, maxnames)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nnet);
      for (i = 0 ; i < nnet ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 11679 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0)
;
#line 5496 "Virt.xs"
      virNodeDevicePtr dev;
#line 11699 "Virt.c"
#line 5498 "Virt.xs"
      dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
      if (virNodeDeviceDestroy(dev) < 0)
          _croak_error();
#line 11704 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0)
;
#line 5507 "Virt.xs"
      virNodeDevicePtr dev;
#line 11724 "Virt.c"
#line 5509 "Virt.xs"
      dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
      if (dev) {
          virNodeDeviceFree(dev);
          sv_setiv((SV*)SvRV(dev_rv), 0);
      }
#line 11731 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Interface__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags = 0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5524 "Virt.xs"
      if (!(RETVAL = virInterfaceDefineXML(con, xml, flags)))
          _croak_error();
#line 11768 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5535 "Virt.xs"
      if (!(RETVAL = virInterfaceLookupByName(con, name)))
          _croak_error();
#line 11798 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface__lookup_by_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface__lookup_by_mac)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, mac");
    {
	virConnectPtr	con;
	const char *	mac = (const char *)SvPV_nolen(ST(1))
;
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::_lookup_by_mac() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5546 "Virt.xs"
      if (!(RETVAL = virInterfaceLookupByMACString(con, mac)))
          _croak_error();
#line 11828 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Interface", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_get_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_get_mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::get_mac() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5556 "Virt.xs"
      if (!(RETVAL = virInterfaceGetMACString(iface)))
          _croak_error();
#line 11857 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::get_name() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5566 "Virt.xs"
      if (!(RETVAL = virInterfaceGetName(iface)))
          _croak_error();
#line 11885 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::is_active() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5576 "Virt.xs"
      if ((RETVAL = virInterfaceIsActive(iface)) < 0)
          _croak_error();
#line 11913 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface, flags=0");
    {
	virInterfacePtr	iface;
	unsigned int	flags;
#line 5587 "Virt.xs"
      char *xml;
#line 11931 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::get_xml_description() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5589 "Virt.xs"
      if (!(xml = virInterfaceGetXMLDesc(iface, flags)))
          _croak_error();
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 11953 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virInterfacePtr	iface;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::undefine() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5601 "Virt.xs"
      if (virInterfaceUndefine(iface) < 0)
          _croak_error();
#line 11982 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Interface_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_create)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virInterfacePtr	iface;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::create() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5610 "Virt.xs"
      if (virInterfaceCreate(iface, flags) < 0)
          _croak_error();
#line 12018 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Interface_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_destroy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface_rv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	iface_rv = ST(0)
;
	unsigned int	flags;
#line 5619 "Virt.xs"
      virInterfacePtr iface;
#line 12039 "Virt.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5621 "Virt.xs"
      iface = (virInterfacePtr)SvIV((SV*)SvRV(iface_rv));
      if (virInterfaceDestroy(iface, flags) < 0)
          _croak_error();
#line 12051 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Interface_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	iface_rv = ST(0)
;
#line 5630 "Virt.xs"
      virInterfacePtr iface;
#line 12071 "Virt.c"
#line 5632 "Virt.xs"
      iface = (virInterfacePtr)SvIV((SV*)SvRV(iface_rv));
      if (iface) {
          virInterfaceFree(iface);
          sv_setiv((SV*)SvRV(iface_rv), 0);
      }
#line 12078 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Secret__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5648 "Virt.xs"
      if (!(RETVAL = virSecretDefineXML(con, xml, flags)))
          _croak_error();
#line 12115 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Secret", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_usage); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_usage)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "con, usageType, usageID");
    {
	virConnectPtr	con;
	int	usageType = (int)SvIV(ST(1))
;
	const char *	usageID = (const char *)SvPV_nolen(ST(2))
;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_usage() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5660 "Virt.xs"
      if (!(RETVAL = virSecretLookupByUsage(con, usageType, usageID))) {
	_croak_error();
      }
#line 12148 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Secret", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5672 "Virt.xs"
      if (!(RETVAL = virSecretLookupByUUID(con, uuid)))
          _croak_error();
#line 12178 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Secret", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5683 "Virt.xs"
      if (!(RETVAL = virSecretLookupByUUIDString(con, uuid)))
          _croak_error();
#line 12208 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Secret", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
#line 5693 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 12226 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_uuid() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5695 "Virt.xs"
      if ((virSecretGetUUID(sec, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 12241 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
#line 5707 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 12259 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_uuid_string() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5709 "Virt.xs"
      if ((virSecretGetUUIDString(sec, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 12274 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_usage_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_usage_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_usage_id() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5721 "Virt.xs"
      if (!(RETVAL = virSecretGetUsageID(sec)))
          _croak_error();
#line 12303 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_usage_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_usage_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_usage_type() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5731 "Virt.xs"
      if (!(RETVAL = virSecretGetUsageType(sec)))
          _croak_error();
#line 12331 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sec, flags=0");
    {
	virSecretPtr	sec;
	unsigned int	flags;
#line 5742 "Virt.xs"
      char *xml;
#line 12349 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_xml_description() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5744 "Virt.xs"
      if (!(xml = virSecretGetXMLDesc(sec, flags)))
          _croak_error();
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 12371 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virSecretPtr	sec;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::undefine() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5756 "Virt.xs"
      if (virSecretUndefine(sec) < 0)
          _croak_error();
#line 12400 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Secret_set_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_set_value)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sec, value, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virSecretPtr	sec;
	SV *	value = ST(1)
;
	unsigned int	flags;
#line 5766 "Virt.xs"
      unsigned char *bytes;
      STRLEN len;
#line 12423 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::set_value() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5769 "Virt.xs"
      bytes = (unsigned char *)SvPV(value, len);
      if (virSecretSetValue(sec, bytes, len, flags) < 0)
          _croak_error();
#line 12443 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Secret_get_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_value)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sec, flags=0");
    {
	virSecretPtr	sec;
	unsigned int	flags;
#line 5779 "Virt.xs"
      unsigned char *bytes;
      size_t len;
#line 12462 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_value() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5782 "Virt.xs"
      if ((bytes = virSecretGetValue(sec, &len, flags)) == NULL)
          _croak_error();

      RETVAL = newSVpv((char*)bytes, len);
#line 12484 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sec_rv = ST(0)
;
#line 5795 "Virt.xs"
      virSecretPtr sec;
#line 12505 "Virt.c"
#line 5797 "Virt.xs"
      sec = (virSecretPtr)SvIV((SV*)SvRV(sec_rv));
      if (sec) {
          virSecretFree(sec);
          sv_setiv((SV*)SvRV(sec_rv), 0);
      }
#line 12512 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NWFilter__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter__define_xml)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5812 "Virt.xs"
      if (!(RETVAL = virNWFilterDefineXML(con, xml)))
          _croak_error();
#line 12541 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NWFilter", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5823 "Virt.xs"
      if (!(RETVAL = virNWFilterLookupByName(con, name)))
          _croak_error();
#line 12571 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NWFilter", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5834 "Virt.xs"
      if (!(RETVAL = virNWFilterLookupByUUID(con, uuid)))
          _croak_error();
#line 12601 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NWFilter", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5845 "Virt.xs"
      if (!(RETVAL = virNWFilterLookupByUUIDString(con, uuid)))
          _croak_error();
#line 12631 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::NWFilter", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
#line 5855 "Virt.xs"
      unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 12649 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::get_uuid() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5857 "Virt.xs"
      if ((virNWFilterGetUUID(filter, rawuuid)) < 0)
          _croak_error();

      RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 12664 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
#line 5869 "Virt.xs"
      char uuid[VIR_UUID_STRING_BUFLEN];
#line 12682 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::get_uuid_string() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5871 "Virt.xs"
      if ((virNWFilterGetUUIDString(filter, uuid)) < 0)
          _croak_error();

      RETVAL = newSVpv(uuid, 0);
#line 12697 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::get_name() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5883 "Virt.xs"
      if (!(RETVAL = virNWFilterGetName(filter)))
          _croak_error();
#line 12726 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "filter, flags=0");
    {
	virNWFilterPtr	filter;
	unsigned int	flags;
#line 5894 "Virt.xs"
      char *xml;
#line 12744 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::get_xml_description() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5896 "Virt.xs"
      if (!(xml = virNWFilterGetXMLDesc(filter, flags)))
          _croak_error();

      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 12767 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNWFilterPtr	filter;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::undefine() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5909 "Virt.xs"
      if (virNWFilterUndefine(filter) < 0)
          _croak_error();
#line 12796 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NWFilter_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	filter_rv = ST(0)
;
#line 5916 "Virt.xs"
      virNWFilterPtr filter;
#line 12816 "Virt.c"
#line 5918 "Virt.xs"
      filter = (virNWFilterPtr)SvIV((SV*)SvRV(filter_rv));
      if (filter) {
          virNWFilterFree(filter);
          sv_setiv((SV*)SvRV(filter_rv), 0);
      }
#line 12823 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::_create_xml() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5934 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotCreateXML(dom, xml, flags)))
          _croak_error();
#line 12860 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::DomainSnapshot", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, name, flags=0");
    {
	virDomainPtr	dom;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::_lookup_by_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5946 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotLookupByName(dom, name, flags)))
          _croak_error();
#line 12898 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::DomainSnapshot", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "domss");
    {
	virDomainSnapshotPtr	domss;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_name() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5956 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotGetName(domss)))
          _croak_error();
#line 12927 "Virt.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
#line 5967 "Virt.xs"
      char *xml;
#line 12945 "Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_xml_description() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5969 "Virt.xs"
      if (!(xml = virDomainSnapshotGetXMLDesc(domss, flags)))
          _croak_error();
      RETVAL = newSVpv(xml, 0);
      free(xml);
#line 12967 "Virt.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_revert_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_revert_to)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::revert_to() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5982 "Virt.xs"
      if (virDomainRevertToSnapshot(domss, flags) < 0)
          _croak_error();
#line 13004 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_delete)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::delete() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5991 "Virt.xs"
      if (virDomainSnapshotDelete(domss, flags) < 0)
          _croak_error();
#line 13040 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_parent)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_parent() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6000 "Virt.xs"
      if (!(RETVAL = virDomainSnapshotGetParent(domss, flags)))
          _croak_error();
#line 13075 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::DomainSnapshot", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::num_of_child_snapshots() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6011 "Virt.xs"
      if ((RETVAL = virDomainSnapshotNumChildren(domss, flags)) < 0)
          _croak_error();
#line 13112 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_is_current); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_is_current)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::is_current() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6022 "Virt.xs"
      if ((RETVAL = virDomainSnapshotIsCurrent(domss, flags)) < 0)
          _croak_error();
#line 13148 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_has_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_has_metadata)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::has_metadata() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6033 "Virt.xs"
      if ((RETVAL = virDomainSnapshotHasMetadata(domss, flags)) < 0)
          _croak_error();
#line 13184 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "domss, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	int	maxnames = (int)SvIV(ST(1))
;
	unsigned int	flags;
#line 6045 "Virt.xs"
      char **names;
      int nsnap;
      int i;
#line 13208 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::list_child_snapshot_names() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6049 "Virt.xs"
      Newx(names, maxnames, char *);
      if ((nsnap = virDomainSnapshotListChildrenNames(domss, names, maxnames, flags)) < 0) {
          Safefree(names);
          _croak_error();
      }
      EXTEND(SP, nsnap);
      for (i = 0 ; i < nsnap ; i++) {
          PUSHs(sv_2mortal(newSVpv(names[i], 0)));
          free(names[i]);
      }
      Safefree(names);
#line 13236 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_list_all_children); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_list_all_children)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
#line 6067 "Virt.xs"
      virDomainSnapshotPtr *domsss;
      int i, ndomss;
      SV *domssrv;
#line 13258 "Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::list_all_children() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6071 "Virt.xs"
      if ((ndomss = virDomainSnapshotListAllChildren(domss, &domsss, flags)) < 0)
          _croak_error();

      EXTEND(SP, ndomss);
      for (i = 0 ; i < ndomss ; i++) {
          domssrv = sv_newmortal();
          sv_setref_pv(domssrv, "Sys::Virt::DomainSnapshot", domsss[i]);
          PUSHs(domssrv);
      }
      free(domsss);
#line 13285 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "domss_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	domss_rv = ST(0)
;
#line 6087 "Virt.xs"
      virDomainSnapshotPtr domss;
#line 13305 "Virt.c"
#line 6089 "Virt.xs"
      domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV(domss_rv));
      if (domss) {
          virDomainSnapshotFree(domss);
          sv_setiv((SV*)SvRV(domss_rv), 0);
      }
#line 13312 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event__register_impl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event__register_impl)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 6105 "Virt.xs"
      virEventRegisterImpl(_event_add_handle,
			   _event_update_handle,
			   _event_remove_handle,
			   _event_add_timeout,
			   _event_update_timeout,
			   _event_remove_timeout);
#line 13335 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_register_default); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_register_default)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 6116 "Virt.xs"
      virEventRegisterDefaultImpl();
#line 13353 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_run_default); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_run_default)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 6122 "Virt.xs"
      virEventRunDefaultImpl();
#line 13371 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_add_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_add_handle)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, events, coderef");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	events = (int)SvIV(ST(1))
;
	SV *	coderef = ST(2)
;
#line 6131 "Virt.xs"
      int watch;
#line 13393 "Virt.c"
	int	RETVAL;
	dXSTARG;
#line 6133 "Virt.xs"
      SvREFCNT_inc(coderef);

      if ((watch = virEventAddHandle(fd, events, _event_handle_helper, coderef, _event_cb_free)) < 0) {
          SvREFCNT_dec(coderef);
          _croak_error();
      }
      RETVAL = watch;
#line 13404 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Event_update_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_update_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "watch, events");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0))
;
	int	events = (int)SvIV(ST(1))
;
#line 6149 "Virt.xs"
      virEventUpdateHandle(watch, events);
#line 13426 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_remove_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_remove_handle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "watch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0))
;
#line 6156 "Virt.xs"
      if (virEventRemoveHandle(watch) < 0)
          _croak_error();
#line 13447 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_add_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_add_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "frequency, coderef");
    {
	int	frequency = (int)SvIV(ST(0))
;
	SV *	coderef = ST(1)
;
#line 6165 "Virt.xs"
      int timer;
#line 13467 "Virt.c"
	int	RETVAL;
	dXSTARG;
#line 6167 "Virt.xs"
      SvREFCNT_inc(coderef);

      if ((timer = virEventAddTimeout(frequency, _event_timeout_helper, coderef, _event_cb_free)) < 0) {
          SvREFCNT_dec(coderef);
          _croak_error();
      }
      RETVAL = timer;
#line 13478 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Event_update_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_update_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "timer, frequency");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0))
;
	int	frequency = (int)SvIV(ST(1))
;
#line 6183 "Virt.xs"
      virEventUpdateTimeout(timer, frequency);
#line 13500 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_remove_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_remove_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timer");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0))
;
#line 6190 "Virt.xs"
      if (virEventRemoveTimeout(timer) < 0)
          _croak_error();
#line 13521 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event__run_handle_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event__run_handle_callback_helper)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "watch, fd, event, cbref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0))
;
	int	fd = (int)SvIV(ST(1))
;
	int	event = (int)SvIV(ST(2))
;
	SV *	cbref = ST(3)
;
	SV *	opaqueref = ST(4)
;
#line 6202 "Virt.xs"
      virEventHandleCallback cb;
      void *opaque;
#line 13550 "Virt.c"
#line 6205 "Virt.xs"
      cb = (virEventHandleCallback)SvIV((SV*)SvRV(cbref));
      opaque = (void*)SvIV((SV*)SvRV(opaqueref));

      cb(watch, fd, event, opaque);
#line 13556 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event__run_timeout_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event__run_timeout_callback_helper)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "timer, cbref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0))
;
	SV *	cbref = ST(1)
;
	SV *	opaqueref = ST(2)
;
#line 6217 "Virt.xs"
      virEventTimeoutCallback cb;
      void *opaque;
#line 13581 "Virt.c"
#line 6220 "Virt.xs"
      cb = (virEventTimeoutCallback)SvIV((SV*)SvRV(cbref));
      opaque = (void*)SvIV((SV*)SvRV(opaqueref));

      cb(timer, opaque);
#line 13587 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event__free_callback_opaque_helper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event__free_callback_opaque_helper)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ffref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ffref = ST(0)
;
	SV *	opaqueref = ST(1)
;
#line 6231 "Virt.xs"
      virFreeCallback ff;
      void *opaque;
#line 13610 "Virt.c"
#line 6234 "Virt.xs"
      opaque = SvOK(opaqueref) ? (void*)SvIV((SV*)SvRV(opaqueref)) : NULL;
      ff = SvOK(ffref) ? (virFreeCallback)SvIV((SV*)SvRV(ffref)) : NULL;

      if (opaque != NULL && ff != NULL)
        ff(opaque);
#line 13617 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream__new_obj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream__new_obj)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    {
	virConnectPtr	con;
	unsigned int	flags;
	virStreamPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::_new_obj() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6249 "Virt.xs"
      if (!(RETVAL = virStreamNew(con, flags)))
          _croak_error();
#line 13652 "Virt.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), "Sys::Virt::Stream", (void*)RETVAL );
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Stream_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_send)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "st, data, nbytes");
    {
	virStreamPtr	st;
	SV *	data = ST(1)
;
	size_t	nbytes = (size_t)SvUV(ST(2))
;
#line 6261 "Virt.xs"
      const char *rawdata;
      STRLEN len;
#line 13675 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::send() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6264 "Virt.xs"
      if (SvOK(data)) {
	  rawdata = SvPV(data, len);
          if (nbytes > len)
              nbytes = len;
      } else {
          rawdata = "";
          nbytes = 0;
      }

      if ((RETVAL = virStreamSend(st, rawdata, nbytes)) < 0 &&
          RETVAL != -2)
          _croak_error();
#line 13699 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Stream_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_recv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "st, data, nbytes");
    {
	virStreamPtr	st;
	SV *	data = ST(1)
;
	size_t	nbytes = (size_t)SvUV(ST(2))
;
#line 6286 "Virt.xs"
      char *rawdata;
#line 13720 "Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::recv() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6288 "Virt.xs"
      Newx(rawdata, nbytes, char);
      if ((RETVAL = virStreamRecv(st, rawdata, nbytes)) < 0 &&
          RETVAL != -2) {
          Safefree(rawdata);
          _croak_error();
      }
      if (RETVAL > 0) {
          sv_setpvn(data, rawdata, RETVAL);
      }
      Safefree(rawdata);
#line 13742 "Virt.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Stream_send_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_send_all)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "stref, handler");
    {
	SV *	stref = ST(0)
;
	SV *	handler = ST(1)
;
#line 6307 "Virt.xs"
      AV *opaque;
      virStreamPtr st;
#line 13763 "Virt.c"
#line 6310 "Virt.xs"
      st = (virStreamPtr)SvIV((SV*)SvRV(stref));

      opaque = newAV();
      SvREFCNT_inc(handler);
      SvREFCNT_inc(stref);
      av_push(opaque, stref);
      av_push(opaque, handler);

      if (virStreamSendAll(st, _stream_send_all_source, opaque) < 0)
          _croak_error();

      SvREFCNT_dec(opaque);
#line 13777 "Virt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__Virt__Stream_recv_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_recv_all)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "stref, handler");
    {
	SV *	stref = ST(0)
;
	SV *	handler = ST(1)
;
#line 6329 "Virt.xs"
      AV *opaque;
      virStreamPtr st;
#line 13797 "Virt.c"
#line 6332 "Virt.xs"
      st = (virStreamPtr)SvIV((SV*)SvRV(stref));

      opaque = newAV();
      SvREFCNT_inc(handler);
      SvREFCNT_inc(stref);
      av_push(opaque, stref);
      av_push(opaque, handler);

      if (virStreamRecvAll(st, _stream_recv_all_sink, opaque) < 0)
          _croak_error();

      SvREFCNT_dec(opaque);
#line 13811 "Virt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__Virt__Stream_add_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_add_callback)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "stref, events, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	stref = ST(0)
;
	int	events = (int)SvIV(ST(1))
;
	SV*	cb = ST(2)
;
#line 6352 "Virt.xs"
      AV *opaque;
      virStreamPtr st;
#line 13835 "Virt.c"
#line 6355 "Virt.xs"
      st = (virStreamPtr)SvIV((SV*)SvRV(stref));

      opaque = newAV();
      SvREFCNT_inc(cb);
      SvREFCNT_inc(stref);
      av_push(opaque, stref);
      av_push(opaque, cb);
      if (virStreamEventAddCallback(st, events, _stream_event_callback, opaque, _stream_event_free) < 0)
          _croak_error();
#line 13846 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_update_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_update_callback)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "st, events");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;
	int	events = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::update_callback() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6371 "Virt.xs"
      if (virStreamEventUpdateCallback(st, events) < 0)
          _croak_error();
#line 13876 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_remove_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_remove_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::remove_callback() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6379 "Virt.xs"
      if (virStreamEventRemoveCallback(st) < 0)
          _croak_error();
#line 13904 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_finish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::finish() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6387 "Virt.xs"
      if (virStreamFinish(st) < 0)
          _croak_error();
#line 13932 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_abort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_abort)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::abort() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6395 "Virt.xs"
      if (virStreamAbort(st) < 0)
          _croak_error();
#line 13960 "Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "st_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	st_rv = ST(0)
;
#line 6403 "Virt.xs"
      virStreamPtr st;
#line 13980 "Virt.c"
#line 6405 "Virt.xs"
      st = (virStreamPtr)SvIV((SV*)SvRV(st_rv));
      if (st) {
	virStreamFree(st);
	sv_setiv((SV*)SvRV(st_rv), 0);
      }
#line 13987 "Virt.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Sys__Virt); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Sys__Virt)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        (void)newXSproto_portable("Sys::Virt::_open", XS_Sys__Virt__open, file, "$$");
        (void)newXSproto_portable("Sys::Virt::_open_auth", XS_Sys__Virt__open_auth, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::restore_domain", XS_Sys__Virt_restore_domain, file, "$$;$$");
        (void)newXSproto_portable("Sys::Virt::get_save_image_xml_description", XS_Sys__Virt_get_save_image_xml_description, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::define_save_image_xml", XS_Sys__Virt_define_save_image_xml, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::_get_library_version", XS_Sys__Virt__get_library_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::_get_conn_version", XS_Sys__Virt__get_conn_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::_get_conn_library_version", XS_Sys__Virt__get_conn_library_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_encrypted", XS_Sys__Virt_is_encrypted, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_secure", XS_Sys__Virt_is_secure, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_alive", XS_Sys__Virt_is_alive, file, "$");
        (void)newXSproto_portable("Sys::Virt::set_keep_alive", XS_Sys__Virt_set_keep_alive, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::get_type", XS_Sys__Virt_get_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_uri", XS_Sys__Virt_get_uri, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_sysinfo", XS_Sys__Virt_get_sysinfo, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::get_node_info", XS_Sys__Virt_get_node_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_security_model", XS_Sys__Virt_get_node_security_model, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_cpu_map", XS_Sys__Virt_get_node_cpu_map, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::get_node_free_memory", XS_Sys__Virt_get_node_free_memory, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_cells_free_memory", XS_Sys__Virt_get_node_cells_free_memory, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::get_node_cpu_stats", XS_Sys__Virt_get_node_cpu_stats, file, "$;$$");
        (void)newXSproto_portable("Sys::Virt::get_node_memory_stats", XS_Sys__Virt_get_node_memory_stats, file, "$;$$");
        (void)newXSproto_portable("Sys::Virt::get_node_memory_parameters", XS_Sys__Virt_get_node_memory_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::set_node_memory_parameters", XS_Sys__Virt_set_node_memory_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::node_suspend_for_duration", XS_Sys__Virt_node_suspend_for_duration, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::find_storage_pool_sources", XS_Sys__Virt_find_storage_pool_sources, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::get_capabilities", XS_Sys__Virt_get_capabilities, file, "$");
        (void)newXSproto_portable("Sys::Virt::compare_cpu", XS_Sys__Virt_compare_cpu, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::baseline_cpu", XS_Sys__Virt_baseline_cpu, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::get_max_vcpus", XS_Sys__Virt_get_max_vcpus, file, "$$");
        (void)newXSproto_portable("Sys::Virt::get_hostname", XS_Sys__Virt_get_hostname, file, "$");
        (void)newXSproto_portable("Sys::Virt::num_of_domains", XS_Sys__Virt_num_of_domains, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_domain_ids", XS_Sys__Virt_list_domain_ids, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_domains", XS_Sys__Virt_num_of_defined_domains, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_domain_names", XS_Sys__Virt_list_defined_domain_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::list_all_domains", XS_Sys__Virt_list_all_domains, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_interfaces", XS_Sys__Virt_list_all_interfaces, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_nwfilters", XS_Sys__Virt_list_all_nwfilters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_networks", XS_Sys__Virt_list_all_networks, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_node_devices", XS_Sys__Virt_list_all_node_devices, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_secrets", XS_Sys__Virt_list_all_secrets, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_storage_pools", XS_Sys__Virt_list_all_storage_pools, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::num_of_networks", XS_Sys__Virt_num_of_networks, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_network_names", XS_Sys__Virt_list_network_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_networks", XS_Sys__Virt_num_of_defined_networks, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_network_names", XS_Sys__Virt_list_defined_network_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_storage_pools", XS_Sys__Virt_num_of_storage_pools, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_storage_pool_names", XS_Sys__Virt_list_storage_pool_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_storage_pools", XS_Sys__Virt_num_of_defined_storage_pools, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_storage_pool_names", XS_Sys__Virt_list_defined_storage_pool_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_node_devices", XS_Sys__Virt_num_of_node_devices, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::list_node_device_names", XS_Sys__Virt_list_node_device_names, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::num_of_interfaces", XS_Sys__Virt_num_of_interfaces, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_interface_names", XS_Sys__Virt_list_interface_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_interfaces", XS_Sys__Virt_num_of_defined_interfaces, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_interface_names", XS_Sys__Virt_list_defined_interface_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_secrets", XS_Sys__Virt_num_of_secrets, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_secret_uuids", XS_Sys__Virt_list_secret_uuids, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_nwfilters", XS_Sys__Virt_num_of_nwfilters, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_nwfilter_names", XS_Sys__Virt_list_nwfilter_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::domain_xml_from_native", XS_Sys__Virt_domain_xml_from_native, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::domain_xml_to_native", XS_Sys__Virt_domain_xml_to_native, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::domain_event_register", XS_Sys__Virt_domain_event_register, file, "$$");
        (void)newXSproto_portable("Sys::Virt::domain_event_deregister", XS_Sys__Virt_domain_event_deregister, file, "$");
        (void)newXSproto_portable("Sys::Virt::domain_event_register_any", XS_Sys__Virt_domain_event_register_any, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::domain_event_deregister_any", XS_Sys__Virt_domain_event_deregister_any, file, "$$");
        (void)newXSproto_portable("Sys::Virt::register_close_callback", XS_Sys__Virt_register_close_callback, file, "$$");
        (void)newXSproto_portable("Sys::Virt::unregister_close_callback", XS_Sys__Virt_unregister_close_callback, file, "$");
        (void)newXSproto_portable("Sys::Virt::interface_change_begin", XS_Sys__Virt_interface_change_begin, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::interface_change_commit", XS_Sys__Virt_interface_change_commit, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::interface_change_rollback", XS_Sys__Virt_interface_change_rollback, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DESTROY", XS_Sys__Virt_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::_create", XS_Sys__Virt__Domain__create, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_create_with_files", XS_Sys__Virt__Domain__create_with_files, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_define_xml", XS_Sys__Virt__Domain__define_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_id", XS_Sys__Virt__Domain__lookup_by_id, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_name", XS_Sys__Virt__Domain__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_uuid", XS_Sys__Virt__Domain__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_uuid_string", XS_Sys__Virt__Domain__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_id", XS_Sys__Virt__Domain_get_id, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_uuid", XS_Sys__Virt__Domain_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_uuid_string", XS_Sys__Virt__Domain_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_name", XS_Sys__Virt__Domain_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_hostname", XS_Sys__Virt__Domain_get_hostname, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_metadata", XS_Sys__Virt__Domain_get_metadata, file, "$$;$$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_metadata", XS_Sys__Virt__Domain_set_metadata, file, "$$;$$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_active", XS_Sys__Virt__Domain_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_persistent", XS_Sys__Virt__Domain_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_updated", XS_Sys__Virt__Domain_is_updated, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::suspend", XS_Sys__Virt__Domain_suspend, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::resume", XS_Sys__Virt__Domain_resume, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::pm_wakeup", XS_Sys__Virt__Domain_pm_wakeup, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::save", XS_Sys__Virt__Domain_save, file, "$$;$$");
        (void)newXSproto_portable("Sys::Virt::Domain::managed_save", XS_Sys__Virt__Domain_managed_save, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::has_managed_save_image", XS_Sys__Virt__Domain_has_managed_save_image, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::managed_save_remove", XS_Sys__Virt__Domain_managed_save_remove, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::core_dump", XS_Sys__Virt__Domain_core_dump, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_info", XS_Sys__Virt__Domain_get_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_control_info", XS_Sys__Virt__Domain_get_control_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_state", XS_Sys__Virt__Domain_get_state, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_console", XS_Sys__Virt__Domain_open_console, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_channel", XS_Sys__Virt__Domain_open_channel, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_graphics", XS_Sys__Virt__Domain_open_graphics, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::screenshot", XS_Sys__Virt__Domain_screenshot, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_info", XS_Sys__Virt__Domain_get_block_info, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_job_info", XS_Sys__Virt__Domain_get_job_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_job_stats", XS_Sys__Virt__Domain_get_job_stats, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::abort_job", XS_Sys__Virt__Domain_abort_job, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::abort_block_job", XS_Sys__Virt__Domain_abort_block_job, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_job_info", XS_Sys__Virt__Domain_get_block_job_info, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_block_job_speed", XS_Sys__Virt__Domain_set_block_job_speed, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_pull", XS_Sys__Virt__Domain_block_pull, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_rebase", XS_Sys__Virt__Domain_block_rebase, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_commit", XS_Sys__Virt__Domain_block_commit, file, "$$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_disk_errors", XS_Sys__Virt__Domain_get_disk_errors, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_scheduler_parameters", XS_Sys__Virt__Domain_get_scheduler_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_scheduler_parameters", XS_Sys__Virt__Domain_set_scheduler_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_memory_parameters", XS_Sys__Virt__Domain_get_memory_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_memory_parameters", XS_Sys__Virt__Domain_set_memory_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_numa_parameters", XS_Sys__Virt__Domain_get_numa_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_numa_parameters", XS_Sys__Virt__Domain_set_numa_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_blkio_parameters", XS_Sys__Virt__Domain_get_blkio_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_blkio_parameters", XS_Sys__Virt__Domain_set_blkio_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_max_memory", XS_Sys__Virt__Domain_get_max_memory, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_max_memory", XS_Sys__Virt__Domain_set_max_memory, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_memory", XS_Sys__Virt__Domain_set_memory, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_memory_stats_period", XS_Sys__Virt__Domain_set_memory_stats_period, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_max_vcpus", XS_Sys__Virt__Domain_get_max_vcpus, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_vcpus", XS_Sys__Virt__Domain_set_vcpus, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_vcpus", XS_Sys__Virt__Domain_get_vcpus, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_autostart", XS_Sys__Virt__Domain_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_autostart", XS_Sys__Virt__Domain_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_scheduler_type", XS_Sys__Virt__Domain_get_scheduler_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_os_type", XS_Sys__Virt__Domain_get_os_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_xml_description", XS_Sys__Virt__Domain_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::shutdown", XS_Sys__Virt__Domain_shutdown, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::reboot", XS_Sys__Virt__Domain_reboot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pm_suspend_for_duration", XS_Sys__Virt__Domain_pm_suspend_for_duration, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::reset", XS_Sys__Virt__Domain_reset, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::inject_nmi", XS_Sys__Virt__Domain_inject_nmi, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::undefine", XS_Sys__Virt__Domain_undefine, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::create", XS_Sys__Virt__Domain_create, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::create_with_files", XS_Sys__Virt__Domain_create_with_files, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_migrate", XS_Sys__Virt__Domain__migrate, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_migrate_to_uri", XS_Sys__Virt__Domain__migrate_to_uri, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_set_max_downtime", XS_Sys__Virt__Domain_migrate_set_max_downtime, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_set_max_speed", XS_Sys__Virt__Domain_migrate_set_max_speed, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_get_max_speed", XS_Sys__Virt__Domain_migrate_get_max_speed, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_set_compression_cache", XS_Sys__Virt__Domain_migrate_set_compression_cache, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_get_compression_cache", XS_Sys__Virt__Domain_migrate_get_compression_cache, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::attach_device", XS_Sys__Virt__Domain_attach_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::detach_device", XS_Sys__Virt__Domain_detach_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::update_device", XS_Sys__Virt__Domain_update_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_iotune", XS_Sys__Virt__Domain_get_block_iotune, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_block_iotune", XS_Sys__Virt__Domain_set_block_iotune, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_interface_parameters", XS_Sys__Virt__Domain_get_interface_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_interface_parameters", XS_Sys__Virt__Domain_set_interface_parameters, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_stats", XS_Sys__Virt__Domain_block_stats, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::interface_stats", XS_Sys__Virt__Domain_interface_stats, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::memory_stats", XS_Sys__Virt__Domain_memory_stats, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::send_key", XS_Sys__Virt__Domain_send_key, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_resize", XS_Sys__Virt__Domain_block_resize, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_peek", XS_Sys__Virt__Domain_block_peek, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::memory_peek", XS_Sys__Virt__Domain_memory_peek, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_security_label", XS_Sys__Virt__Domain_get_security_label, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_security_label_list", XS_Sys__Virt__Domain_get_security_label_list, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_cpu_stats", XS_Sys__Virt__Domain_get_cpu_stats, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_vcpu_info", XS_Sys__Virt__Domain_get_vcpu_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pin_vcpu", XS_Sys__Virt__Domain_pin_vcpu, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pin_emulator", XS_Sys__Virt__Domain_pin_emulator, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_emulator_pin_info", XS_Sys__Virt__Domain_get_emulator_pin_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::num_of_snapshots", XS_Sys__Virt__Domain_num_of_snapshots, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::list_snapshot_names", XS_Sys__Virt__Domain_list_snapshot_names, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::list_all_snapshots", XS_Sys__Virt__Domain_list_all_snapshots, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::has_current_snapshot", XS_Sys__Virt__Domain_has_current_snapshot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::current_snapshot", XS_Sys__Virt__Domain_current_snapshot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::fs_trim", XS_Sys__Virt__Domain_fs_trim, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::send_process_signal", XS_Sys__Virt__Domain_send_process_signal, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::destroy", XS_Sys__Virt__Domain_destroy, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::DESTROY", XS_Sys__Virt__Domain_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::_create_xml", XS_Sys__Virt__Network__create_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_define_xml", XS_Sys__Virt__Network__define_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_name", XS_Sys__Virt__Network__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_uuid", XS_Sys__Virt__Network__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_uuid_string", XS_Sys__Virt__Network__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::get_uuid", XS_Sys__Virt__Network_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_uuid_string", XS_Sys__Virt__Network_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_name", XS_Sys__Virt__Network_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::is_active", XS_Sys__Virt__Network_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::is_persistent", XS_Sys__Virt__Network_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_bridge_name", XS_Sys__Virt__Network_get_bridge_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_xml_description", XS_Sys__Virt__Network_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Network::undefine", XS_Sys__Virt__Network_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::create", XS_Sys__Virt__Network_create, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::update", XS_Sys__Virt__Network_update, file, "$$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Network::set_autostart", XS_Sys__Virt__Network_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::get_autostart", XS_Sys__Virt__Network_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::destroy", XS_Sys__Virt__Network_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::DESTROY", XS_Sys__Virt__Network_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_create_xml", XS_Sys__Virt__StoragePool__create_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_define_xml", XS_Sys__Virt__StoragePool__define_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_name", XS_Sys__Virt__StoragePool__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_uuid", XS_Sys__Virt__StoragePool__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_uuid_string", XS_Sys__Virt__StoragePool__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_volume", XS_Sys__Virt__StoragePool__lookup_by_volume, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_uuid", XS_Sys__Virt__StoragePool_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_uuid_string", XS_Sys__Virt__StoragePool_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_name", XS_Sys__Virt__StoragePool_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::is_active", XS_Sys__Virt__StoragePool_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::is_persistent", XS_Sys__Virt__StoragePool_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_xml_description", XS_Sys__Virt__StoragePool_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::undefine", XS_Sys__Virt__StoragePool_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::create", XS_Sys__Virt__StoragePool_create, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::refresh", XS_Sys__Virt__StoragePool_refresh, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::build", XS_Sys__Virt__StoragePool_build, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::delete", XS_Sys__Virt__StoragePool_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::set_autostart", XS_Sys__Virt__StoragePool_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_autostart", XS_Sys__Virt__StoragePool_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_info", XS_Sys__Virt__StoragePool_get_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::destroy", XS_Sys__Virt__StoragePool_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::num_of_storage_volumes", XS_Sys__Virt__StoragePool_num_of_storage_volumes, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::list_storage_vol_names", XS_Sys__Virt__StoragePool_list_storage_vol_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::list_all_volumes", XS_Sys__Virt__StoragePool_list_all_volumes, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::DESTROY", XS_Sys__Virt__StoragePool_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_create_xml", XS_Sys__Virt__StorageVol__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_create_xml_from", XS_Sys__Virt__StorageVol__create_xml_from, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_name", XS_Sys__Virt__StorageVol__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_key", XS_Sys__Virt__StorageVol__lookup_by_key, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_path", XS_Sys__Virt__StorageVol__lookup_by_path, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_name", XS_Sys__Virt__StorageVol_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_key", XS_Sys__Virt__StorageVol_get_key, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_path", XS_Sys__Virt__StorageVol_get_path, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::resize", XS_Sys__Virt__StorageVol_resize, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_xml_description", XS_Sys__Virt__StorageVol_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::delete", XS_Sys__Virt__StorageVol_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::wipe", XS_Sys__Virt__StorageVol_wipe, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::wipe_pattern", XS_Sys__Virt__StorageVol_wipe_pattern, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_info", XS_Sys__Virt__StorageVol_get_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::download", XS_Sys__Virt__StorageVol_download, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::upload", XS_Sys__Virt__StorageVol_upload, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::DESTROY", XS_Sys__Virt__StorageVol_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_create_xml", XS_Sys__Virt__NodeDevice__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_lookup_by_name", XS_Sys__Virt__NodeDevice__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_lookup_scsihost_by_wwn", XS_Sys__Virt__NodeDevice__lookup_scsihost_by_wwn, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_name", XS_Sys__Virt__NodeDevice_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_parent", XS_Sys__Virt__NodeDevice_get_parent, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_xml_description", XS_Sys__Virt__NodeDevice_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::dettach", XS_Sys__Virt__NodeDevice_dettach, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::reattach", XS_Sys__Virt__NodeDevice_reattach, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::reset", XS_Sys__Virt__NodeDevice_reset, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::list_capabilities", XS_Sys__Virt__NodeDevice_list_capabilities, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::destroy", XS_Sys__Virt__NodeDevice_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::DESTROY", XS_Sys__Virt__NodeDevice_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::_define_xml", XS_Sys__Virt__Interface__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::_lookup_by_name", XS_Sys__Virt__Interface__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Interface::_lookup_by_mac", XS_Sys__Virt__Interface__lookup_by_mac, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_mac", XS_Sys__Virt__Interface_get_mac, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_name", XS_Sys__Virt__Interface_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::is_active", XS_Sys__Virt__Interface_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_xml_description", XS_Sys__Virt__Interface_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::undefine", XS_Sys__Virt__Interface_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::create", XS_Sys__Virt__Interface_create, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::destroy", XS_Sys__Virt__Interface_destroy, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::DESTROY", XS_Sys__Virt__Interface_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::_define_xml", XS_Sys__Virt__Secret__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_usage", XS_Sys__Virt__Secret__lookup_by_usage, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_uuid", XS_Sys__Virt__Secret__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_uuid_string", XS_Sys__Virt__Secret__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_uuid", XS_Sys__Virt__Secret_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_uuid_string", XS_Sys__Virt__Secret_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_usage_id", XS_Sys__Virt__Secret_get_usage_id, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_usage_type", XS_Sys__Virt__Secret_get_usage_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_xml_description", XS_Sys__Virt__Secret_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::undefine", XS_Sys__Virt__Secret_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::set_value", XS_Sys__Virt__Secret_set_value, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_value", XS_Sys__Virt__Secret_get_value, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::DESTROY", XS_Sys__Virt__Secret_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_define_xml", XS_Sys__Virt__NWFilter__define_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_name", XS_Sys__Virt__NWFilter__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_uuid", XS_Sys__Virt__NWFilter__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_uuid_string", XS_Sys__Virt__NWFilter__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_uuid", XS_Sys__Virt__NWFilter_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_uuid_string", XS_Sys__Virt__NWFilter_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_name", XS_Sys__Virt__NWFilter_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_xml_description", XS_Sys__Virt__NWFilter_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::undefine", XS_Sys__Virt__NWFilter_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::DESTROY", XS_Sys__Virt__NWFilter_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::_create_xml", XS_Sys__Virt__DomainSnapshot__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::_lookup_by_name", XS_Sys__Virt__DomainSnapshot__lookup_by_name, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_name", XS_Sys__Virt__DomainSnapshot_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_xml_description", XS_Sys__Virt__DomainSnapshot_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::revert_to", XS_Sys__Virt__DomainSnapshot_revert_to, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::delete", XS_Sys__Virt__DomainSnapshot_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_parent", XS_Sys__Virt__DomainSnapshot_get_parent, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::num_of_child_snapshots", XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::is_current", XS_Sys__Virt__DomainSnapshot_is_current, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::has_metadata", XS_Sys__Virt__DomainSnapshot_has_metadata, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::list_child_snapshot_names", XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::list_all_children", XS_Sys__Virt__DomainSnapshot_list_all_children, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::DESTROY", XS_Sys__Virt__DomainSnapshot_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::_register_impl", XS_Sys__Virt__Event__register_impl, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::register_default", XS_Sys__Virt__Event_register_default, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::run_default", XS_Sys__Virt__Event_run_default, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::add_handle", XS_Sys__Virt__Event_add_handle, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Event::update_handle", XS_Sys__Virt__Event_update_handle, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::remove_handle", XS_Sys__Virt__Event_remove_handle, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::add_timeout", XS_Sys__Virt__Event_add_timeout, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::update_timeout", XS_Sys__Virt__Event_update_timeout, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::remove_timeout", XS_Sys__Virt__Event_remove_timeout, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::_run_handle_callback_helper", XS_Sys__Virt__Event__run_handle_callback_helper, file, "$$$$$");
        (void)newXSproto_portable("Sys::Virt::Event::_run_timeout_callback_helper", XS_Sys__Virt__Event__run_timeout_callback_helper, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Event::_free_callback_opaque_helper", XS_Sys__Virt__Event__free_callback_opaque_helper, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::_new_obj", XS_Sys__Virt__Stream__new_obj, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Stream::send", XS_Sys__Virt__Stream_send, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::recv", XS_Sys__Virt__Stream_recv, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::send_all", XS_Sys__Virt__Stream_send_all, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::recv_all", XS_Sys__Virt__Stream_recv_all, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::add_callback", XS_Sys__Virt__Stream_add_callback, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::update_callback", XS_Sys__Virt__Stream_update_callback, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::remove_callback", XS_Sys__Virt__Stream_remove_callback, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::finish", XS_Sys__Virt__Stream_finish, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::abort", XS_Sys__Virt__Stream_abort, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::DESTROY", XS_Sys__Virt__Stream_DESTROY, file, "$");

    /* Initialisation Section */

#line 6419 "Virt.xs"
    {
      HV *stash;

      virSetErrorFunc(NULL, ignoreVirErrorFunc);
      virInitialize();

      stash = gv_stashpv( "Sys::Virt", TRUE );

      REGISTER_CONSTANT(VIR_CONNECT_RO, CONNECT_RO);
      REGISTER_CONSTANT(VIR_CONNECT_NO_ALIASES, CONNECT_NO_ALIASES);

      REGISTER_CONSTANT(VIR_CRED_USERNAME, CRED_USERNAME);
      REGISTER_CONSTANT(VIR_CRED_AUTHNAME, CRED_AUTHNAME);
      REGISTER_CONSTANT(VIR_CRED_LANGUAGE, CRED_LANGUAGE);
      REGISTER_CONSTANT(VIR_CRED_CNONCE, CRED_CNONCE);
      REGISTER_CONSTANT(VIR_CRED_PASSPHRASE, CRED_PASSPHRASE);
      REGISTER_CONSTANT(VIR_CRED_ECHOPROMPT, CRED_ECHOPROMPT);
      REGISTER_CONSTANT(VIR_CRED_NOECHOPROMPT, CRED_NOECHOPROMPT);
      REGISTER_CONSTANT(VIR_CRED_REALM, CRED_REALM);
      REGISTER_CONSTANT(VIR_CRED_EXTERNAL, CRED_EXTERNAL);


      /* Don't bother with VIR_CPU_COMPARE_ERROR since we die in that case */
      REGISTER_CONSTANT(VIR_CPU_COMPARE_INCOMPATIBLE, CPU_COMPARE_INCOMPATIBLE);
      REGISTER_CONSTANT(VIR_CPU_COMPARE_IDENTICAL, CPU_COMPARE_IDENTICAL);
      REGISTER_CONSTANT(VIR_CPU_COMPARE_SUPERSET, CPU_COMPARE_SUPERSET);


      REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_MEM, NODE_SUSPEND_TARGET_MEM);
      REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_DISK, NODE_SUSPEND_TARGET_DISK);
      REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_HYBRID, NODE_SUSPEND_TARGET_HYBRID);


      REGISTER_CONSTANT(VIR_NODE_CPU_STATS_ALL_CPUS, NODE_CPU_STATS_ALL_CPUS);
      REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_IDLE, NODE_CPU_STATS_IDLE);
      REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_IOWAIT, NODE_CPU_STATS_IOWAIT);
      REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_KERNEL, NODE_CPU_STATS_KERNEL);
      REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_USER, NODE_CPU_STATS_USER);
      REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_UTILIZATION, NODE_CPU_STATS_UTILIZATION);

      REGISTER_CONSTANT(VIR_NODE_MEMORY_STATS_ALL_CELLS, NODE_MEMORY_STATS_ALL_CELLS);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_STATS_BUFFERS, NODE_MEMORY_STATS_BUFFERS);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_STATS_CACHED, NODE_MEMORY_STATS_CACHED);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_STATS_FREE, NODE_MEMORY_STATS_FREE);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_STATS_TOTAL, NODE_MEMORY_STATS_TOTAL);

      REGISTER_CONSTANT(VIR_CONNECT_CLOSE_REASON_CLIENT, CLOSE_REASON_CLIENT);
      REGISTER_CONSTANT(VIR_CONNECT_CLOSE_REASON_EOF, CLOSE_REASON_EOF);
      REGISTER_CONSTANT(VIR_CONNECT_CLOSE_REASON_ERROR, CLOSE_REASON_ERROR);
      REGISTER_CONSTANT(VIR_CONNECT_CLOSE_REASON_KEEPALIVE, CLOSE_REASON_KEEPALIVE);

      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_TO_SCAN, NODE_MEMORY_SHARED_PAGES_TO_SCAN);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_SLEEP_MILLISECS, NODE_MEMORY_SHARED_SLEEP_MILLISECS);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_SHARED, NODE_MEMORY_SHARED_PAGES_SHARED);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_SHARING, NODE_MEMORY_SHARED_PAGES_SHARING);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_UNSHARED, NODE_MEMORY_SHARED_PAGES_UNSHARED);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_VOLATILE, NODE_MEMORY_SHARED_PAGES_VOLATILE);
      REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_FULL_SCANS, NODE_MEMORY_SHARED_FULL_SCANS);


      stash = gv_stashpv( "Sys::Virt::Event", TRUE );

      REGISTER_CONSTANT(VIR_EVENT_HANDLE_READABLE, HANDLE_READABLE);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_WRITABLE, HANDLE_WRITABLE);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_ERROR, HANDLE_ERROR);
      REGISTER_CONSTANT(VIR_EVENT_HANDLE_HANGUP, HANDLE_HANGUP);


      stash = gv_stashpv( "Sys::Virt::Domain", TRUE );
      REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE, STATE_NOSTATE);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED, STATE_BLOCKED);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED, STATE_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN, STATE_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF, STATE_SHUTOFF);
      REGISTER_CONSTANT(VIR_DOMAIN_CRASHED, STATE_CRASHED);
      REGISTER_CONSTANT(VIR_DOMAIN_PMSUSPENDED, STATE_PMSUSPENDED);

      REGISTER_CONSTANT(VIR_DUMP_CRASH, DUMP_CRASH);
      REGISTER_CONSTANT(VIR_DUMP_LIVE, DUMP_LIVE);
      REGISTER_CONSTANT(VIR_DUMP_BYPASS_CACHE, DUMP_BYPASS_CACHE);
      REGISTER_CONSTANT(VIR_DUMP_RESET, DUMP_RESET);
      REGISTER_CONSTANT(VIR_DUMP_MEMORY_ONLY, DUMP_MEMORY_ONLY);

      REGISTER_CONSTANT(VIR_DOMAIN_SAVE_BYPASS_CACHE, SAVE_BYPASS_CACHE);
      REGISTER_CONSTANT(VIR_DOMAIN_SAVE_RUNNING, SAVE_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_SAVE_PAUSED, SAVE_PAUSED);

      REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_MANAGED_SAVE, UNDEFINE_MANAGED_SAVE);
      REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_SNAPSHOTS_METADATA, UNDEFINE_SNAPSHOTS_METADATA);

      REGISTER_CONSTANT(VIR_DOMAIN_START_PAUSED, START_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_START_AUTODESTROY, START_AUTODESTROY);
      REGISTER_CONSTANT(VIR_DOMAIN_START_BYPASS_CACHE, START_BYPASS_CACHE);
      REGISTER_CONSTANT(VIR_DOMAIN_START_FORCE_BOOT, START_FORCE_BOOT);

      REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE_UNKNOWN, STATE_NOSTATE_UNKNOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_UNKNOWN, STATE_RUNNING_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_BOOTED, STATE_RUNNING_BOOTED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_MIGRATED, STATE_RUNNING_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_RESTORED, STATE_RUNNING_RESTORED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_FROM_SNAPSHOT, STATE_RUNNING_FROM_SNAPSHOT);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_UNPAUSED, STATE_RUNNING_UNPAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_MIGRATION_CANCELED, STATE_RUNNING_MIGRATION_CANCELED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_SAVE_CANCELED, STATE_RUNNING_SAVE_CANCELED);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_WAKEUP, STATE_RUNNING_WAKEUP);
      REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_CRASHED, STATE_RUNNING_CRASHED);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED_UNKNOWN, STATE_BLOCKED_UNKNOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_UNKNOWN, STATE_PAUSED_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_USER, STATE_PAUSED_USER);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_MIGRATION, STATE_PAUSED_MIGRATION);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_SAVE, STATE_PAUSED_SAVE);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_DUMP, STATE_PAUSED_DUMP);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_IOERROR, STATE_PAUSED_IOERROR);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_WATCHDOG, STATE_PAUSED_WATCHDOG);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_FROM_SNAPSHOT, STATE_PAUSED_FROM_SNAPSHOT);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_SHUTTING_DOWN, STATE_PAUSED_SHUTTING_DOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_SNAPSHOT, STATE_PAUSED_SNAPSHOT);
      REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_CRASHED, STATE_PAUSED_CRASHED);

      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_UNKNOWN, STATE_SHUTDOWN_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_USER, STATE_SHUTDOWN_USER);

      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_UNKNOWN, STATE_SHUTOFF_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_SHUTDOWN, STATE_SHUTOFF_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_DESTROYED, STATE_SHUTOFF_DESTROYED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_CRASHED, STATE_SHUTOFF_CRASHED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_MIGRATED, STATE_SHUTOFF_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_SAVED, STATE_SHUTOFF_SAVED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_FAILED, STATE_SHUTOFF_FAILED);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_FROM_SNAPSHOT, STATE_SHUTOFF_FROM_SNAPSHOT);

      REGISTER_CONSTANT(VIR_DOMAIN_CRASHED_UNKNOWN, STATE_CRASHED_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_CRASHED_PANICKED, STATE_CRASHED_PANICKED);

      REGISTER_CONSTANT(VIR_DOMAIN_PMSUSPENDED_UNKNOWN, STATE_PMSUSPENDED_UNKNOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_PMSUSPENDED_DISK_UNKNOWN, STATE_PMSUSPENDED_DISK_UNKNOWN);

      REGISTER_CONSTANT(VIR_DOMAIN_OPEN_GRAPHICS_SKIPAUTH, OPEN_GRAPHICS_SKIPAUTH);

      REGISTER_CONSTANT(VIR_DOMAIN_CONSOLE_FORCE, OPEN_CONSOLE_FORCE);
      REGISTER_CONSTANT(VIR_DOMAIN_CONSOLE_SAFE, OPEN_CONSOLE_SAFE);

      REGISTER_CONSTANT(VIR_DOMAIN_CHANNEL_FORCE, OPEN_CHANNEL_FORCE);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_EMULATOR_PERIOD, SCHEDULER_EMULATOR_PERIOD);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_EMULATOR_QUOTA, SCHEDULER_EMULATOR_QUOTA);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_CPU_STATS_CPUTIME, CPU_STATS_CPUTIME);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_CPU_STATS_SYSTEMTIME, CPU_STATS_SYSTEMTIME);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_CPU_STATS_USERTIME, CPU_STATS_USERTIME);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_CPU_STATS_VCPUTIME, CPU_STATS_VCPUTIME);


      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_ERRS, BLOCK_STATS_ERRS);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_FLUSH_REQ, BLOCK_STATS_FLUSH_REQ);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_FLUSH_TOTAL_TIMES, BLOCK_STATS_FLUSH_TOTAL_TIMES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_READ_BYTES, BLOCK_STATS_READ_BYTES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_READ_REQ, BLOCK_STATS_READ_REQ);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_READ_TOTAL_TIMES, BLOCK_STATS_READ_TOTAL_TIMES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_WRITE_BYTES, BLOCK_STATS_WRITE_BYTES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_WRITE_REQ, BLOCK_STATS_WRITE_REQ);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_WRITE_TOTAL_TIMES, BLOCK_STATS_WRITE_TOTAL_TIMES);

      REGISTER_CONSTANT(VIR_MIGRATE_LIVE, MIGRATE_LIVE);
      REGISTER_CONSTANT(VIR_MIGRATE_PEER2PEER, MIGRATE_PEER2PEER);
      REGISTER_CONSTANT(VIR_MIGRATE_TUNNELLED, MIGRATE_TUNNELLED);
      REGISTER_CONSTANT(VIR_MIGRATE_PERSIST_DEST, MIGRATE_PERSIST_DEST);
      REGISTER_CONSTANT(VIR_MIGRATE_UNDEFINE_SOURCE, MIGRATE_UNDEFINE_SOURCE);
      REGISTER_CONSTANT(VIR_MIGRATE_PAUSED, MIGRATE_PAUSED);
      REGISTER_CONSTANT(VIR_MIGRATE_NON_SHARED_DISK, MIGRATE_NON_SHARED_DISK);
      REGISTER_CONSTANT(VIR_MIGRATE_NON_SHARED_INC, MIGRATE_NON_SHARED_INC);
      REGISTER_CONSTANT(VIR_MIGRATE_CHANGE_PROTECTION, MIGRATE_CHANGE_PROTECTION);
      REGISTER_CONSTANT(VIR_MIGRATE_UNSAFE, MIGRATE_UNSAFE);
      REGISTER_CONSTANT(VIR_MIGRATE_OFFLINE, MIGRATE_OFFLINE);
      REGISTER_CONSTANT(VIR_MIGRATE_COMPRESSED, MIGRATE_COMPRESSED);
      REGISTER_CONSTANT(VIR_MIGRATE_ABORT_ON_ERROR, MIGRATE_ABORT_ON_ERROR);

      REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_BANDWIDTH, MIGRATE_PARAM_BANDWIDTH);
      REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_DEST_NAME, MIGRATE_PARAM_DEST_NAME);
      REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_DEST_XML, MIGRATE_PARAM_DEST_XML);
      REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_GRAPHICS_URI, MIGRATE_PARAM_GRAPHICS_URI);
      REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_URI, MIGRATE_PARAM_URI);

      REGISTER_CONSTANT(VIR_DOMAIN_XML_SECURE, XML_SECURE);
      REGISTER_CONSTANT(VIR_DOMAIN_XML_INACTIVE, XML_INACTIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_XML_UPDATE_CPU, XML_UPDATE_CPU);
      REGISTER_CONSTANT(VIR_DOMAIN_XML_MIGRATABLE, XML_MIGRATABLE);


      REGISTER_CONSTANT(VIR_MEMORY_VIRTUAL, MEMORY_VIRTUAL);
      REGISTER_CONSTANT(VIR_MEMORY_PHYSICAL, MEMORY_PHYSICAL);


      REGISTER_CONSTANT(VIR_VCPU_OFFLINE, VCPU_OFFLINE);
      REGISTER_CONSTANT(VIR_VCPU_RUNNING, VCPU_RUNNING);
      REGISTER_CONSTANT(VIR_VCPU_BLOCKED, VCPU_BLOCKED);


      REGISTER_CONSTANT(VIR_KEYCODE_SET_LINUX, KEYCODE_SET_LINUX);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_XT, KEYCODE_SET_XT);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET1, KEYCODE_SET_ATSET1);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET2, KEYCODE_SET_ATSET2);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET3, KEYCODE_SET_ATSET3);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_OSX, KEYCODE_SET_OSX);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_XT_KBD, KEYCODE_SET_XT_KBD);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_USB, KEYCODE_SET_USB);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_WIN32, KEYCODE_SET_WIN32);
      REGISTER_CONSTANT(VIR_KEYCODE_SET_RFB, KEYCODE_SET_RFB);


      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED, EVENT_DEFINED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED, EVENT_UNDEFINED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED, EVENT_STARTED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED, EVENT_SUSPENDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED, EVENT_RESUMED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED, EVENT_STOPPED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SHUTDOWN, EVENT_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_PMSUSPENDED, EVENT_PMSUSPENDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_PMSUSPENDED_DISK, EVENT_PMSUSPENDED_DISK);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_CRASHED, EVENT_CRASHED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_ADDED, EVENT_DEFINED_ADDED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_UPDATED, EVENT_DEFINED_UPDATED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED_REMOVED, EVENT_UNDEFINED_REMOVED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_BOOTED, EVENT_STARTED_BOOTED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_MIGRATED, EVENT_STARTED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_RESTORED, EVENT_STARTED_RESTORED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_FROM_SNAPSHOT, EVENT_STARTED_FROM_SNAPSHOT);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_WAKEUP, EVENT_STARTED_WAKEUP);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_CRASHED_PANICKED, EVENT_CRASHED_PANICKED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_PAUSED, EVENT_SUSPENDED_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_MIGRATED, EVENT_SUSPENDED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_IOERROR, EVENT_SUSPENDED_IOERROR);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_WATCHDOG, EVENT_SUSPENDED_WATCHDOG);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_RESTORED, EVENT_SUSPENDED_RESTORED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_FROM_SNAPSHOT, EVENT_SUSPENDED_FROM_SNAPSHOT);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_API_ERROR, EVENT_SUSPENDED_API_ERROR);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_UNPAUSED, EVENT_RESUMED_UNPAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_MIGRATED, EVENT_RESUMED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_FROM_SNAPSHOT, EVENT_RESUMED_FROM_SNAPSHOT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SHUTDOWN, EVENT_STOPPED_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_DESTROYED, EVENT_STOPPED_DESTROYED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_CRASHED, EVENT_STOPPED_CRASHED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_MIGRATED, EVENT_STOPPED_MIGRATED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SAVED, EVENT_STOPPED_SAVED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_FAILED, EVENT_STOPPED_FAILED);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_FROM_SNAPSHOT, EVENT_STOPPED_FROM_SNAPSHOT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SHUTDOWN_FINISHED, EVENT_SHUTDOWN_FINISHED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_PMSUSPENDED_MEMORY, EVENT_PMSUSPENDED_MEMORY);


      REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_OK, CONTROL_OK);
      REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_JOB, CONTROL_JOB);
      REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_OCCUPIED, CONTROL_OCCUPIED);
      REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_ERROR, CONTROL_ERROR);


      REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_CURRENT, DEVICE_MODIFY_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_LIVE, DEVICE_MODIFY_LIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_CONFIG, DEVICE_MODIFY_CONFIG);
      REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_FORCE, DEVICE_MODIFY_FORCE);


      REGISTER_CONSTANT(VIR_DOMAIN_MEM_CURRENT, MEM_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_MEM_LIVE, MEM_LIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_MEM_CONFIG, MEM_CONFIG);
      REGISTER_CONSTANT(VIR_DOMAIN_MEM_MAXIMUM, MEM_MAXIMUM);


      REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_CURRENT, AFFECT_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_LIVE, AFFECT_LIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_CONFIG, AFFECT_CONFIG);


      REGISTER_CONSTANT(VIR_DOMAIN_JOB_NONE, JOB_NONE);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_BOUNDED, JOB_BOUNDED);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_UNBOUNDED, JOB_UNBOUNDED);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_COMPLETED, JOB_COMPLETED);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_FAILED, JOB_FAILED);
      REGISTER_CONSTANT(VIR_DOMAIN_JOB_CANCELLED, JOB_CANCELLED);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_BYTES, JOB_COMPRESSION_BYTES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_CACHE, JOB_COMPRESSION_CACHE);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_CACHE_MISSES, JOB_COMPRESSION_CACHE_MISSES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_OVERFLOW, JOB_COMPRESSION_OVERFLOW);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_PAGES, JOB_COMPRESSION_PAGES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DATA_PROCESSED, JOB_DATA_PROCESSED);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DATA_REMAINING, JOB_DATA_REMAINING);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DATA_TOTAL, JOB_DATA_TOTAL);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_PROCESSED, JOB_DISK_PROCESSED);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_REMAINING, JOB_DISK_REMAINING);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_TOTAL, JOB_DISK_TOTAL);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DOWNTIME, JOB_DOWNTIME);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_CONSTANT, JOB_MEMORY_CONSTANT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_NORMAL, JOB_MEMORY_NORMAL);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_NORMAL_BYTES, JOB_MEMORY_NORMAL_BYTES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_PROCESSED, JOB_MEMORY_PROCESSED);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_REMAINING, JOB_MEMORY_REMAINING);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_TOTAL, JOB_MEMORY_TOTAL);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_TIME_ELAPSED, JOB_TIME_ELAPSED);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_TIME_REMAINING, JOB_TIME_REMAINING);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_UNKNOWN, BLOCK_JOB_TYPE_UNKNOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_PULL, BLOCK_JOB_TYPE_PULL);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_COPY, BLOCK_JOB_TYPE_COPY);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_COMMIT, BLOCK_JOB_TYPE_COMMIT);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_COMPLETED, BLOCK_JOB_COMPLETED);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_FAILED, BLOCK_JOB_FAILED);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_CANCELED, BLOCK_JOB_CANCELED);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_READY, BLOCK_JOB_READY);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COMMIT_DELETE, BLOCK_COMMIT_DELETE);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COMMIT_SHALLOW, BLOCK_COMMIT_SHALLOW);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_LIFECYCLE, EVENT_ID_LIFECYCLE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_REBOOT, EVENT_ID_REBOOT);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_RTC_CHANGE, EVENT_ID_RTC_CHANGE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_WATCHDOG, EVENT_ID_WATCHDOG);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_IO_ERROR, EVENT_ID_IO_ERROR);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_GRAPHICS, EVENT_ID_GRAPHICS);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_IO_ERROR_REASON, EVENT_ID_IO_ERROR_REASON);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_CONTROL_ERROR, EVENT_ID_CONTROL_ERROR);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_BLOCK_JOB, EVENT_ID_BLOCK_JOB);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_DISK_CHANGE, EVENT_ID_DISK_CHANGE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_PMSUSPEND, EVENT_ID_PMSUSPEND);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_PMSUSPEND_DISK, EVENT_ID_PMSUSPEND_DISK);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_PMWAKEUP, EVENT_ID_PMWAKEUP);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_TRAY_CHANGE, EVENT_ID_TRAY_CHANGE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_BALLOON_CHANGE, EVENT_ID_BALLOON_CHANGE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED, EVENT_ID_DEVICE_REMOVED);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_NONE, EVENT_WATCHDOG_NONE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_PAUSE, EVENT_WATCHDOG_PAUSE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_RESET, EVENT_WATCHDOG_RESET);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_POWEROFF, EVENT_WATCHDOG_POWEROFF);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_SHUTDOWN, EVENT_WATCHDOG_SHUTDOWN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_DEBUG, EVENT_WATCHDOG_DEBUG);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_NONE, EVENT_IO_ERROR_NONE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_PAUSE, EVENT_IO_ERROR_PAUSE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_REPORT, EVENT_IO_ERROR_REPORT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_CONNECT, EVENT_GRAPHICS_CONNECT);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_INITIALIZE, EVENT_GRAPHICS_INITIALIZE);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_DISCONNECT, EVENT_GRAPHICS_DISCONNECT);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_IPV4, EVENT_GRAPHICS_ADDRESS_IPV4);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_IPV6, EVENT_GRAPHICS_ADDRESS_IPV6);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_UNIX, EVENT_GRAPHICS_ADDRESS_UNIX);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DISK_CHANGE_MISSING_ON_START, EVENT_DISK_CHANGE_MISSING_ON_START);

      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_TRAY_CHANGE_OPEN, EVENT_TRAY_CHANGE_OPEN);
      REGISTER_CONSTANT(VIR_DOMAIN_EVENT_TRAY_CHANGE_CLOSE, EVENT_TRAY_CHANGE_CLOSE);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_HARD_LIMIT, MEMORY_HARD_LIMIT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_SOFT_LIMIT, MEMORY_SOFT_LIMIT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_MIN_GUARANTEE, MEMORY_MIN_GUARANTEE);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_SWAP_HARD_LIMIT, MEMORY_SWAP_HARD_LIMIT);
      REGISTER_CONSTANT_ULL(VIR_DOMAIN_MEMORY_PARAM_UNLIMITED, MEMORY_PARAM_UNLIMITED);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_WEIGHT, BLKIO_WEIGHT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_DEVICE_WEIGHT, BLKIO_DEVICE_WEIGHT);

      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_CPU_SHARES, SCHEDULER_CPU_SHARES);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_VCPU_PERIOD, SCHEDULER_VCPU_PERIOD);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_VCPU_QUOTA, SCHEDULER_VCPU_QUOTA);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_WEIGHT, SCHEDULER_WEIGHT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_CAP, SCHEDULER_CAP);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_LIMIT, SCHEDULER_LIMIT);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_RESERVATION, SCHEDULER_RESERVATION);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_SHARES, SCHEDULER_SHARES);


      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_SWAP_IN, MEMORY_STAT_SWAP_IN);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_SWAP_OUT, MEMORY_STAT_SWAP_OUT);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_MAJOR_FAULT, MEMORY_STAT_MAJOR_FAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_MINOR_FAULT, MEMORY_STAT_MINOR_FAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_UNUSED, MEMORY_STAT_UNUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_AVAILABLE, MEMORY_STAT_AVAILABLE);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_ACTUAL_BALLOON, MEMORY_STAT_ACTUAL_BALLOON);
      REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_RSS, MEMORY_STAT_RSS);


      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_BYTES_SEC, BLOCK_IOTUNE_TOTAL_BYTES_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_BYTES_SEC, BLOCK_IOTUNE_READ_BYTES_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_BYTES_SEC, BLOCK_IOTUNE_WRITE_BYTES_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_IOPS_SEC, BLOCK_IOTUNE_TOTAL_IOPS_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_IOPS_SEC, BLOCK_IOTUNE_READ_IOPS_SEC);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_IOPS_SEC, BLOCK_IOTUNE_WRITE_IOPS_SEC);


      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_RESIZE_BYTES, BLOCK_RESIZE_BYTES);


      REGISTER_CONSTANT_STR(VIR_DOMAIN_NUMA_NODESET, NUMA_NODESET);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_NUMA_MODE, NUMA_MODE);

      REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_STRICT, NUMATUNE_MEM_STRICT);
      REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_PREFERRED, NUMATUNE_MEM_PREFERRED);
      REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_INTERLEAVE, NUMATUNE_MEM_INTERLEAVE);


      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_AVERAGE, BANDWIDTH_IN_AVERAGE);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_PEAK, BANDWIDTH_IN_PEAK);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_BURST, BANDWIDTH_IN_BURST);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_AVERAGE, BANDWIDTH_OUT_AVERAGE);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_PEAK, BANDWIDTH_OUT_PEAK);
      REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_BURST, BANDWIDTH_OUT_BURST);


      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_CURRENT, VCPU_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_LIVE, VCPU_LIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_CONFIG, VCPU_CONFIG);
      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_MAXIMUM, VCPU_MAXIMUM);
      REGISTER_CONSTANT(VIR_DOMAIN_VCPU_GUEST, VCPU_GUEST);


      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_DEFAULT, SHUTDOWN_DEFAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_ACPI_POWER_BTN, SHUTDOWN_ACPI_POWER_BTN);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_GUEST_AGENT, SHUTDOWN_GUEST_AGENT);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_INITCTL, SHUTDOWN_INITCTL);
      REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_SIGNAL, SHUTDOWN_SIGNAL);


      REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_DEFAULT, REBOOT_DEFAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_ACPI_POWER_BTN, REBOOT_ACPI_POWER_BTN);
      REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_GUEST_AGENT, REBOOT_GUEST_AGENT);
      REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_INITCTL, REBOOT_INITCTL);
      REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_SIGNAL, REBOOT_SIGNAL);

      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_NOP, PROCESS_SIGNAL_NOP);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_HUP, PROCESS_SIGNAL_HUP);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_INT, PROCESS_SIGNAL_INT);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_QUIT, PROCESS_SIGNAL_QUIT);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_ILL, PROCESS_SIGNAL_ILL);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TRAP, PROCESS_SIGNAL_TRAP);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_ABRT, PROCESS_SIGNAL_ABRT);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_BUS, PROCESS_SIGNAL_BUS);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_FPE, PROCESS_SIGNAL_FPE);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_KILL, PROCESS_SIGNAL_KILL);

      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_USR1, PROCESS_SIGNAL_USR1);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_SEGV, PROCESS_SIGNAL_SEGV);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_USR2, PROCESS_SIGNAL_USR2);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_PIPE, PROCESS_SIGNAL_PIPE);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_ALRM, PROCESS_SIGNAL_ALRM);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TERM, PROCESS_SIGNAL_TERM);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_STKFLT, PROCESS_SIGNAL_STKFLT);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_CHLD, PROCESS_SIGNAL_CHLD);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_CONT, PROCESS_SIGNAL_CONT);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_STOP, PROCESS_SIGNAL_STOP);

      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TSTP, PROCESS_SIGNAL_TSTP);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TTIN, PROCESS_SIGNAL_TTIN);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TTOU, PROCESS_SIGNAL_TTOU);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_URG, PROCESS_SIGNAL_URG);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_XCPU, PROCESS_SIGNAL_XCPU);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_XFSZ, PROCESS_SIGNAL_XFSZ);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_VTALRM, PROCESS_SIGNAL_VTALRM);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_PROF, PROCESS_SIGNAL_PROF);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_WINCH, PROCESS_SIGNAL_WINCH);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_POLL, PROCESS_SIGNAL_POLL);

      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_PWR, PROCESS_SIGNAL_PWR);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_SYS, PROCESS_SIGNAL_SYS);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT0, PROCESS_SIGNAL_RT0);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT1, PROCESS_SIGNAL_RT1);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT2, PROCESS_SIGNAL_RT2);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT3, PROCESS_SIGNAL_RT3);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT4, PROCESS_SIGNAL_RT4);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT5, PROCESS_SIGNAL_RT5);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT6, PROCESS_SIGNAL_RT6);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT7, PROCESS_SIGNAL_RT7);

      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT8, PROCESS_SIGNAL_RT8);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT9, PROCESS_SIGNAL_RT9);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT10, PROCESS_SIGNAL_RT10);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT11, PROCESS_SIGNAL_RT11);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT12, PROCESS_SIGNAL_RT12);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT13, PROCESS_SIGNAL_RT13);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT14, PROCESS_SIGNAL_RT14);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT15, PROCESS_SIGNAL_RT15);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT16, PROCESS_SIGNAL_RT16);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT17, PROCESS_SIGNAL_RT17);

      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT18, PROCESS_SIGNAL_RT18);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT19, PROCESS_SIGNAL_RT19);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT20, PROCESS_SIGNAL_RT20);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT21, PROCESS_SIGNAL_RT21);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT22, PROCESS_SIGNAL_RT22);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT23, PROCESS_SIGNAL_RT23);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT24, PROCESS_SIGNAL_RT24);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT25, PROCESS_SIGNAL_RT25);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT26, PROCESS_SIGNAL_RT26);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT27, PROCESS_SIGNAL_RT27);

      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT28, PROCESS_SIGNAL_RT28);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT29, PROCESS_SIGNAL_RT29);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT30, PROCESS_SIGNAL_RT30);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT31, PROCESS_SIGNAL_RT31);
      REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT32, PROCESS_SIGNAL_RT32);

      REGISTER_CONSTANT(VIR_DOMAIN_DESTROY_DEFAULT, DESTROY_DEFAULT);
      REGISTER_CONSTANT(VIR_DOMAIN_DESTROY_GRACEFUL, DESTROY_GRACEFUL);


      REGISTER_CONSTANT(VIR_DOMAIN_METADATA_DESCRIPTION, METADATA_DESCRIPTION);
      REGISTER_CONSTANT(VIR_DOMAIN_METADATA_TITLE, METADATA_TITLE);
      REGISTER_CONSTANT(VIR_DOMAIN_METADATA_ELEMENT, METADATA_ELEMENT);

      REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_NONE, DISK_ERROR_NONE);
      REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_NO_SPACE, DISK_ERROR_NO_SPACE);
      REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_UNSPEC, DISK_ERROR_UNSPEC);


      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_ABORT_ASYNC, BLOCK_JOB_ABORT_ASYNC);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_ABORT_PIVOT, BLOCK_JOB_ABORT_PIVOT);

      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_SHALLOW, BLOCK_REBASE_SHALLOW);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_REUSE_EXT, BLOCK_REBASE_REUSE_EXT);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_COPY_RAW, BLOCK_REBASE_COPY_RAW);
      REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_COPY, BLOCK_REBASE_COPY);

      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_ACTIVE, LIST_ACTIVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_AUTOSTART, LIST_AUTOSTART);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_HAS_SNAPSHOT, LIST_HAS_SNAPSHOT);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_INACTIVE, LIST_INACTIVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_MANAGEDSAVE, LIST_MANAGEDSAVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_NO_AUTOSTART, LIST_NO_AUTOSTART);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_NO_MANAGEDSAVE, LIST_NO_MANAGEDSAVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_NO_SNAPSHOT, LIST_NO_SNAPSHOT);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_OTHER, LIST_OTHER);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_PAUSED, LIST_PAUSED);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_PERSISTENT, LIST_PERSISTENT);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_RUNNING, LIST_RUNNING);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_SHUTOFF, LIST_SHUTOFF);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_TRANSIENT, LIST_TRANSIENT);

      REGISTER_CONSTANT(VIR_DOMAIN_SEND_KEY_MAX_KEYS, SEND_KEY_MAX_KEYS);


      stash = gv_stashpv( "Sys::Virt::DomainSnapshot", TRUE );
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_CHILDREN, DELETE_CHILDREN);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_METADATA_ONLY, DELETE_METADATA_ONLY);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_CHILDREN_ONLY, DELETE_CHILDREN_ONLY);

      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_REDEFINE, CREATE_REDEFINE);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_CURRENT, CREATE_CURRENT);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_NO_METADATA, CREATE_NO_METADATA);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_HALT, CREATE_HALT);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_DISK_ONLY, CREATE_DISK_ONLY);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_REUSE_EXT, CREATE_REUSE_EXT);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_QUIESCE, CREATE_QUIESCE);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_ATOMIC, CREATE_ATOMIC);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_LIVE, CREATE_LIVE);

      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_ROOTS, LIST_ROOTS);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_DESCENDANTS, LIST_DESCENDANTS);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_METADATA, LIST_METADATA);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_LEAVES, LIST_LEAVES);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_NO_LEAVES, LIST_NO_LEAVES);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_NO_METADATA, LIST_NO_METADATA);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_ACTIVE, LIST_ACTIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_INACTIVE, LIST_INACTIVE);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_EXTERNAL, LIST_EXTERNAL);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_INTERNAL, LIST_INTERNAL);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_DISK_ONLY, LIST_DISK_ONLY);


      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_RUNNING, REVERT_RUNNING);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_PAUSED, REVERT_PAUSED);
      REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_FORCE, REVERT_FORCE);

      stash = gv_stashpv( "Sys::Virt::StoragePool", TRUE );
      REGISTER_CONSTANT(VIR_STORAGE_POOL_INACTIVE, STATE_INACTIVE);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILDING, STATE_BUILDING);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_RUNNING, STATE_RUNNING);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_DEGRADED, STATE_DEGRADED);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_INACCESSIBLE, STATE_INACCESSIBLE);

      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_NEW, BUILD_NEW);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_REPAIR, BUILD_REPAIR);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_RESIZE, BUILD_RESIZE);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_NO_OVERWRITE, BUILD_NO_OVERWRITE);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_OVERWRITE, BUILD_OVERWRITE);

      REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_NORMAL, DELETE_NORMAL);
      REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_ZEROED, DELETE_ZEROED);

      REGISTER_CONSTANT(VIR_STORAGE_XML_INACTIVE, XML_INACTIVE);


      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_INACTIVE, LIST_INACTIVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_ACTIVE, LIST_ACTIVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_PERSISTENT, LIST_PERSISTENT);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_TRANSIENT, LIST_TRANSIENT);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_AUTOSTART, LIST_AUTOSTART);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_NO_AUTOSTART, LIST_NO_AUTOSTART);

      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_DIR, LIST_DIR);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_FS, LIST_FS);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_NETFS, LIST_NETFS);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_LOGICAL, LIST_LOGICAL);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_DISK, LIST_DISK);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_ISCSI, LIST_ISCSI);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_SCSI, LIST_SCSI);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_MPATH, LIST_MPATH);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_RBD, LIST_RBD);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_SHEEPDOG, LIST_SHEEPDOG);

      stash = gv_stashpv( "Sys::Virt::Network", TRUE );
      REGISTER_CONSTANT(VIR_NETWORK_XML_INACTIVE, XML_INACTIVE);

      REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_NONE, UPDATE_COMMAND_NONE);
      REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_MODIFY, UPDATE_COMMAND_MODIFY);
      REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_DELETE, UPDATE_COMMAND_DELETE);
      REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_ADD_LAST, UPDATE_COMMAND_ADD_LAST);
      REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_ADD_FIRST, UPDATE_COMMAND_ADD_FIRST);

      REGISTER_CONSTANT(VIR_NETWORK_SECTION_NONE, SECTION_NONE);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_BRIDGE, SECTION_BRIDGE);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_DOMAIN, SECTION_DOMAIN);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_IP, SECTION_IP);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_IP_DHCP_HOST, SECTION_IP_DHCP_HOST);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_IP_DHCP_RANGE, SECTION_IP_DHCP_RANGE);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_FORWARD, SECTION_FORWARD);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_FORWARD_INTERFACE, SECTION_FORWARD_INTERFACE);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_FORWARD_PF, SECTION_FORWARD_PF);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_PORTGROUP, SECTION_PORTGROUP);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_DNS_HOST, SECTION_DNS_HOST);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_DNS_TXT, SECTION_DNS_TXT);
      REGISTER_CONSTANT(VIR_NETWORK_SECTION_DNS_SRV, SECTION_DNS_SRV);

      REGISTER_CONSTANT(VIR_NETWORK_UPDATE_AFFECT_CURRENT, UPDATE_AFFECT_CURRENT);
      REGISTER_CONSTANT(VIR_NETWORK_UPDATE_AFFECT_LIVE, UPDATE_AFFECT_LIVE);
      REGISTER_CONSTANT(VIR_NETWORK_UPDATE_AFFECT_CONFIG, UPDATE_AFFECT_CONFIG);

      REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_ACTIVE, LIST_ACTIVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_INACTIVE, LIST_INACTIVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_AUTOSTART, LIST_AUTOSTART);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_NO_AUTOSTART, LIST_NO_AUTOSTART);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_PERSISTENT, LIST_PERSISTENT);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_TRANSIENT, LIST_TRANSIENT);

      stash = gv_stashpv( "Sys::Virt::Interface", TRUE );
      REGISTER_CONSTANT(VIR_INTERFACE_XML_INACTIVE, XML_INACTIVE);

      REGISTER_CONSTANT(VIR_CONNECT_LIST_INTERFACES_ACTIVE, LIST_ACTIVE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_INTERFACES_INACTIVE, LIST_INACTIVE);


      stash = gv_stashpv( "Sys::Virt::NodeDevice", TRUE );

      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SYSTEM, LIST_CAP_SYSTEM);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_PCI_DEV, LIST_CAP_PCI_DEV);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_USB_DEV, LIST_CAP_USB_DEV);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_USB_INTERFACE, LIST_CAP_USB_INTERFACE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_NET, LIST_CAP_NET);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SCSI_HOST, LIST_CAP_SCSI_HOST);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SCSI_TARGET, LIST_CAP_SCSI_TARGET);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SCSI, LIST_CAP_SCSI);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_STORAGE, LIST_CAP_STORAGE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_FC_HOST, LIST_CAP_FC_HOST);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_VPORTS, LIST_CAP_VPORTS);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SCSI_GENERIC, LIST_CAP_SCSI_GENERIC);


      stash = gv_stashpv( "Sys::Virt::StorageVol", TRUE );
      REGISTER_CONSTANT(VIR_STORAGE_VOL_FILE, TYPE_FILE);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_BLOCK, TYPE_BLOCK);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_DIR, TYPE_DIR);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_NETWORK, TYPE_NETWORK);

      REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_NORMAL, DELETE_NORMAL);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_ZEROED, DELETE_ZEROED);


      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_ZERO, WIPE_ALG_ZERO);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_NNSA, WIPE_ALG_NNSA);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_DOD, WIPE_ALG_DOD);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_BSI, WIPE_ALG_BSI);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_GUTMANN, WIPE_ALG_GUTMANN);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_SCHNEIER, WIPE_ALG_SCHNEIER);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_PFITZNER7, WIPE_ALG_PFITZNER7);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_PFITZNER33, WIPE_ALG_PFITZNER33);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_RANDOM, WIPE_ALG_RANDOM);

      REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_ALLOCATE, RESIZE_ALLOCATE);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_DELTA, RESIZE_DELTA);
      REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_SHRINK, RESIZE_SHRINK);

      REGISTER_CONSTANT(VIR_STORAGE_VOL_CREATE_PREALLOC_METADATA, CREATE_PREALLOC_METADATA);


      stash = gv_stashpv( "Sys::Virt::Secret", TRUE );
      REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_NONE, USAGE_TYPE_NONE);
      REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_VOLUME, USAGE_TYPE_VOLUME);
      REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_CEPH, USAGE_TYPE_CEPH);
      REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_ISCSI, USAGE_TYPE_ISCSI);


      REGISTER_CONSTANT(VIR_CONNECT_LIST_SECRETS_EPHEMERAL, LIST_EPHEMERAL);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_SECRETS_NO_EPHEMERAL, LIST_NO_EPHEMERAL);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_SECRETS_PRIVATE, LIST_PRIVATE);
      REGISTER_CONSTANT(VIR_CONNECT_LIST_SECRETS_NO_PRIVATE, LIST_NO_PRIVATE);


      stash = gv_stashpv( "Sys::Virt::Stream", TRUE );
      REGISTER_CONSTANT(VIR_STREAM_NONBLOCK, NONBLOCK);

      REGISTER_CONSTANT(VIR_STREAM_EVENT_READABLE, EVENT_READABLE);
      REGISTER_CONSTANT(VIR_STREAM_EVENT_WRITABLE, EVENT_WRITABLE);
      REGISTER_CONSTANT(VIR_STREAM_EVENT_ERROR, EVENT_ERROR);
      REGISTER_CONSTANT(VIR_STREAM_EVENT_HANGUP, EVENT_HANGUP);



      stash = gv_stashpv( "Sys::Virt::Error", TRUE );

      REGISTER_CONSTANT(VIR_ERR_NONE, LEVEL_NONE);
      REGISTER_CONSTANT(VIR_ERR_WARNING, LEVEL_WARNING);
      REGISTER_CONSTANT(VIR_ERR_ERROR, LEVEL_ERROR);

      REGISTER_CONSTANT(VIR_FROM_NONE, FROM_NONE);
      REGISTER_CONSTANT(VIR_FROM_XEN, FROM_XEN);
      REGISTER_CONSTANT(VIR_FROM_XEND, FROM_XEND);
      REGISTER_CONSTANT(VIR_FROM_XENSTORE, FROM_XENSTORE);
      REGISTER_CONSTANT(VIR_FROM_SEXPR, FROM_SEXPR);
      REGISTER_CONSTANT(VIR_FROM_XML, FROM_XML);
      REGISTER_CONSTANT(VIR_FROM_DOM, FROM_DOM);
      REGISTER_CONSTANT(VIR_FROM_RPC, FROM_RPC);
      REGISTER_CONSTANT(VIR_FROM_PROXY, FROM_PROXY);
      REGISTER_CONSTANT(VIR_FROM_CONF, FROM_CONF);
      REGISTER_CONSTANT(VIR_FROM_QEMU, FROM_QEMU);
      REGISTER_CONSTANT(VIR_FROM_NET, FROM_NET);
      REGISTER_CONSTANT(VIR_FROM_TEST, FROM_TEST);
      REGISTER_CONSTANT(VIR_FROM_REMOTE, FROM_REMOTE);
      REGISTER_CONSTANT(VIR_FROM_OPENVZ, FROM_OPENVZ);
      REGISTER_CONSTANT(VIR_FROM_XENXM, FROM_XENXM);
      REGISTER_CONSTANT(VIR_FROM_STATS_LINUX, FROM_STATS_LINUX);
      REGISTER_CONSTANT(VIR_FROM_LXC, FROM_LXC);
      REGISTER_CONSTANT(VIR_FROM_STORAGE, FROM_STORAGE);
      REGISTER_CONSTANT(VIR_FROM_NETWORK, FROM_NETWORK);
      REGISTER_CONSTANT(VIR_FROM_DOMAIN, FROM_DOMAIN);
      REGISTER_CONSTANT(VIR_FROM_UML, FROM_UML);
      REGISTER_CONSTANT(VIR_FROM_NODEDEV, FROM_NODEDEV);
      REGISTER_CONSTANT(VIR_FROM_XEN_INOTIFY, FROM_XEN_INOTIFY);
      REGISTER_CONSTANT(VIR_FROM_SECURITY, FROM_SECURITY);
      REGISTER_CONSTANT(VIR_FROM_VBOX, FROM_VBOX);
      REGISTER_CONSTANT(VIR_FROM_INTERFACE, FROM_INTERFACE);
      REGISTER_CONSTANT(VIR_FROM_ONE, FROM_ONE);
      REGISTER_CONSTANT(VIR_FROM_ESX, FROM_ESX);
      REGISTER_CONSTANT(VIR_FROM_PHYP, FROM_PHYP);
      REGISTER_CONSTANT(VIR_FROM_SECRET, FROM_SECRET);
      REGISTER_CONSTANT(VIR_FROM_CPU, FROM_CPU);
      REGISTER_CONSTANT(VIR_FROM_XENAPI, FROM_XENAPI);
      REGISTER_CONSTANT(VIR_FROM_NWFILTER, FROM_NWFILTER);
      REGISTER_CONSTANT(VIR_FROM_HOOK, FROM_HOOK);
      REGISTER_CONSTANT(VIR_FROM_DOMAIN_SNAPSHOT, FROM_DOMAIN_SNAPSHOT);
      REGISTER_CONSTANT(VIR_FROM_AUDIT, FROM_AUDIT);
      REGISTER_CONSTANT(VIR_FROM_SYSINFO, FROM_SYSINFO);
      REGISTER_CONSTANT(VIR_FROM_STREAMS, FROM_STREAMS);
      REGISTER_CONSTANT(VIR_FROM_VMWARE, FROM_VMWARE);
      REGISTER_CONSTANT(VIR_FROM_EVENT, FROM_EVENT);
      REGISTER_CONSTANT(VIR_FROM_LIBXL, FROM_LIBXL);
      REGISTER_CONSTANT(VIR_FROM_LOCKING, FROM_LOCKING);
      REGISTER_CONSTANT(VIR_FROM_HYPERV, FROM_HYPERV);
      REGISTER_CONSTANT(VIR_FROM_CAPABILITIES, FROM_CAPABILITIES);
      REGISTER_CONSTANT(VIR_FROM_AUTH, FROM_AUTH);
      REGISTER_CONSTANT(VIR_FROM_URI, FROM_URI);
      REGISTER_CONSTANT(VIR_FROM_DBUS, FROM_DBUS);
      REGISTER_CONSTANT(VIR_FROM_DEVICE, FROM_DEVICE);
      REGISTER_CONSTANT(VIR_FROM_PARALLELS, FROM_PARALLELS);
      REGISTER_CONSTANT(VIR_FROM_SSH, FROM_SSH);
      REGISTER_CONSTANT(VIR_FROM_LOCKSPACE, FROM_LOCKSPACE);
      REGISTER_CONSTANT(VIR_FROM_INITCTL, FROM_INITCTL);
      REGISTER_CONSTANT(VIR_FROM_CGROUP, FROM_CGROUP);
      REGISTER_CONSTANT(VIR_FROM_IDENTITY, FROM_IDENTITY);
      REGISTER_CONSTANT(VIR_FROM_ACCESS, FROM_ACCESS);
      REGISTER_CONSTANT(VIR_FROM_SYSTEMD, FROM_SYSTEMD);


      REGISTER_CONSTANT(VIR_ERR_OK, ERR_OK);
      REGISTER_CONSTANT(VIR_ERR_INTERNAL_ERROR, ERR_INTERNAL_ERROR);
      REGISTER_CONSTANT(VIR_ERR_NO_MEMORY, ERR_NO_MEMORY);
      REGISTER_CONSTANT(VIR_ERR_NO_SUPPORT, ERR_NO_SUPPORT);
      REGISTER_CONSTANT(VIR_ERR_UNKNOWN_HOST, ERR_UNKNOWN_HOST);
      REGISTER_CONSTANT(VIR_ERR_NO_CONNECT, ERR_NO_CONNECT);
      REGISTER_CONSTANT(VIR_ERR_INVALID_CONN, ERR_INVALID_CONN);
      REGISTER_CONSTANT(VIR_ERR_INVALID_DOMAIN, ERR_INVALID_DOMAIN);
      REGISTER_CONSTANT(VIR_ERR_INVALID_ARG, ERR_INVALID_ARG);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_FAILED, ERR_OPERATION_FAILED);
      REGISTER_CONSTANT(VIR_ERR_GET_FAILED, ERR_GET_FAILED);
      REGISTER_CONSTANT(VIR_ERR_POST_FAILED, ERR_POST_FAILED);
      REGISTER_CONSTANT(VIR_ERR_HTTP_ERROR, ERR_HTTP_ERROR);
      REGISTER_CONSTANT(VIR_ERR_SEXPR_SERIAL, ERR_SEXPR_SERIAL);
      REGISTER_CONSTANT(VIR_ERR_NO_XEN, ERR_NO_XEN);
      REGISTER_CONSTANT(VIR_ERR_XEN_CALL, ERR_XEN_CALL);
      REGISTER_CONSTANT(VIR_ERR_OS_TYPE, ERR_OS_TYPE);
      REGISTER_CONSTANT(VIR_ERR_NO_KERNEL, ERR_NO_KERNEL);
      REGISTER_CONSTANT(VIR_ERR_NO_ROOT, ERR_NO_ROOT);
      REGISTER_CONSTANT(VIR_ERR_NO_SOURCE, ERR_NO_SOURCE);
      REGISTER_CONSTANT(VIR_ERR_NO_TARGET, ERR_NO_TARGET);
      REGISTER_CONSTANT(VIR_ERR_NO_NAME, ERR_NO_NAME);
      REGISTER_CONSTANT(VIR_ERR_NO_OS, ERR_NO_OS);
      REGISTER_CONSTANT(VIR_ERR_NO_DEVICE, ERR_NO_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_XENSTORE, ERR_NO_XENSTORE);
      REGISTER_CONSTANT(VIR_ERR_DRIVER_FULL, ERR_DRIVER_FULL);
      REGISTER_CONSTANT(VIR_ERR_CALL_FAILED, ERR_CALL_FAILED);
      REGISTER_CONSTANT(VIR_ERR_XML_ERROR, ERR_XML_ERROR);
      REGISTER_CONSTANT(VIR_ERR_DOM_EXIST, ERR_DOM_EXIST);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_DENIED, ERR_OPERATIONED_DENIED);
      REGISTER_CONSTANT(VIR_ERR_OPEN_FAILED, ERR_OPEN_FAILED);
      REGISTER_CONSTANT(VIR_ERR_READ_FAILED, ERR_READ_FAILED);
      REGISTER_CONSTANT(VIR_ERR_PARSE_FAILED, ERR_PARSE_FAILED);
      REGISTER_CONSTANT(VIR_ERR_CONF_SYNTAX, ERR_CONF_SYNTAX);
      REGISTER_CONSTANT(VIR_ERR_WRITE_FAILED, ERR_WRITE_FAILED);
      REGISTER_CONSTANT(VIR_ERR_XML_DETAIL, ERR_XML_DETAIL);
      REGISTER_CONSTANT(VIR_ERR_INVALID_NETWORK, ERR_INVALID_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_NETWORK_EXIST, ERR_NETWORK_EXIST);
      REGISTER_CONSTANT(VIR_ERR_SYSTEM_ERROR, ERR_SYSTEM_ERROR);
      REGISTER_CONSTANT(VIR_ERR_RPC, ERR_RPC);
      REGISTER_CONSTANT(VIR_ERR_GNUTLS_ERROR, ERR_GNUTLS_ERROR);
      REGISTER_CONSTANT(VIR_WAR_NO_NETWORK, WAR_NO_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN, ERR_NO_DOMAIN);
      REGISTER_CONSTANT(VIR_ERR_NO_NETWORK, ERR_NO_NETWORK);
      REGISTER_CONSTANT(VIR_ERR_INVALID_MAC, ERR_INVALID_MAC);
      REGISTER_CONSTANT(VIR_ERR_AUTH_FAILED, ERR_AUTH_FAILED);
      REGISTER_CONSTANT(VIR_ERR_INVALID_STORAGE_POOL, ERR_INVALID_STORAGE_POOL);
      REGISTER_CONSTANT(VIR_ERR_INVALID_STORAGE_VOL, ERR_INVALID_STORAGE_VOL);
      REGISTER_CONSTANT(VIR_WAR_NO_STORAGE, WAR_NO_STORAGE);
      REGISTER_CONSTANT(VIR_ERR_NO_STORAGE_POOL, ERR_NO_STORAGE_POOL);
      REGISTER_CONSTANT(VIR_ERR_NO_STORAGE_VOL, ERR_NO_STORAGE_VOL);
      REGISTER_CONSTANT(VIR_WAR_NO_NODE, WAR_NO_NODE);
      REGISTER_CONSTANT(VIR_ERR_INVALID_NODE_DEVICE, ERR_INVALID_NODE_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_NODE_DEVICE, ERR_NO_NODE_DEVICE);
      REGISTER_CONSTANT(VIR_ERR_NO_SECURITY_MODEL, ERR_NO_SECURITY_MODEL);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_INVALID, ERR_OPERATION_INVALID);
      REGISTER_CONSTANT(VIR_WAR_NO_INTERFACE, WAR_NO_INTERFACE);
      REGISTER_CONSTANT(VIR_ERR_NO_INTERFACE, ERR_NO_INTERFACE);
      REGISTER_CONSTANT(VIR_ERR_INVALID_INTERFACE, ERR_INVALID_INTERFACE);
      REGISTER_CONSTANT(VIR_ERR_MULTIPLE_INTERFACES, ERR_MULTIPLE_INTERFACES);
      REGISTER_CONSTANT(VIR_WAR_NO_NWFILTER, WAR_NO_NWFILTER);
      REGISTER_CONSTANT(VIR_ERR_INVALID_NWFILTER, ERR_INVALID_NWFILTER);
      REGISTER_CONSTANT(VIR_ERR_NO_NWFILTER, ERR_NO_NWFILTER);
      REGISTER_CONSTANT(VIR_ERR_BUILD_FIREWALL, ERR_BUILD_FIREWALL);
      REGISTER_CONSTANT(VIR_WAR_NO_SECRET, WAR_NO_SECRET);
      REGISTER_CONSTANT(VIR_ERR_INVALID_SECRET, ERR_INVALID_SECRET);
      REGISTER_CONSTANT(VIR_ERR_NO_SECRET, ERR_NO_SECRET);
      REGISTER_CONSTANT(VIR_ERR_CONFIG_UNSUPPORTED, ERR_CONFIG_UNSUPPORTED);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_TIMEOUT, ERR_OPERATION_TIMEOUT);
      REGISTER_CONSTANT(VIR_ERR_MIGRATE_PERSIST_FAILED, ERR_MIGRATE_PERSIST_FAILED);
      REGISTER_CONSTANT(VIR_ERR_HOOK_SCRIPT_FAILED, ERR_HOOK_SCRIPT_FAILED);
      REGISTER_CONSTANT(VIR_ERR_INVALID_DOMAIN_SNAPSHOT, ERR_INVALID_DOMAIN_SNAPSHOT);
      REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN_SNAPSHOT, ERR_NO_DOMAIN_SNAPSHOT);
      REGISTER_CONSTANT(VIR_ERR_INVALID_STREAM, ERR_INVALID_STREAM);
      REGISTER_CONSTANT(VIR_ERR_ARGUMENT_UNSUPPORTED, ERR_ARGUMENT_UNSUPPORTED);
      REGISTER_CONSTANT(VIR_ERR_STORAGE_PROBE_FAILED, ERR_STORAGE_PROBE_FAILED);
      REGISTER_CONSTANT(VIR_ERR_STORAGE_POOL_BUILT, ERR_STORAGE_POOL_BUILT);
      REGISTER_CONSTANT(VIR_ERR_SNAPSHOT_REVERT_RISKY, ERR_SNAPSHOT_REVERT_RISKY);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_ABORTED, ERR_OPERATION_ABORTED);
      REGISTER_CONSTANT(VIR_ERR_AUTH_CANCELLED, ERR_AUTH_CANCELLED);
      REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN_METADATA, ERR_NO_DOMAIN_METADATA);
      REGISTER_CONSTANT(VIR_ERR_MIGRATE_UNSAFE, ERR_MIGRATE_UNSAFE);
      REGISTER_CONSTANT(VIR_ERR_OVERFLOW, ERR_OVERFLOW);
      REGISTER_CONSTANT(VIR_ERR_BLOCK_COPY_ACTIVE, ERR_BLOCK_COPY_ACTIVE);
      REGISTER_CONSTANT(VIR_ERR_AGENT_UNRESPONSIVE, ERR_AGENT_UNRESPONSIVE);
      REGISTER_CONSTANT(VIR_ERR_OPERATION_UNSUPPORTED, ERR_OPERATION_UNSUPPORTED);
      REGISTER_CONSTANT(VIR_ERR_SSH, ERR_SSH);
      REGISTER_CONSTANT(VIR_ERR_RESOURCE_BUSY, ERR_RESOURCE_BUSY);
      REGISTER_CONSTANT(VIR_ERR_ACCESS_DENIED, ERR_ACCESS_DENIED);
      REGISTER_CONSTANT(VIR_ERR_DBUS_SERVICE, ERR_DBUS_SERVICE);
    }

#line 15229 "Virt.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

